#ifndef BRIDLE_CM_H_
#define BRIDLE_CM_H_


#include "AEEBridle.h"
#include "cm.h"

#define CM_MAJ_VER 3
#define CM_MIN_VER 50

#define MIN_CM_REV(maj,min) \
        (CM_MAJ_VER > maj || (CM_MAJ_VER == maj && CM_MIN_VER >= min))


enum {
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_mm_call_cmd_orig),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_mm_call_cmd_answer),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_mm_call_cmd_end),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_mm_call_cmd_sups),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_mm_call_cmd_privacy_pref),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_mm_call_cmd_get_call_info),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_mm_call_cmd_setup_res),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_mm_call_cmd_pdp_act_res),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_mm_call_cmd_pdp_modify),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_mm_call_cmd_rab_reestablish),
#ifdef FEATURE_PS_DORMANT_PWR_SAVE
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_mm_ss_cmd_ps_data_available),
#else
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_mm_call_cmd_ps_data_available),
#endif
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_nc_reg),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_ph_cmd_oprt_mode),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_ph_cmd_sys_sel_pref),
#if MIN_CM_REV(3,15)
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_ph_cmd_ddtm_pref),
#endif
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_ph_cmd_avoid_sys),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_ph_cmd_answer_voice),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_ph_cmd_nam_sel),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_ph_cmd_get_ph_info),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_ph_cmd_rssi_delta_threshold),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_ph_cmd_subscription_available),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_ph_cmd_subscription_not_available),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_ph_cmd_subscription_changed),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_ph_cmd_get_networks),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_ph_cmd_terminate_get_networks),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_ph_cmd_set_preferred_networks),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_ph_cmd_packet_state),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_ph_cmd_voc_activity),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_ph_cmd_wakeup_from_standby),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_ph_cmd_change_rtre_config),
#if MIN_CM_REV(3,100)
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_ph_cmd_aoc_reset_acm),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_ph_cmd_aoc_set_acmmax),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_ph_cmd_aoc_get_ccm),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_ph_cmd_aoc_get_acm),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_ph_cmd_aoc_get_acmmax),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_ph_cmd_aoc_get_puct),
#endif
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_ss_cmd_get_ss_info),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_mm_inband_cmd_burst_dtmf),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_mm_inband_cmd_start_cont_dtmf),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_mm_inband_cmd_stop_cont_dtmf),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_sms_cmd_mo_msg),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_sms_cmd_awi_ack),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_sms_cmd_bc_enable),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_pd_cmd_session_start),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_pd_cmd_session_end),
#ifdef FEATURE_GPSONE
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_pd_cmd_reva_mo_msg),
#endif
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_pd_reg),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_sups_cmd_register),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_sups_cmd_erase),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_sups_cmd_activate),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_sups_cmd_deactivate),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_sups_cmd_interrogate),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_sups_cmd_process_uss),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_sups_cmd_reg_password),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_sups_cmd_release),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_sups_cmd_get_password_res),
#ifdef FEATURE_MMGPS
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_sups_cmd_lcs_molr),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_sups_cmd_lcs_location_notification_res),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_sups_cmd_lcs_molr_completed),
#endif
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_sups_cmd_uss_notify_res),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_sups_cmd_uss_res),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_dbm_cmd_mo_msg),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_client_init),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_client_release),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_mm_client_call_reg),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_client_ph_reg),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_mm_client_ss_reg),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_mm_client_inband_reg),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_client_sms_reg),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_client_pd_reg),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_client_dbm_event_reg),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_client_dbm_class_reg),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_client_sups_reg),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_client_act),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_client_deact),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cmclient_get_client_type),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_change_m511_mode),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_change_m512_mode),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_change_m513_mode),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_m51_mode_reg),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_is_valid_mode_band_pref),
#if (defined(FEATURE_CDMA_800) || defined(FEATURE_CDMA_1900))
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_is_valid_mode_pref),
#endif
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_is_sys_mode_digital),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_get_pref_srv_type_for_packet_orig),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_get_curr_nam),
#ifdef FEATURE_HDR_HYBRID
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_get_cur_hybr_status),
#endif
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_num_init),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_num_fill),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_num_get),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_num_cmp),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_num_cmp_exact),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_num_copy),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_num_ep_msg_copy),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_num_ep_cli_copy),
#if (defined(FEATURE_CDMA_800) || defined(FEATURE_CDMA_1900))
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_num_attrib_copy),
#endif
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_num_validate),
#ifdef FEATURE_IS95B_EXT_DISP
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_ext_disp_itr_reset),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_ext_disp_itr_next),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_ext_disp_itr_more),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_ext_disp_itr_get),
#endif
#if MIN_CM_REV(3,100)
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_get_current_acq_sys_mode),
#if defined FEATURE_HDR_HYBRID && defined FEATURE_GPSONE
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_pd_cmd_fix_start),
BRIDLE_SUBSYS_HANDLER_IDX(cm,cm_pd_cmd_fix_end),
#endif
#endif
BRIDLE_cm_COUNT
};


extern uint32 BRIDLE_SUBSYS_NO(cm);

extern int bridle_cm_RegisterSubSystem(void *po);





//extern boolean cm_mm_call_cmd_orig(
//  cm_call_cmd_cb_f_type       cmd_cb_func,
//  void                        *data_block_ptr,
//  cm_client_id_type           client_id,
//  cm_call_type_e_type         call_type,
//  cm_srv_type_e_type          srv_type,
//  const cm_num_s_type         *calling_number,
//  const cm_num_s_type         *called_number,
//  const cm_orig_alpha_s_type  *alpha_buf,
//  cm_cdma_orig_params_s_type  *cdma_orig_params_ptr,
//  cm_gw_cs_orig_params_s_type *gw_cs_orig_params_ptr,
//  cm_gw_ps_orig_params_s_type *gw_ps_orig_params_ptr,
//  cm_call_id_type             *return_call_id_ptr
//)

BRIDLE_SUBSYS_12_RET(cm, boolean, cm_mm_call_cmd_orig,
   cm_call_cmd_cb_f_type*, BRIDLE_CHECK_NONE, 0, void*, BRIDLE_CHECK_NONE, 0,
   cm_client_id_type,BRIDLE_CHECK_NONE, 0, cm_call_type_e_type,BRIDLE_CHECK_NONE, 0,
   cm_srv_type_e_type ,BRIDLE_CHECK_NONE, 0, const cm_num_s_type*,BRIDLE_CHECK_READACCESS_NZ, sizeof(const cm_num_s_type),
   const cm_num_s_type*,BRIDLE_CHECK_READACCESS_NZ, sizeof(const cm_num_s_type), const cm_orig_alpha_s_type *,BRIDLE_CHECK_READACCESS_NZ, sizeof(const cm_orig_alpha_s_type),
   cm_cdma_orig_params_s_type  *,BRIDLE_CHECK_READACCESS_NZ, sizeof(cm_cdma_orig_params_s_type), cm_gw_cs_orig_params_s_type *,BRIDLE_CHECK_READACCESS_NZ, sizeof(cm_gw_cs_orig_params_s_type),
   cm_gw_ps_orig_params_s_type *,BRIDLE_CHECK_READACCESS_NZ, sizeof(cm_gw_ps_orig_params_s_type), cm_call_id_type             *,BRIDLE_CHECK_WRITEACCESS, sizeof(cm_call_id_type) )



//extern boolean cm_mm_call_cmd_answer(
//  cm_call_cmd_cb_f_type  cmd_cb_func,
//  void                   *data_block_ptr,
//  cm_client_id_type      client_id,
//  cm_call_id_type        call_id,
//  cm_ans_params_s_type   *ans_params_ptr
//)


BRIDLE_SUBSYS_5_RET(cm,boolean, cm_mm_call_cmd_answer,
  cm_call_cmd_cb_f_type*  ,BRIDLE_CHECK_NONE, 0,
  void*, BRIDLE_CHECK_NONE, 0,
  cm_client_id_type  ,BRIDLE_CHECK_NONE, 0,
  cm_call_id_type    ,BRIDLE_CHECK_NONE, 0,
  cm_ans_params_s_type*, BRIDLE_CHECK_READACCESS_NZ, sizeof(cm_ans_params_s_type))



//extern boolean cm_mm_call_cmd_end(
//  cm_call_cmd_cb_f_type  cmd_cb_func,
//  void                   *data_block_ptr,
//  cm_client_id_type      client_id,
//  uint8                  num_call_ids,
//  cm_end_params_s_type   *end_params_ptr
//)

BRIDLE_SUBSYS_5_RET(cm, boolean, cm_mm_call_cmd_end,
  cm_call_cmd_cb_f_type*  ,BRIDLE_CHECK_NONE, 0,
  void                   *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type      ,BRIDLE_CHECK_NONE, 0,
  uint8                  ,BRIDLE_CHECK_NONE, 0,
  cm_end_params_s_type   *, BRIDLE_CHECK_READACCESS_NZ, sizeof(cm_end_params_s_type))




//extern boolean cm_mm_call_cmd_sups(
//  cm_call_cmd_cb_f_type       cmd_cb_func,
//  void                        *data_block_ptr,
//  cm_client_id_type           client_id,
//  cm_call_sups_type_e_type    sups_type,
//  cm_call_sups_params_s_type  *sups_params_ptr
//)

BRIDLE_SUBSYS_5_RET(cm, boolean, cm_mm_call_cmd_sups,
  cm_call_cmd_cb_f_type* ,BRIDLE_CHECK_NONE, 0,
  void                        *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type           ,BRIDLE_CHECK_NONE, 0,
  cm_call_sups_type_e_type    ,BRIDLE_CHECK_NONE, 0,
  cm_call_sups_params_s_type  *,BRIDLE_CHECK_READACCESS_NZ, sizeof(cm_call_sups_params_s_type))

////////////////////////////////////////////////////////////////////////////////



//boolean cm_mm_call_cmd_privacy_pref(
//  cm_call_cmd_cb_f_type   cmd_cb_func,
//  void                    *data_block_ptr,
//  cm_client_id_type       client_id,
//  cm_call_id_type         call_id,
//  cm_privacy_pref_e_type  privacy_pref
//)

BRIDLE_SUBSYS_5_RET(cm, boolean, cm_mm_call_cmd_privacy_pref,
  cm_call_cmd_cb_f_type*   ,BRIDLE_CHECK_NONE, 0,
  void                    *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type       ,BRIDLE_CHECK_NONE, 0,
  cm_call_id_type         ,BRIDLE_CHECK_NONE, 0,
  cm_privacy_pref_e_type  ,BRIDLE_CHECK_NONE, 0
)


////////////////////////////////////////////////////////////////////////////////


//extern boolean cm_mm_call_cmd_get_call_info(
//  cm_call_cmd_cb_f_type  cmd_cb_func,
//  void                   *data_block_ptr,
//  cm_client_id_type      client_id,
//  cm_call_id_type        call_id
//)

BRIDLE_SUBSYS_4_RET(cm, boolean, cm_mm_call_cmd_get_call_info,
  cm_call_cmd_cb_f_type*  ,BRIDLE_CHECK_NONE, 0,
  void                   *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type      ,BRIDLE_CHECK_NONE, 0,
  cm_call_id_type        ,BRIDLE_CHECK_NONE, 0
)

////////////////////////////////////////////////////////////////////////////////

//extern boolean cm_mm_call_cmd_setup_res(
//  cm_call_cmd_cb_f_type         cmd_cb_func,
//  void                          *data_block_ptr,
//  cm_client_id_type             client_id,
//  cm_call_id_type               call_id,
//  cm_setup_res_params_s_type   *setup_params_ptr
//)

BRIDLE_SUBSYS_5_RET(cm, boolean, cm_mm_call_cmd_setup_res,
  cm_call_cmd_cb_f_type*        ,BRIDLE_CHECK_NONE, 0,
  void                          *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type             ,BRIDLE_CHECK_NONE, 0,
  cm_call_id_type              ,BRIDLE_CHECK_NONE, 0,
  cm_setup_res_params_s_type   *,BRIDLE_CHECK_READACCESS_NZ, sizeof(cm_setup_res_params_s_type)
)


////////////////////////////////////////////////////////////////////////////////

//extern boolean cm_mm_call_cmd_pdp_act_res(
//  cm_call_cmd_cb_f_type          cmd_cb_func,
//  void                           *data_block_ptr,
//  cm_client_id_type              client_id,
//  cm_call_id_type                call_id,
//  cm_pdp_act_res_params_s_type   *act_res_params_ptr
//)

BRIDLE_SUBSYS_5_RET(cm, boolean, cm_mm_call_cmd_pdp_act_res,
  cm_call_cmd_cb_f_type*          ,BRIDLE_CHECK_NONE, 0,
  void                           *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type              ,BRIDLE_CHECK_NONE, 0,
  cm_call_id_type                ,BRIDLE_CHECK_NONE, 0,
  cm_pdp_act_res_params_s_type   *,BRIDLE_CHECK_READACCESS_NZ, sizeof(cm_pdp_act_res_params_s_type)
)

////////////////////////////////////////////////////////////////////////////////

//extern boolean cm_mm_call_cmd_pdp_modify(
//  cm_call_cmd_cb_f_type         cmd_cb_func,
//  void                          *data_block_ptr,
//  cm_client_id_type             client_id,
//  cm_call_id_type               call_id,
//  cm_pdp_modify_params_s_type   *modify_params_ptr
//)

BRIDLE_SUBSYS_5_RET(cm, boolean, cm_mm_call_cmd_pdp_modify,
  cm_call_cmd_cb_f_type*         ,BRIDLE_CHECK_NONE, 0,
  void                          *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type             ,BRIDLE_CHECK_NONE, 0,
  cm_call_id_type               ,BRIDLE_CHECK_NONE, 0,
  cm_pdp_modify_params_s_type   *,BRIDLE_CHECK_READACCESS_NZ, sizeof(cm_pdp_modify_params_s_type)
)


////////////////////////////////////////////////////////////////////////////////

//extern boolean cm_mm_call_cmd_rab_reestablish(
//  cm_call_cmd_cb_f_type          cmd_cb_func,
//  void                           *data_block_ptr,
//  cm_client_id_type              client_id,
//  cm_call_id_type                call_id,
//  cm_rab_reestab_params_s_type   *reestab_params_ptr
//)
BRIDLE_SUBSYS_5_RET(cm, boolean, cm_mm_call_cmd_rab_reestablish,
  cm_call_cmd_cb_f_type*          ,BRIDLE_CHECK_NONE, 0,
  void                           *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type              ,BRIDLE_CHECK_NONE, 0,
  cm_call_id_type                ,BRIDLE_CHECK_NONE, 0,
  cm_rab_reestab_params_s_type   *,BRIDLE_CHECK_READACCESS_NZ, sizeof(cm_rab_reestab_params_s_type)
)

////////////////////////////////////////////////////////////////////////////////

//extern boolean cm_mm_call_cmd_ps_data_available(
//  cm_call_cmd_cb_f_type          cmd_cb_func,
//  void                           *data_block_ptr,
//  cm_client_id_type              client_id
//)
#ifdef FEATURE_PS_DORMANT_PWR_SAVE
BRIDLE_SUBSYS_3_RET(cm, boolean, cm_mm_ss_cmd_ps_data_available,
  cm_ss_cmd_cb_f_type*         ,BRIDLE_CHECK_NONE, 0,
  void                           *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type              ,BRIDLE_CHECK_NONE, 0
)
#else
BRIDLE_SUBSYS_3_RET(cm, boolean, cm_mm_call_cmd_ps_data_available,
  cm_call_cmd_cb_f_type*         ,BRIDLE_CHECK_NONE, 0,
  void                           *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type              ,BRIDLE_CHECK_NONE, 0
)
#endif



////////////////////////////////////////////////////////////////////////////////


//extern cm_nc_status_e_type cm_nc_reg(
//  cm_nc_resolve_call_type_f_type     *resolve_call_type_func,
//  cm_nc_is_call_allowed_f_type       *cm_nc_is_call_allowed_func,
//  cm_nc_pre_pending_dial_f_type      *pre_pending_dial_func
//)

BRIDLE_SUBSYS_3_RET(cm, cm_nc_status_e_type, cm_nc_reg,
  cm_nc_resolve_call_type_f_type     *,BRIDLE_CHECK_NONE, 0,
  cm_nc_is_call_allowed_f_type       *,BRIDLE_CHECK_NONE, 0,
  cm_nc_pre_pending_dial_f_type      *,BRIDLE_CHECK_NONE, 0
)


////////////////////////////////////////////////////////////////////////////////



 


////////////////////////////////////////////////////////////////////////////////
//extern boolean cm_ph_cmd_oprt_mode(
//  cm_ph_cmd_cb_f_type    cmd_cb_func,
//  void                   *data_block_ptr,
//  cm_client_id_type      client_id,
//  sys_oprt_mode_e_type   oprt_mode
//)

BRIDLE_SUBSYS_4_RET(cm, boolean, cm_ph_cmd_oprt_mode,
  cm_ph_cmd_cb_f_type*    ,BRIDLE_CHECK_NONE, 0,
  void                   *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type      ,BRIDLE_CHECK_NONE, 0,
  sys_oprt_mode_e_type   ,BRIDLE_CHECK_NONE, 0
)


#if defined (CM_API_SYS_SEL_PRL_PREF)
////////////////////////////////////////////////////////////////////////////////
//extern boolean cm_ph_cmd_sys_sel_pref(
//  cm_ph_cmd_cb_f_type               cmd_cb_func,
//  void                              *data_block_ptr,
//  cm_client_id_type                 client_id,
//  cm_mode_pref_e_type               mode_pref,
//  cm_pref_term_e_type               pref_term,
//  dword                             pref_duration,
//  cm_gw_acq_order_pref_e_type       acq_order_pref,
//  cm_band_pref_e_type               band_pref,
//  cm_prl_pref_e_type                prl_pref,
//  cm_roam_pref_e_type               roam_pref,
//  cm_hybr_pref_e_type               hybr_pref,
//  cm_srv_domain_pref_e_type         srv_domain_pref,
//  cm_network_sel_mode_pref_e_type   network_sel_mode_pref,
//  sys_plmn_id_s_type                *plmn_ptr
//)

BRIDLE_SUBSYS_14_RET(cm, boolean, cm_ph_cmd_sys_sel_pref,
   cm_ph_cmd_cb_f_type*, BRIDLE_CHECK_NONE, 0,  void *, BRIDLE_CHECK_NONE, 0,
   cm_client_id_type, BRIDLE_CHECK_NONE, 0,  cm_mode_pref_e_type, BRIDLE_CHECK_NONE, 0,
   cm_pref_term_e_type, BRIDLE_CHECK_NONE, 0,  dword, BRIDLE_CHECK_NONE, 0,
   cm_gw_acq_order_pref_e_type, BRIDLE_CHECK_NONE, 0,  cm_band_pref_e_type, BRIDLE_CHECK_NONE, 0,
   cm_prl_pref_e_type, BRIDLE_CHECK_NONE, 0, cm_roam_pref_e_type, BRIDLE_CHECK_NONE, 0, 
   cm_hybr_pref_e_type, BRIDLE_CHECK_NONE, 0, cm_srv_domain_pref_e_type, BRIDLE_CHECK_NONE, 0,
   cm_network_sel_mode_pref_e_type, BRIDLE_CHECK_NONE, 0, sys_plmn_id_s_type*, BRIDLE_CHECK_READACCESS_NZ,
   sizeof(sys_plmn_id_s_type) )

#else
////////////////////////////////////////////////////////////////////////////////
//extern boolean cm_ph_cmd_sys_sel_pref(
//  cm_ph_cmd_cb_f_type               cmd_cb_func,
//  void                              *data_block_ptr,
//  cm_client_id_type                 client_id,
//  cm_mode_pref_e_type               mode_pref,
//  cm_pref_term_e_type               pref_term,
//  dword                             pref_duration,
//  cm_gw_acq_order_pref_e_type       acq_order_pref,
//  cm_band_pref_e_type               band_pref,
//  cm_roam_pref_e_type               roam_pref,
//  cm_hybr_pref_e_type               hybr_pref,
//  cm_srv_domain_pref_e_type         srv_domain_pref,
//  cm_network_sel_mode_pref_e_type   network_sel_mode_pref,
//  sys_plmn_id_s_type                *plmn_ptr
//)
BRIDLE_SUBSYS_13_RET(cm, boolean, cm_ph_cmd_sys_sel_pref,
   cm_ph_cmd_cb_f_type*, BRIDLE_CHECK_NONE, 0,  void *, BRIDLE_CHECK_NONE, 0,
   cm_client_id_type, BRIDLE_CHECK_NONE, 0,  cm_mode_pref_e_type, BRIDLE_CHECK_NONE, 0,
   cm_pref_term_e_type, BRIDLE_CHECK_NONE, 0,  dword, BRIDLE_CHECK_NONE, 0,
   cm_gw_acq_order_pref_e_type, BRIDLE_CHECK_NONE, 0,  cm_band_pref_e_type, BRIDLE_CHECK_NONE, 0,
   cm_roam_pref_e_type, BRIDLE_CHECK_NONE, 0,  cm_hybr_pref_e_type, BRIDLE_CHECK_NONE, 0,
   cm_srv_domain_pref_e_type, BRIDLE_CHECK_NONE, 0,  cm_network_sel_mode_pref_e_type, BRIDLE_CHECK_NONE, 0,
   sys_plmn_id_s_type*, BRIDLE_CHECK_READACCESS_NZ, sizeof(sys_plmn_id_s_type) )
#endif


////////////////////////////////////////////////////////////////////////////////
//boolean cm_ph_cmd_ddtm_pref(
//  cm_ph_cmd_cb_f_type        cmd_cb_func,
//  void                       *data_block_ptr,
//  cm_client_id_type          client_id,
//  cm_ddtm_pref_e_type        ddtm_pref,
//  sys_ddtm_act_mask_e_type   ddtm_act,
//  cm_ddtm_so_list_act_e_type so_list_act,
//  uint16                     num_srv_opt,  
//  sys_srv_opt_type           srv_opt_list[]  
//)

#if MIN_CM_REV(3,16)
BRIDLE_SUBSYS_8_RET(cm, boolean, cm_ph_cmd_ddtm_pref,
  cm_ph_cmd_cb_f_type*        ,BRIDLE_CHECK_NONE, 0, 
  void                       *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type          ,BRIDLE_CHECK_NONE, 0,
  cm_ddtm_pref_e_type        ,BRIDLE_CHECK_NONE, 0,
  sys_ddtm_act_mask_e_type   ,BRIDLE_CHECK_NONE, 0, 
  cm_ddtm_so_list_act_e_type ,BRIDLE_CHECK_NONE, 0,
  uint16                     ,BRIDLE_CHECK_NONE, 0, 
  sys_srv_opt_type           *,BRIDLE_CHECK_NONE, 0
)
#elif MIN_CM_REV(3,15)
BRIDLE_SUBSYS_4_RET(cm, boolean, cm_ph_cmd_ddtm_pref,
  cm_ph_cmd_cb_f_type*        ,BRIDLE_CHECK_NONE, 0, 
  void                       *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type          ,BRIDLE_CHECK_NONE, 0,
  cm_ddtm_pref_e_type        ,BRIDLE_CHECK_NONE, 0
)
#endif

////////////////////////////////////////////////////////////////////////////////
//extern boolean cm_ph_cmd_avoid_sys(
//  cm_ph_cmd_cb_f_type     cmd_cb_func,
//  void                    *data_block_ptr,
//  cm_client_id_type       client_id,
//  cm_ss_avoid_sys_e_type  avoid_type,
//  dword                   avoid_time
//)

BRIDLE_SUBSYS_5_RET(cm, boolean, cm_ph_cmd_avoid_sys,
  cm_ph_cmd_cb_f_type*     ,BRIDLE_CHECK_NONE, 0,
  void                    *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type       ,BRIDLE_CHECK_NONE, 0,
  cm_ss_avoid_sys_e_type  ,BRIDLE_CHECK_NONE, 0,
  dword                   ,BRIDLE_CHECK_NONE, 0
)

////////////////////////////////////////////////////////////////////////////////
//extern boolean cm_ph_cmd_answer_voice(
// cm_ph_cmd_cb_f_type        cmd_cb_func,
//  void                       *data_block_ptr,
//  cm_client_id_type          client_id,
//  cm_answer_voice_e_type     answer_voice,
//  dword                      answer_duration
//)

BRIDLE_SUBSYS_5_RET(cm, boolean, cm_ph_cmd_answer_voice,
 cm_ph_cmd_cb_f_type*        ,BRIDLE_CHECK_NONE, 0,
  void                       *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type          ,BRIDLE_CHECK_NONE, 0,
  cm_answer_voice_e_type     ,BRIDLE_CHECK_NONE, 0,
  dword                      ,BRIDLE_CHECK_NONE, 0
)

////////////////////////////////////////////////////////////////////////////////
//extern boolean cm_ph_cmd_nam_sel(
//  cm_ph_cmd_cb_f_type        cmd_cb_func,
//  void                       *data_block_ptr,
//  cm_client_id_type          client_id,
//  cm_nam_e_type              nam_sel
//)

BRIDLE_SUBSYS_4_RET(cm, boolean, cm_ph_cmd_nam_sel,
  cm_ph_cmd_cb_f_type*        ,BRIDLE_CHECK_NONE, 0,
  void                       *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type          ,BRIDLE_CHECK_NONE, 0,
  cm_nam_e_type              ,BRIDLE_CHECK_NONE, 0
)

////////////////////////////////////////////////////////////////////////////////
//extern boolean cm_ph_cmd_get_ph_info(
//  cm_ph_cmd_cb_f_type    cmd_cb_func,
//  void                   *data_block_ptr,
//  cm_client_id_type      client_id
//)

BRIDLE_SUBSYS_3_RET(cm, boolean, cm_ph_cmd_get_ph_info,
  cm_ph_cmd_cb_f_type*    ,BRIDLE_CHECK_NONE, 0,
  void                   *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type      ,BRIDLE_CHECK_NONE, 0
)

////////////////////////////////////////////////////////////////////////////////
//extern boolean cm_ph_cmd_rssi_delta_threshold(
//  cm_ph_cmd_cb_f_type    cmd_cb_func,
//  void                   *data_block_ptr,
//  cm_client_id_type      client_id,
//  uint8                  delta
//)

BRIDLE_SUBSYS_4_RET(cm, boolean, cm_ph_cmd_rssi_delta_threshold,
  cm_ph_cmd_cb_f_type*    ,BRIDLE_CHECK_NONE, 0,
  void                   *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type      ,BRIDLE_CHECK_NONE, 0,
  uint8                  ,BRIDLE_CHECK_NONE, 0
)

////////////////////////////////////////////////////////////////////////////////
//extern boolean cm_ph_cmd_subscription_available(
//  cm_ph_cmd_cb_f_type             cmd_cb_func,
//  void                            *data_block_ptr,
//  cm_client_id_type               client_id,
//  cm_subscription_status_e_type   cdma_status,
//  cm_subscription_status_e_type   gw_status
//)

BRIDLE_SUBSYS_5_RET(cm, boolean, cm_ph_cmd_subscription_available,
  cm_ph_cmd_cb_f_type*             ,BRIDLE_CHECK_NONE, 0,
  void                            *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type               ,BRIDLE_CHECK_NONE, 0,
  cm_subscription_status_e_type   ,BRIDLE_CHECK_NONE, 0,
  cm_subscription_status_e_type   ,BRIDLE_CHECK_NONE, 0
)


////////////////////////////////////////////////////////////////////////////////
//extern boolean cm_ph_cmd_subscription_not_available(
//  cm_ph_cmd_cb_f_type             cmd_cb_func,
//  void                            *data_block_ptr,
//  cm_client_id_type               client_id,
//  cm_subscription_status_e_type   cdma_status,
//  cm_subscription_status_e_type   gw_status
//)

BRIDLE_SUBSYS_5_RET(cm, boolean, cm_ph_cmd_subscription_not_available,
  cm_ph_cmd_cb_f_type*             ,BRIDLE_CHECK_NONE, 0,
  void                            *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type               ,BRIDLE_CHECK_NONE, 0,
  cm_subscription_status_e_type   ,BRIDLE_CHECK_NONE, 0,
  cm_subscription_status_e_type   ,BRIDLE_CHECK_NONE, 0
)


////////////////////////////////////////////////////////////////////////////////
//extern boolean cm_ph_cmd_subscription_changed(
//  cm_ph_cmd_cb_f_type             cmd_cb_func,
//  void                            *data_block_ptr,
//  cm_client_id_type               client_id,
//  cm_subscription_status_e_type   cdma_status,
//  cm_subscription_status_e_type   gw_status
//)

BRIDLE_SUBSYS_5_RET(cm, boolean, cm_ph_cmd_subscription_changed,
  cm_ph_cmd_cb_f_type*             ,BRIDLE_CHECK_NONE, 0,
  void                            *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type               ,BRIDLE_CHECK_NONE, 0,
  cm_subscription_status_e_type   ,BRIDLE_CHECK_NONE, 0,
  cm_subscription_status_e_type   ,BRIDLE_CHECK_NONE, 0
)
////////////////////////////////////////////////////////////////////////////////

//extern boolean cm_ph_cmd_get_networks(
//  cm_ph_cmd_cb_f_type          cmd_cb_func,
//  void                        *data_block_ptr,
//  cm_client_id_type            client_id,
//  cm_network_list_type_e_type  list_type
//)
BRIDLE_SUBSYS_4_RET(cm, boolean, cm_ph_cmd_get_networks,
  cm_ph_cmd_cb_f_type*          ,BRIDLE_CHECK_NONE, 0,
  void                        *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type            ,BRIDLE_CHECK_NONE, 0,
  cm_network_list_type_e_type  ,BRIDLE_CHECK_NONE, 0
)

////////////////////////////////////////////////////////////////////////////////

//extern boolean cm_ph_cmd_terminate_get_networks(
 // cm_ph_cmd_cb_f_type          cmd_cb_func,
//  void                        *data_block_ptr,
//  cm_client_id_type            client_id
//)

BRIDLE_SUBSYS_3_RET(cm, boolean, cm_ph_cmd_terminate_get_networks,
 cm_ph_cmd_cb_f_type*          ,BRIDLE_CHECK_NONE, 0,
  void                        *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type            ,BRIDLE_CHECK_NONE, 0
)

////////////////////////////////////////////////////////////////////////////////

//extern boolean cm_ph_cmd_set_preferred_networks(
//  cm_ph_cmd_cb_f_type              cmd_cb_func,
//  void                            *data_block_ptr,
//  cm_client_id_type                client_id,
//  sys_user_pref_plmn_list_s_type  *preferred_networks_ptr
//)
BRIDLE_SUBSYS_4_RET(cm, boolean, cm_ph_cmd_set_preferred_networks,
  cm_ph_cmd_cb_f_type*              ,BRIDLE_CHECK_NONE, 0,
  void                            *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type                ,BRIDLE_CHECK_NONE, 0,
  sys_user_pref_plmn_list_s_type  *,BRIDLE_CHECK_READACCESS_NZ, sizeof(sys_user_pref_plmn_list_s_type)
)

////////////////////////////////////////////////////////////////////////////////

//boolean cm_ph_cmd_packet_state(
//  cm_ph_cmd_cb_f_type         cmd_cb_func,
//  void                        *data_block_ptr,
//  cm_client_id_type           client_id,
//  cm_packet_state_e_type      packet_state
//)
BRIDLE_SUBSYS_4_RET(cm,boolean, cm_ph_cmd_packet_state,
  cm_ph_cmd_cb_f_type*         ,BRIDLE_CHECK_NONE, 0,
  void                        *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type           ,BRIDLE_CHECK_NONE, 0,
  cm_packet_state_e_type      ,BRIDLE_CHECK_NONE, 0
)

////////////////////////////////////////////////////////////////////////////////

//extern boolean cm_ph_cmd_voc_activity(
//  cm_ph_cmd_cb_f_type    cmd_cb_func,
//  void                   *data_block_ptr,
//  cm_client_id_type      client_id,
//  boolean                enable,
//  uint16                 voc_1,
//  uint16                 voc_2,
//  uint16                 voc_8
//)
BRIDLE_SUBSYS_7_RET(cm, boolean, cm_ph_cmd_voc_activity,
  cm_ph_cmd_cb_f_type*    ,BRIDLE_CHECK_NONE, 0,
  void                   *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type      ,BRIDLE_CHECK_NONE, 0,
  boolean                ,BRIDLE_CHECK_NONE, 0,
  uint16                 ,BRIDLE_CHECK_NONE, 0,
  uint16                 ,BRIDLE_CHECK_NONE, 0,
  uint16                 ,BRIDLE_CHECK_NONE, 0
)

////////////////////////////////////////////////////////////////////////////////

//extern boolean cm_ph_cmd_wakeup_from_standby(
//  cm_ph_cmd_cb_f_type    cmd_cb_func,
//  void                   *data_block_ptr,
//  cm_client_id_type      client_id
//)
BRIDLE_SUBSYS_3_RET(cm, boolean, cm_ph_cmd_wakeup_from_standby,
  cm_ph_cmd_cb_f_type*    ,BRIDLE_CHECK_NONE, 0,
  void                   *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type      ,BRIDLE_CHECK_NONE, 0
)

////////////////////////////////////////////////////////////////////////////////

//extern boolean cm_ph_cmd_change_rtre_config(
//  cm_ph_cmd_cb_f_type    cmd_cb_func,
//  void                   *data_block_ptr,
//  cm_client_id_type      client_id,
//  cm_rtre_config_e_type  rtre_config
//)
BRIDLE_SUBSYS_4_RET(cm, boolean, cm_ph_cmd_change_rtre_config,
  cm_ph_cmd_cb_f_type*    ,BRIDLE_CHECK_NONE, 0,
  void                   *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type      ,BRIDLE_CHECK_NONE, 0,
  cm_rtre_config_e_type  ,BRIDLE_CHECK_NONE, 0
)

////////////////////////////////////////////////////////////////////////////////

//extern boolean cm_ph_cmd_aoc_reset_acm(
//  cm_ph_cmd_cb_f_type    cmd_cb_func,
//  void                   *data_block_ptr,
//  cm_client_id_type      client_id
//)
#if MIN_CM_REV(3,100)
BRIDLE_SUBSYS_3_RET(cm, boolean, cm_ph_cmd_aoc_reset_acm,
  cm_ph_cmd_cb_f_type*    ,BRIDLE_CHECK_NONE, 0,
  void                   *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type      ,BRIDLE_CHECK_NONE, 0
)
////////////////////////////////////////////////////////////////////////////////

//extern boolean cm_ph_cmd_aoc_set_acmmax(
//  cm_ph_cmd_cb_f_type    cmd_cb_func,
//  void                   *data_block_ptr,
//  cm_client_id_type      client_id,
//  uint32                 new_max
//)
BRIDLE_SUBSYS_4_RET(cm, boolean, cm_ph_cmd_aoc_set_acmmax,
  cm_ph_cmd_cb_f_type*    ,BRIDLE_CHECK_NONE, 0,
  void                   *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type      ,BRIDLE_CHECK_NONE, 0,
  uint32                 ,BRIDLE_CHECK_NONE, 0
)
////////////////////////////////////////////////////////////////////////////////

//extern unsigned long cm_ph_cmd_aoc_get_ccm(void)
BRIDLE_SUBSYS_0_RET(cm, unsigned long, cm_ph_cmd_aoc_get_ccm)

////////////////////////////////////////////////////////////////////////////////

//extern unsigned long cm_ph_cmd_aoc_get_acm(void)
BRIDLE_SUBSYS_0_RET(cm, unsigned long, cm_ph_cmd_aoc_get_acm)

////////////////////////////////////////////////////////////////////////////////

//extern unsigned long cm_ph_cmd_aoc_get_acmmax(void)
BRIDLE_SUBSYS_0_RET(cm, unsigned long, cm_ph_cmd_aoc_get_acmmax)

////////////////////////////////////////////////////////////////////////////////

//extern unsigned long cm_ph_cmd_aoc_get_puct(void)
BRIDLE_SUBSYS_0_RET(cm, unsigned long, cm_ph_cmd_aoc_get_puct)
#endif

////////////////////////////////////////////////////////////////////////////////


//extern boolean cm_ss_cmd_get_ss_info(
//  cm_ss_cmd_cb_f_type  cmd_cb_func,
//  void                 *data_block_ptr,
//  cm_client_id_type    client_id
//)

BRIDLE_SUBSYS_3_RET(cm, boolean, cm_ss_cmd_get_ss_info,
  cm_ss_cmd_cb_f_type*  ,BRIDLE_CHECK_NONE, 0,
  void                 *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type    ,BRIDLE_CHECK_NONE, 0
)


////////////////////////////////////////////////////////////////////////////////


//extern boolean cm_mm_inband_cmd_burst_dtmf(
//  cm_inband_cmd_cb_f_type     cmd_cb_func,
//  void                        *data_block_ptr,
//  cm_client_id_type           client_id,
//  cm_call_id_type             call_id,
//  uint8                       on_length,
//  uint8                       off_length,
//  uint8                       cnt,
//  const uint8                 *dtmf_digit_ptr
//)

BRIDLE_SUBSYS_8_RET(cm, boolean, cm_mm_inband_cmd_burst_dtmf,
  cm_inband_cmd_cb_f_type*     ,BRIDLE_CHECK_NONE, 0,
  void                        *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type           ,BRIDLE_CHECK_NONE, 0,
  cm_call_id_type             ,BRIDLE_CHECK_NONE, 0,
  uint8                       ,BRIDLE_CHECK_NONE, 0,
  uint8                       ,BRIDLE_CHECK_NONE, 0,
  uint8                       ,BRIDLE_CHECK_NONE, 0,
  const uint8                 *,BRIDLE_CHECK_READ_STRING_ACCESS, 0
)

////////////////////////////////////////////////////////////////////////////////

//extern boolean cm_mm_inband_cmd_start_cont_dtmf(
//  cm_inband_cmd_cb_f_type     cmd_cb_func,
//  void                        *data_block_ptr,
//  cm_client_id_type           client_id,
//  cm_call_id_type             call_id,
//  uint8                       digit
//)
BRIDLE_SUBSYS_5_RET(cm, boolean, cm_mm_inband_cmd_start_cont_dtmf,
  cm_inband_cmd_cb_f_type*     ,BRIDLE_CHECK_NONE, 0, void                        *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type           ,BRIDLE_CHECK_NONE, 0,  cm_call_id_type             ,BRIDLE_CHECK_NONE, 0,
  uint8                       ,BRIDLE_CHECK_NONE, 0
)

////////////////////////////////////////////////////////////////////////////////

///extern boolean cm_mm_inband_cmd_stop_cont_dtmf(
//  cm_inband_cmd_cb_f_type     cmd_cb_func,
//  void                        *data_block_ptr,
///  cm_client_id_type           client_id,
//  cm_call_id_type             call_id,
//  uint16                      duration
//)

BRIDLE_SUBSYS_5_RET(cm, boolean, cm_mm_inband_cmd_stop_cont_dtmf,
  cm_inband_cmd_cb_f_type*     ,BRIDLE_CHECK_NONE, 0,
  void                        *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type           ,BRIDLE_CHECK_NONE, 0,
 cm_call_id_type             ,BRIDLE_CHECK_NONE, 0,
  uint16                      ,BRIDLE_CHECK_NONE, 0
)


////////////////////////////////////////////////////////////////////////////////

 
//extern boolean cm_sms_cmd_mo_msg(
//  cm_sms_cmd_cb_f_type    cmd_cb_func,
//  void                    *data_block_ptr,
//  cm_client_id_type       client_id,
//  boolean                 l2_ack_requested,
//  uint8                   *data
//)
BRIDLE_SUBSYS_5_RET(cm, boolean, cm_sms_cmd_mo_msg,
  cm_sms_cmd_cb_f_type*    ,BRIDLE_CHECK_NONE, 0,
  void                    *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type       ,BRIDLE_CHECK_NONE, 0,
  boolean                 ,BRIDLE_CHECK_NONE, 0,
  uint8                   *,BRIDLE_CHECK_NONE, 0
)

////////////////////////////////////////////////////////////////////////////////

//extern boolean cm_sms_cmd_awi_ack(
 // cm_sms_cmd_cb_f_type   cmd_cb_func,
//  void                   *data_block_ptr,
//  cm_client_id_type      client_id,
//  uint8                  seq_no,
//  boolean                bf,
//  uint8                  error_class,
//  uint8                  status
//)

BRIDLE_SUBSYS_7_RET(cm, boolean, cm_sms_cmd_awi_ack,
 cm_sms_cmd_cb_f_type*   ,BRIDLE_CHECK_NONE, 0,
  void                   *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type      ,BRIDLE_CHECK_NONE, 0,
  uint8                  ,BRIDLE_CHECK_NONE, 0,
  boolean                ,BRIDLE_CHECK_NONE, 0,
  uint8                  ,BRIDLE_CHECK_NONE, 0,
  uint8                  ,BRIDLE_CHECK_NONE, 0
)


////////////////////////////////////////////////////////////////////////////////

//extern boolean cm_sms_cmd_bc_enable(
//  cm_sms_cmd_cb_f_type  cmd_cb_func,
//  void                  *data_block_ptr,
//  cm_client_id_type     client_id,
//  boolean               bc_enable
//)

BRIDLE_SUBSYS_4_RET(cm, boolean, cm_sms_cmd_bc_enable,
  cm_sms_cmd_cb_f_type*  ,BRIDLE_CHECK_NONE, 0,
  void                  *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type     ,BRIDLE_CHECK_NONE, 0,
  boolean               ,BRIDLE_CHECK_NONE, 0
)

////////////////////////////////////////////////////////////////////////////////


//extern boolean cm_pd_cmd_session_start(
//  cm_pd_cmd_cb_f_type         cmd_cb_func,
//  void                        *data_block_ptr,
//  cm_client_id_type           client_id,
//  cm_pd_session_type_e_type   session_type
//)
BRIDLE_SUBSYS_4_RET(cm, boolean, cm_pd_cmd_session_start,
  cm_pd_cmd_cb_f_type*         ,BRIDLE_CHECK_NONE, 0,
  void                        *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type           ,BRIDLE_CHECK_NONE, 0,
  cm_pd_session_type_e_type   ,BRIDLE_CHECK_NONE, 0
)

////////////////////////////////////////////////////////////////////////////////

//extern boolean cm_pd_cmd_session_end/
//(
//  cm_pd_cmd_cb_f_type   cmd_cb_func,
//  void                  *data_block_ptr,
//  cm_client_id_type     client_id
//)
BRIDLE_SUBSYS_3_RET(cm, boolean, cm_pd_cmd_session_end,
  cm_pd_cmd_cb_f_type*   ,BRIDLE_CHECK_NONE, 0,
  void                  *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type     ,BRIDLE_CHECK_NONE, 0
)

////////////////////////////////////////////////////////////////////////////////

#ifdef FEATURE_GPSONE
//extern void cm_pd_cmd_reva_mo_msg(
//    void                               * data_block_ptr,
//    cm_client_id_type                  client,
//    word                               *payload,
//    uint16                             num_bytes
//    )

//extern void cm_pd_cmd_reva_mo_msg(
//    cm_pd_cmd_cb_f_type                cmd_cb_func,
//    void                               * data_block_ptr,
//    cm_client_id_type                  client,
//    word                               *payload,
//    uint16                             num_bytes
//    );
BRIDLE_SUBSYS_5_VOID(cm,  cm_pd_cmd_reva_mo_msg,
    cm_pd_cmd_cb_f_type					* ,BRIDLE_CHECK_NONE, 0,
    void                               * ,BRIDLE_CHECK_NONE, 0,
    cm_client_id_type                  ,BRIDLE_CHECK_NONE, 0,
  word                               *,BRIDLE_CHECK_NONE, 0,
    uint16                             ,BRIDLE_CHECK_NONE, 0
    )

////////////////////////////////////////////////////////////////////////////////
#endif

//extern cm_pd_status_e_type cm_pd_reg (
//  cm_pd_resp_is_within_t2m_f_type   *cm_pd_resp_is_within_t2m_func
//)
BRIDLE_SUBSYS_1_RET(cm, cm_pd_status_e_type, cm_pd_reg,
  cm_pd_resp_is_within_t2m_f_type   *,BRIDLE_CHECK_NONE, 0
)

////////////////////////////////////////////////////////////////////////////////


//extern boolean cm_sups_cmd_register(
//  cm_sups_cmd_cb_f_type     sups_cmd_cb_func,
//  void                      *data_block_ptr,
//  cm_client_id_type         client_id,
//  cm_reg_ss_params_s_type   *reg_cmd_params
//)


BRIDLE_SUBSYS_4_RET(cm, boolean, cm_sups_cmd_register,
  cm_sups_cmd_cb_f_type*     ,BRIDLE_CHECK_NONE, 0,
  void                      *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type         ,BRIDLE_CHECK_NONE, 0,
  cm_reg_ss_params_s_type   *,BRIDLE_CHECK_READACCESS_NZ, sizeof(cm_reg_ss_params_s_type)
)

////////////////////////////////////////////////////////////////////////////////


//extern boolean cm_sups_cmd_erase(
//  cm_sups_cmd_cb_f_type       sups_cmd_cb_func,
//  void                        *data_block_ptr,
//  cm_client_id_type           client_id,
//  cm_erase_ss_params_s_type   *erase_cmd_params
//)
BRIDLE_SUBSYS_4_RET(cm, boolean, cm_sups_cmd_erase,
  cm_sups_cmd_cb_f_type*       ,BRIDLE_CHECK_NONE, 0,
  void                        *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type           ,BRIDLE_CHECK_NONE, 0,
  cm_erase_ss_params_s_type   *,BRIDLE_CHECK_READACCESS_NZ, sizeof(cm_erase_ss_params_s_type)
)

////////////////////////////////////////////////////////////////////////////////

//extern boolean cm_sups_cmd_activate(
//  cm_sups_cmd_cb_f_type    sups_cmd_cb_func,
//  void                     *data_block_ptr,
//  cm_client_id_type        client_id,
//  cm_act_ss_params_s_type  *act_cmd_params
//)

BRIDLE_SUBSYS_4_RET(cm, boolean, cm_sups_cmd_activate,
  cm_sups_cmd_cb_f_type*    ,BRIDLE_CHECK_NONE, 0,
  void                     *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type        ,BRIDLE_CHECK_NONE, 0,
  cm_act_ss_params_s_type  *,BRIDLE_CHECK_READACCESS_NZ, sizeof(cm_act_ss_params_s_type)
)

////////////////////////////////////////////////////////////////////////////////


//extern boolean cm_sups_cmd_deactivate(
//  cm_sups_cmd_cb_f_type       sups_cmd_cb_func,/
//  void                        *data_block_ptr,
//  cm_client_id_type           client_id,
//  cm_deact_ss_params_s_type   *deact_cmd_params
//)
BRIDLE_SUBSYS_4_RET(cm, boolean, cm_sups_cmd_deactivate,
  cm_sups_cmd_cb_f_type*       ,BRIDLE_CHECK_NONE, 0,
  void                        *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type           ,BRIDLE_CHECK_NONE, 0,
  cm_deact_ss_params_s_type   *,BRIDLE_CHECK_READACCESS_NZ, sizeof(cm_deact_ss_params_s_type)
)

////////////////////////////////////////////////////////////////////////////////

//extern boolean cm_sups_cmd_interrogate(
//  cm_sups_cmd_cb_f_type        sups_cmd_cb_func,
//  void                         *data_block_ptr,
//  cm_client_id_type            client_id,
//  cm_interr_ss_params_s_type   *interr_cmd_params
//)
BRIDLE_SUBSYS_4_RET(cm, boolean, cm_sups_cmd_interrogate,
  cm_sups_cmd_cb_f_type*        ,BRIDLE_CHECK_NONE, 0,
  void                         *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type            ,BRIDLE_CHECK_NONE, 0,
  cm_interr_ss_params_s_type   *,BRIDLE_CHECK_READACCESS_NZ, sizeof(cm_interr_ss_params_s_type)
)
////////////////////////////////////////////////////////////////////////////////


//extern boolean cm_sups_cmd_process_uss(
//  cm_sups_cmd_cb_f_type    sups_cmd_cb_func,
//  void                     *data_block_ptr,
//  cm_client_id_type        client_id,
//  cm_uss_params_s_type     *process_uss_cmd_params
//)
BRIDLE_SUBSYS_4_RET(cm, boolean, cm_sups_cmd_process_uss,
  cm_sups_cmd_cb_f_type*    ,BRIDLE_CHECK_NONE, 0,
  void                     *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type        ,BRIDLE_CHECK_NONE, 0,
  cm_uss_params_s_type     *,BRIDLE_CHECK_READACCESS_NZ, sizeof(cm_uss_params_s_type)
)

////////////////////////////////////////////////////////////////////////////////

//extern boolean cm_sups_cmd_reg_password(
//  cm_sups_cmd_cb_f_type      sups_cmd_cb_func,
//  void                       *data_block_ptr,
//  cm_client_id_type          client_id,
//  cm_reg_pwd_params_s_type   *reg_pwd_cmd_params
//)
BRIDLE_SUBSYS_4_RET(cm, boolean, cm_sups_cmd_reg_password,
  cm_sups_cmd_cb_f_type*      ,BRIDLE_CHECK_NONE, 0,
  void                       *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type          ,BRIDLE_CHECK_NONE, 0,
  cm_reg_pwd_params_s_type   *,BRIDLE_CHECK_READACCESS_NZ, sizeof(cm_reg_pwd_params_s_type)
)
////////////////////////////////////////////////////////////////////////////////

//extern boolean cm_sups_cmd_release(
//  cm_sups_cmd_cb_f_type          sups_cmd_cb_func,
//  void                           *data_block_ptr,
//  cm_client_id_type              client_id,
//  cm_release_ss_params_s_type    *release_cmd_params
//)

BRIDLE_SUBSYS_4_RET(cm, boolean, cm_sups_cmd_release,
  cm_sups_cmd_cb_f_type*          ,BRIDLE_CHECK_NONE, 0,
  void                           *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type              ,BRIDLE_CHECK_NONE, 0,
  cm_release_ss_params_s_type    *,BRIDLE_CHECK_READACCESS_NZ, sizeof(cm_release_ss_params_s_type)
)
////////////////////////////////////////////////////////////////////////////////

//extern boolean cm_sups_cmd_get_password_res(
//  cm_sups_cmd_cb_f_type             sups_cmd_cb_func,
//  void                              *data_block_ptr,
//  cm_client_id_type                 client_id,
//  cm_get_pwd_res_params_s_type      *get_pwd_res_params
//)

BRIDLE_SUBSYS_4_RET(cm, boolean, cm_sups_cmd_get_password_res,
  cm_sups_cmd_cb_f_type*             ,BRIDLE_CHECK_NONE, 0,
  void                              *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type                 ,BRIDLE_CHECK_NONE, 0,
  cm_get_pwd_res_params_s_type      *,BRIDLE_CHECK_READACCESS_NZ, sizeof(cm_get_pwd_res_params_s_type)
)

////////////////////////////////////////////////////////////////////////////////

#ifdef FEATURE_MMGPS
//boolean cm_sups_cmd_lcs_molr(
//        cm_sups_cmd_cb_f_type      sups_cmd_cb_func,
//        void                       *data_block_ptr,
//        cm_client_id_type           client,
//        cm_lcs_molr_params_s_type    *lcs_molr_cmd_params
//)
BRIDLE_SUBSYS_4_RET(cm,boolean, cm_sups_cmd_lcs_molr,
        cm_sups_cmd_cb_f_type*      ,BRIDLE_CHECK_NONE, 0,
        void                       *,BRIDLE_CHECK_NONE, 0,
        cm_client_id_type           ,BRIDLE_CHECK_NONE, 0,
        cm_lcs_molr_params_s_type    *,BRIDLE_CHECK_READACCESS_NZ, sizeof(cm_lcs_molr_params_s_type)
)
////////////////////////////////////////////////////////////////////////////////
//boolean cm_sups_cmd_lcs_location_notification_res(
//        cm_sups_cmd_cb_f_type             sups_cmd_cb_func,
//        void                               *data_block_ptr,
//        cm_client_id_type                  client,
//        cm_lcs_location_notification_res_params_s_type       *lcs_location_notification_res_params
//)

BRIDLE_SUBSYS_4_RET(cm,boolean, cm_sups_cmd_lcs_location_notification_res,
        cm_sups_cmd_cb_f_type*             ,BRIDLE_CHECK_NONE, 0,
        void                               *,BRIDLE_CHECK_NONE, 0,
        cm_client_id_type                  ,BRIDLE_CHECK_NONE, 0,
        cm_lcs_location_notification_res_params_s_type *,BRIDLE_CHECK_READACCESS_NZ, sizeof(cm_lcs_location_notification_res_params_s_type)
)
////////////////////////////////////////////////////////////////////////////////
//boolean cm_sups_cmd_lcs_molr_completed(
//        cm_sups_cmd_cb_f_type      sups_cmd_cb_func,
//        void                       *data_block_ptr,
//        cm_client_id_type           client,
//        cm_lcs_molr_completed_params_s_type    *lcs_molr_completed_cmd_params
//)

BRIDLE_SUBSYS_4_RET(cm,boolean, cm_sups_cmd_lcs_molr_completed,
        cm_sups_cmd_cb_f_type*      ,BRIDLE_CHECK_NONE, 0,
        void                       *,BRIDLE_CHECK_NONE, 0,
        cm_client_id_type           ,BRIDLE_CHECK_NONE, 0,
        cm_lcs_molr_completed_params_s_type    *,BRIDLE_CHECK_READACCESS_NZ, sizeof(cm_lcs_molr_completed_params_s_type)
)
////////////////////////////////////////////////////////////////////////////////

#endif // end if feature_mmgps //
//extern boolean cm_sups_cmd_uss_notify_res(
//  cm_sups_cmd_cb_f_type               sups_cmd_cb_func,
//  void                                *data_block_ptr,
//  cm_client_id_type                   client_id,
//  cm_uss_notify_res_params_s_type     *uss_notify_res_params
//)


BRIDLE_SUBSYS_4_RET(cm, boolean, cm_sups_cmd_uss_notify_res,
  cm_sups_cmd_cb_f_type*               ,BRIDLE_CHECK_NONE, 0,
  void                                *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type                   ,BRIDLE_CHECK_NONE, 0,
  cm_uss_notify_res_params_s_type     *,BRIDLE_CHECK_READACCESS_NZ, sizeof(cm_uss_notify_res_params_s_type)
)
////////////////////////////////////////////////////////////////////////////////

//extern boolean cm_sups_cmd_uss_res(
//  cm_sups_cmd_cb_f_type         sups_cmd_cb_func,
//  void                          *data_block_ptr,
//  cm_client_id_type             client_id,
//  cm_uss_res_params_s_type      *uss_res_params
//)

BRIDLE_SUBSYS_4_RET(cm, boolean, cm_sups_cmd_uss_res,
  cm_sups_cmd_cb_f_type*         ,BRIDLE_CHECK_NONE, 0,
  void                          *,BRIDLE_CHECK_NONE, 0,
  cm_client_id_type             ,BRIDLE_CHECK_NONE, 0,
  cm_uss_res_params_s_type      *,BRIDLE_CHECK_READACCESS_NZ, sizeof(cm_uss_res_params_s_type)
)
////////////////////////////////////////////////////////////////////////////////
//extern boolean cm_dbm_cmd_mo_msg(
//    uint8                   burst_type,
//    cm_dbm_cmd_cb_f_type    cmd_cb_func,
//    void                   * data_block_ptr,
//    cm_client_id_type       client,
//    void *                  payload,
//    uint16                  num_bytes,
//    cm_dbm_payload_copy_cb_f_type      * payload_copy_func,
//    uint8                   l2_ack_wait_time,
 //   uint8                   l3_ack_wait_time,
//    cm_dbm_trans_pref_e_type  trans_pref
//)


BRIDLE_SUBSYS_10_RET(cm, boolean, cm_dbm_cmd_mo_msg,
    uint8                   ,BRIDLE_CHECK_NONE, 0,          cm_dbm_cmd_cb_f_type*    ,BRIDLE_CHECK_NONE, 0,
    void                   * ,BRIDLE_CHECK_NONE, 0,         cm_client_id_type       ,BRIDLE_CHECK_NONE, 0,
    void *                  ,BRIDLE_CHECK_NONE, 0,          uint16                  ,BRIDLE_CHECK_NONE, 0,
    cm_dbm_payload_copy_cb_f_type* ,BRIDLE_CHECK_NONE, 0,   uint8                   ,BRIDLE_CHECK_NONE, 0,
    uint8                   ,BRIDLE_CHECK_NONE, 0,          cm_dbm_trans_pref_e_type  ,BRIDLE_CHECK_NONE, 0 )
////////////////////////////////////////////////////////////////////////////////

//extern cm_client_status_e_type cm_client_init(
//  cm_client_type_e_type           client_type,
//  cm_client_id_type               *client_id_ptr
//)

PACKBRIDLE_SUBSYS_2_RET( cm, cm_client_status_e_type, cm_client_init, cm_client_type_e_type, cm_client_id_type * )

////////////////////////////////////////////////////////////////////////////////
//extern cm_client_status_e_type cm_client_release(
//  cm_client_id_type               client_id
//)

PACKBRIDLE_SUBSYS_1_RET( cm, cm_client_status_e_type, cm_client_release, cm_client_id_type )

////////////////////////////////////////////////////////////////////////////////
//cm_client_status_e_type cm_mm_client_call_reg(
//  cm_client_id_type           client_id,
//  cm_mm_call_event_f_type     *call_event_func,
//  cm_client_event_reg_e_type  event_reg_type,
//  cm_call_event_e_type        from_call_event,
//  cm_call_event_e_type        to_call_event,
//  cm_mm_call_cmd_err_f_type   *call_cmd_err_func
//)

PACKBRIDLE_SUBSYS_6_RET(cm, cm_client_status_e_type, cm_mm_client_call_reg,
                        cm_client_id_type, cm_mm_call_event_f_type *, cm_client_event_reg_e_type,
                        cm_call_event_e_type, cm_call_event_e_type, cm_mm_call_cmd_err_f_type * )

////////////////////////////////////////////////////////////////////////////////
//cm_client_status_e_type cm_client_ph_reg(
//  cm_client_id_type           client_id,
//  cm_ph_event_f_type          *ph_event_func,
//  cm_client_event_reg_e_type  event_reg_type,
//  cm_ph_event_e_type          from_ph_event,
//  cm_ph_event_e_type          to_ph_event,
//  cm_ph_cmd_err_f_type        *ph_cmd_err_func
//)

PACKBRIDLE_SUBSYS_6_RET(cm,cm_client_status_e_type, cm_client_ph_reg,
                        cm_client_id_type, cm_ph_event_f_type, cm_client_event_reg_e_type,
                        cm_ph_event_e_type, cm_ph_event_e_type, cm_ph_cmd_err_f_type )

////////////////////////////////////////////////////////////////////////////////

//cm_client_status_e_type cm_mm_client_ss_reg(
//  cm_client_id_type           client_id,
//  cm_mm_ss_event_f_type       *ss_event_func,
//  cm_client_event_reg_e_type  event_reg_type,
//  cm_ss_event_e_type          from_ss_event,
//  cm_ss_event_e_type          to_ss_event,
//  cm_ss_cmd_err_f_type        *ss_cmd_err_func
//)
PACKBRIDLE_SUBSYS_6_RET(cm,cm_client_status_e_type, cm_mm_client_ss_reg,
                        cm_client_id_type, cm_mm_ss_event_f_type, cm_client_event_reg_e_type,
                        cm_ss_event_e_type, cm_ss_event_e_type, cm_ss_cmd_err_f_type)

////////////////////////////////////////////////////////////////////////////////

//cm_client_status_e_type cm_mm_client_inband_reg(
//  cm_client_id_type               client_id,
//  cm_inband_event_f_type          *inband_event_func,
//  cm_client_event_reg_e_type      event_reg_type,
//  cm_inband_event_e_type          from_inband_event,
//  cm_inband_event_e_type          to_inband_event,
//  cm_mm_inband_cmd_err_f_type     *inband_cmd_err_func
//)
PACKBRIDLE_SUBSYS_6_RET(cm,cm_client_status_e_type, cm_mm_client_inband_reg,
                        cm_client_id_type, cm_inband_event_f_type, cm_client_event_reg_e_type,
                        cm_inband_event_e_type, cm_inband_event_e_type, cm_mm_inband_cmd_err_f_type)

////////////////////////////////////////////////////////////////////////////////
//cm_client_status_e_type cm_client_sms_reg(
//  cm_client_id_type               client_id,
//  cm_sms_event_f_type             *sms_event_func,
//  cm_client_event_reg_e_type      event_reg_type,
//  cm_sms_event_e_type             from_sms_event,
//  cm_sms_event_e_type             to_sms_event,
//  cm_sms_cmd_err_f_type           *sms_cmd_err_func
//)

BRIDLE_SUBSYS_6_RET(cm,cm_client_status_e_type, cm_client_sms_reg,
  cm_client_id_type               ,BRIDLE_CHECK_NONE, 0,
  cm_sms_event_f_type             *,BRIDLE_CHECK_NONE, 0,
  cm_client_event_reg_e_type      ,BRIDLE_CHECK_NONE, 0,
  cm_sms_event_e_type             ,BRIDLE_CHECK_NONE, 0,
  cm_sms_event_e_type             ,BRIDLE_CHECK_NONE, 0,
  cm_sms_cmd_err_f_type           *,BRIDLE_CHECK_NONE, 0
)
////////////////////////////////////////////////////////////////////////////////

//cm_client_status_e_type cm_client_pd_reg(
//  cm_client_id_type               client_id,
//  cm_pd_event_f_type             *pd_event_func,
//  cm_client_event_reg_e_type      event_reg_type,
//  cm_pd_event_e_type              from_pd_event,
//  cm_pd_event_e_type              to_pd_event,
//  cm_pd_cmd_err_f_type           *pd_cmd_err_func
//)
BRIDLE_SUBSYS_6_RET(cm,cm_client_status_e_type, cm_client_pd_reg,
  cm_client_id_type               ,BRIDLE_CHECK_NONE, 0,
  cm_pd_event_f_type             *,BRIDLE_CHECK_NONE, 0,
  cm_client_event_reg_e_type      ,BRIDLE_CHECK_NONE, 0,
  cm_pd_event_e_type              ,BRIDLE_CHECK_NONE, 0,
  cm_pd_event_e_type              ,BRIDLE_CHECK_NONE, 0,
  cm_pd_cmd_err_f_type           *,BRIDLE_CHECK_NONE, 0
)


////////////////////////////////////////////////////////////////////////////////

//cm_client_status_e_type cm_client_dbm_event_reg(
//    cm_client_id_type               client,
//    cm_dbm_event_f_type             *dbm_event_func,
//    cm_client_event_reg_e_type      event_reg_type,
//    cm_dbm_event_e_type             from_dbm_event,
//    cm_dbm_event_e_type             to_dbm_event,
//    cm_dbm_cmd_err_f_type           *dbm_cmd_err_func
//)
BRIDLE_SUBSYS_6_RET(cm,cm_client_status_e_type, cm_client_dbm_event_reg,
    cm_client_id_type               ,BRIDLE_CHECK_NONE, 0,
    cm_dbm_event_f_type             *,BRIDLE_CHECK_NONE, 0,
    cm_client_event_reg_e_type      ,BRIDLE_CHECK_NONE, 0,
    cm_dbm_event_e_type             ,BRIDLE_CHECK_NONE, 0,
    cm_dbm_event_e_type             ,BRIDLE_CHECK_NONE, 0,
    cm_dbm_cmd_err_f_type           *,BRIDLE_CHECK_NONE, 0
)

////////////////////////////////////////////////////////////////////////////////
//cm_client_status_e_type cm_client_dbm_class_reg(
//    cm_client_id_type               client,
//    cm_client_event_reg_e_type      event_reg_type,
//    cm_dbm_class_e_type             from_dbm_class,
//    cm_dbm_class_e_type             to_dbm_class
//)

BRIDLE_SUBSYS_4_RET(cm,cm_client_status_e_type, cm_client_dbm_class_reg,
    cm_client_id_type               ,BRIDLE_CHECK_NONE, 0,
    cm_client_event_reg_e_type      ,BRIDLE_CHECK_NONE, 0,
    cm_dbm_class_e_type             ,BRIDLE_CHECK_NONE, 0,
    cm_dbm_class_e_type             ,BRIDLE_CHECK_NONE, 0
)
////////////////////////////////////////////////////////////////////////////////

//cm_client_status_e_type cm_client_sups_reg(
//  cm_client_id_type             client_id,
//  cm_sups_event_f_type          *sups_event_func,
//  cm_client_event_reg_e_type    event_reg_type,
//  cm_sups_event_e_type          from_event,
//  cm_sups_event_e_type          to_event,
//  cm_sups_cmd_err_f_type        *sups_cmd_err_func
//)
BRIDLE_SUBSYS_6_RET(cm,cm_client_status_e_type, cm_client_sups_reg,
  cm_client_id_type             ,BRIDLE_CHECK_NONE, 0,
  cm_sups_event_f_type          *,BRIDLE_CHECK_NONE, 0,
  cm_client_event_reg_e_type    ,BRIDLE_CHECK_NONE, 0,
  cm_sups_event_e_type          ,BRIDLE_CHECK_NONE, 0,
  cm_sups_event_e_type          ,BRIDLE_CHECK_NONE, 0,
  cm_sups_cmd_err_f_type        *,BRIDLE_CHECK_NONE, 0
)

////////////////////////////////////////////////////////////////////////////////
//extern cm_client_status_e_type cm_client_act(
//  cm_client_id_type               client_id
//)

BRIDLE_SUBSYS_1_RET(cm, cm_client_status_e_type, cm_client_act,
  cm_client_id_type               ,BRIDLE_CHECK_NONE, 0
)
////////////////////////////////////////////////////////////////////////////////
//extern cm_client_status_e_type cm_client_deact(
//  cm_client_id_type               client_id
//)


BRIDLE_SUBSYS_1_RET(cm, cm_client_status_e_type, cm_client_deact,
  cm_client_id_type               ,BRIDLE_CHECK_NONE, 0
)

////////////////////////////////////////////////////////////////////////////////

//extern cm_client_type_e_type cmclient_get_client_type(
//    cm_client_id_type client_id
//)
BRIDLE_SUBSYS_1_RET(cm, cm_client_type_e_type, cmclient_get_client_type,
    cm_client_id_type ,BRIDLE_CHECK_NONE, 0
)

////////////////////////////////////////////////////////////////////////////////
//extern boolean cm_change_m511_mode(sys_jcdma_m511_e_type new_mode)

BRIDLE_SUBSYS_1_RET(cm, boolean, cm_change_m511_mode,
                    sys_jcdma_m511_e_type ,BRIDLE_CHECK_NONE, 0)
////////////////////////////////////////////////////////////////////////////////
//extern boolean cm_change_m512_mode(sys_jcdma_m512_e_type new_mode)

BRIDLE_SUBSYS_1_RET(cm, boolean, cm_change_m512_mode,
                    sys_jcdma_m512_e_type ,BRIDLE_CHECK_NONE, 0)
////////////////////////////////////////////////////////////////////////////////
//extern boolean cm_change_m513_mode(sys_jcdma_m513_e_type new_mode)

BRIDLE_SUBSYS_1_RET(cm, boolean, cm_change_m513_mode,
                    sys_jcdma_m513_e_type ,BRIDLE_CHECK_NONE, 0)
////////////////////////////////////////////////////////////////////////////////

//extern boolean cm_m51_mode_reg(
//  cm_m511_mode_settings_f_type     *change_m511_mode_func,
//  cm_m512_mode_settings_f_type     *change_m512_mode_func,
//  cm_m513_mode_settings_f_type     *change_m513_mode_func
//)
BRIDLE_SUBSYS_3_RET(cm, boolean, cm_m51_mode_reg,
  cm_m511_mode_settings_f_type     *,BRIDLE_CHECK_NONE, 0,
  cm_m512_mode_settings_f_type     *,BRIDLE_CHECK_NONE, 0,
  cm_m513_mode_settings_f_type     *,BRIDLE_CHECK_NONE, 0
)

////////////////////////////////////////////////////////////////////////////////

//extern boolean cm_is_valid_mode_band_pref(
//  cm_mode_pref_e_type    mode_pref,
//  cm_band_pref_e_type    band_pref
//)
BRIDLE_SUBSYS_2_RET(cm, boolean, cm_is_valid_mode_band_pref,
  cm_mode_pref_e_type    ,BRIDLE_CHECK_NONE, 0,
  cm_band_pref_e_type    ,BRIDLE_CHECK_NONE, 0
)

////////////////////////////////////////////////////////////////////////////////
//extern boolean cm_is_valid_mode_pref(
//  cm_mode_pref_e_type    mode_pref
//)

#if (defined(FEATURE_CDMA_800) || defined(FEATURE_CDMA_1900))
BRIDLE_SUBSYS_1_RET(cm, boolean, cm_is_valid_mode_pref,
  cm_mode_pref_e_type    ,BRIDLE_CHECK_NONE, 0
)
#endif

////////////////////////////////////////////////////////////////////////////////
//extern boolean cm_is_sys_mode_digital(
//  sys_sys_mode_e_type    sys_mode
//)

BRIDLE_SUBSYS_1_RET(cm, boolean, cm_is_sys_mode_digital,
  sys_sys_mode_e_type    ,BRIDLE_CHECK_NONE, 0
)

////////////////////////////////////////////////////////////////////////////////
//extern sys_sys_mode_e_type cm_get_pref_srv_type_for_packet_orig(
//  void
//)

BRIDLE_SUBSYS_0_RET(cm, sys_sys_mode_e_type, cm_get_pref_srv_type_for_packet_orig)

////////////////////////////////////////////////////////////////////////////////
//extern cm_nam_e_type  cm_get_curr_nam(
//  void
//)
BRIDLE_SUBSYS_0_RET(cm, cm_nam_e_type,  cm_get_curr_nam)
////////////////////////////////////////////////////////////////////////////////

//boolean cm_get_cur_hybr_status(void)
#ifdef FEATURE_HDR_HYBRID
BRIDLE_SUBSYS_0_RET(cm,boolean, cm_get_cur_hybr_status)
#endif

////////////////////////////////////////////////////////////////////////////////
//extern void cm_num_init(
//  cm_num_s_type *num_ptr
//)
BRIDLE_SUBSYS_1_VOID(cm, cm_num_init, cm_num_s_type *,BRIDLE_CHECK_NONE, 0)

////////////////////////////////////////////////////////////////////////////////
//extern void cm_num_fill(
//    cm_num_s_type          *num_ptr,
//    const uint8            *num_buf,
//    uint8                  num_len,
//    cm_digit_mode_e_type   digit_mode
//)


BRIDLE_SUBSYS_4_VOID(cm, cm_num_fill,
    cm_num_s_type          *,BRIDLE_CHECK_NONE, 0,
    const uint8            *,BRIDLE_CHECK_NONE, 0,
    uint8                  ,BRIDLE_CHECK_NONE, 0,
    cm_digit_mode_e_type   ,BRIDLE_CHECK_NONE, 0
)
////////////////////////////////////////////////////////////////////////////////
//
//extern uint8 cm_num_get(
//  const cm_num_s_type    *cm_num_ptr,
//  uint8*                  num_buf,
//  uint8                   max_len
//)
//
BRIDLE_SUBSYS_3_RET(cm, uint8, cm_num_get,
  cm_num_s_type    *,BRIDLE_CHECK_NONE, 0,
  uint8*                  ,BRIDLE_CHECK_NONE, 0,
  uint8                   ,BRIDLE_CHECK_NONE, 0
)
////////////////////////////////////////////////////////////////////////////////
//extern boolean cm_num_cmp(
//  const cm_num_s_type    *cm_num_ptr,
//  uint8*                 num_buf,
//  unsigned int           cmp_len
//)


BRIDLE_SUBSYS_3_RET(cm, boolean, cm_num_cmp,
  const cm_num_s_type    *,BRIDLE_CHECK_NONE, 0,
  uint8*                 ,BRIDLE_CHECK_NONE, 0,
  unsigned int           ,BRIDLE_CHECK_NONE, 0
)
////////////////////////////////////////////////////////////////////////////////
//extern boolean cm_num_cmp_exact(
//  const cm_num_s_type    *cm_num_ptr,
//  uint8*                  num_buf,
//  unsigned int           num_len
//)


BRIDLE_SUBSYS_3_RET(cm, boolean, cm_num_cmp_exact,
  const cm_num_s_type    *,BRIDLE_CHECK_NONE, 0,
  uint8*                  ,BRIDLE_CHECK_NONE, 0,
  unsigned int           ,BRIDLE_CHECK_NONE, 0
)

////////////////////////////////////////////////////////////////////////////////
//void cm_num_copy(
//    cm_num_s_type    *cm_num_ptr,
//    const byte*      num_buf,
//    uint8            num_len
//)

BRIDLE_SUBSYS_3_VOID(cm, cm_num_copy,
    cm_num_s_type    *,BRIDLE_CHECK_NONE, 0,
    const byte*      ,BRIDLE_CHECK_NONE, 0,
    uint8            ,BRIDLE_CHECK_NONE, 0
)

////////////////////////////////////////////////////////////////////////////////
//void cm_num_ep_msg_copy(
//    cm_num_s_type    *cm_num_ptr,
//    byte*            num_buf,
//    uint8            num_len
//)

BRIDLE_SUBSYS_3_VOID(cm, cm_num_ep_msg_copy,
    cm_num_s_type    *,BRIDLE_CHECK_NONE, 0,
    byte*            ,BRIDLE_CHECK_NONE, 0,
    uint8            ,BRIDLE_CHECK_NONE, 0
)
////////////////////////////////////////////////////////////////////////////////
//void cm_num_ep_cli_copy(
//    cm_num_s_type    *cm_num_ptr,
//    byte*            num_buf,
//    uint8            num_len
//)


BRIDLE_SUBSYS_3_VOID(cm, cm_num_ep_cli_copy,
    cm_num_s_type    *,BRIDLE_CHECK_NONE, 0,
    byte*            ,BRIDLE_CHECK_NONE, 0,
    uint8            ,BRIDLE_CHECK_NONE, 0
)
////////////////////////////////////////////////////////////////////////////////
//void cm_num_attrib_copy(
//    cm_num_s_type           *num_ptr,
//    uint8                   number_type,
//    uint8                   number_plan,
//    uint8                   pi,
//    uint8                   si,
//    cm_digit_mode_e_type    digit_mode
//)

#if (defined(FEATURE_CDMA_800) || defined(FEATURE_CDMA_1900))
BRIDLE_SUBSYS_6_VOID(cm, cm_num_attrib_copy,
    cm_num_s_type           *,BRIDLE_CHECK_NONE, 0,
    uint8                   ,BRIDLE_CHECK_NONE, 0,
    uint8                   ,BRIDLE_CHECK_NONE, 0,
    uint8                   ,BRIDLE_CHECK_NONE, 0,
    uint8                   ,BRIDLE_CHECK_NONE, 0,
    cm_digit_mode_e_type    ,BRIDLE_CHECK_NONE, 0
)
#endif
////////////////////////////////////////////////////////////////////////////////
//cm_num_err_e_type cm_num_validate(
//    const cm_num_s_type    *num_ptr
//)


BRIDLE_SUBSYS_1_RET(cm,cm_num_err_e_type, cm_num_validate,
    const cm_num_s_type    *,BRIDLE_CHECK_NONE, 0
)


#ifdef FEATURE_IS95B_EXT_DISP
////////////////////////////////////////////////////////////////////////////////
//extern void cm_ext_disp_itr_reset(
//  cm_ext_disp_itr_type  *itr_ptr,
//  cm_alpha_s_type       *info_ptr
//)


BRIDLE_SUBSYS_2_VOID(cm,  cm_ext_disp_itr_reset,
  cm_ext_disp_itr_type  *,BRIDLE_CHECK_NONE, 0,
  cm_alpha_s_type       *,BRIDLE_CHECK_NONE, 0
)

////////////////////////////////////////////////////////////////////////////////
//extern void cm_ext_disp_itr_next(
//  cm_ext_disp_itr_type *itr_ptr
//)

BRIDLE_SUBSYS_1_VOID(cm,  cm_ext_disp_itr_next,
  cm_ext_disp_itr_type *,BRIDLE_CHECK_NONE, 0
)

////////////////////////////////////////////////////////////////////////////////
//extern boolean cm_ext_disp_itr_more(
//  cm_ext_disp_itr_type *itr_ptr
//)

BRIDLE_SUBSYS_1_RET(cm, boolean, cm_ext_disp_itr_more,
  cm_ext_disp_itr_type *,BRIDLE_CHECK_NONE, 0
)
////////////////////////////////////////////////////////////////////////////////
//extern void cm_ext_disp_itr_get(
//  cm_ext_disp_itr_type *itr_ptr,
//  cm_ext_disp_subrecord *subrec_ptr
//)

BRIDLE_SUBSYS_2_VOID(cm,  cm_ext_disp_itr_get,
  cm_ext_disp_itr_type *,BRIDLE_CHECK_NONE, 0,
  cm_ext_disp_subrecord *,BRIDLE_CHECK_NONE, 0
)
#endif

////////////////////////////////////////////////////////////////////////////////

#if MIN_CM_REV(3,100)
//sys_sys_mode_e_type cm_get_current_acq_sys_mode( void )
BRIDLE_SUBSYS_0_RET(cm,sys_sys_mode_e_type, cm_get_current_acq_sys_mode)

////////////////////////////////////////////////////////////////////////////////

#if defined FEATURE_HDR_HYBRID && defined FEATURE_GPSONE
//extern boolean cm_pd_cmd_fix_start(
//    cm_pd_cmd_cb_f_type   cmd_cb_func,
//    void                  *data_block_ptr,
//    cm_client_id_type     client
//)

BRIDLE_SUBSYS_3_RET(cm, boolean, cm_pd_cmd_fix_start,
    cm_pd_cmd_cb_f_type*   ,BRIDLE_CHECK_NONE, 0,
    void                  *,BRIDLE_CHECK_NONE, 0,
    cm_client_id_type     ,BRIDLE_CHECK_NONE, 0
)
////////////////////////////////////////////////////////////////////////////////

//extern boolean cm_pd_cmd_fix_end(
//    cm_pd_cmd_cb_f_type   cmd_cb_func,
//    void                  *data_block_ptr,
//    cm_client_id_type     client
//    )
BRIDLE_SUBSYS_3_RET(cm, boolean, cm_pd_cmd_fix_end,
    cm_pd_cmd_cb_f_type*   ,BRIDLE_CHECK_NONE, 0,
    void                  *,BRIDLE_CHECK_NONE, 0,
    cm_client_id_type     ,BRIDLE_CHECK_NONE, 0
    )
#endif
#endif

////////////////////////////////////////////////////////////////////////////////

#ifndef BRIDLE_CM_IMPL
#define cm_mm_call_cmd_orig                        packbridle_cm_mm_call_cmd_orig						
#define cm_mm_call_cmd_answer                      packbridle_cm_mm_call_cmd_answer						
#define cm_mm_call_cmd_end                         packbridle_cm_mm_call_cmd_end						   
#define cm_mm_call_cmd_sups                        packbridle_cm_mm_call_cmd_sups						
#define cm_mm_call_cmd_privacy_pref                packbridle_cm_mm_call_cmd_privacy_pref				
#define cm_mm_call_cmd_get_call_info               packbridle_cm_mm_call_cmd_get_call_info			
#define cm_mm_call_cmd_setup_res                   packbridle_cm_mm_call_cmd_setup_res					
#define cm_mm_call_cmd_pdp_act_res                 packbridle_cm_mm_call_cmd_pdp_act_res				
#define cm_mm_call_cmd_pdp_modify                  packbridle_cm_mm_call_cmd_pdp_modify				
#define cm_mm_call_cmd_rab_reestablish             packbridle_cm_mm_call_cmd_rab_reestablish			
#ifdef FEATURE_PS_DORMANT_PWR_SAVE
#define cm_mm_ss_cmd_ps_data_available           packbridle_cm_mm_ss_cmd_ps_data_available		
#else
#define cm_mm_call_cmd_ps_data_available           packbridle_cm_mm_call_cmd_ps_data_available		
#endif
#define cm_nc_reg                                  packbridle_cm_nc_reg						            
#define cm_ph_cmd_oprt_mode                        packbridle_cm_ph_cmd_oprt_mode						
#define cm_ph_cmd_sys_sel_pref                     packbridle_cm_ph_cmd_sys_sel_pref					
#define cm_ph_cmd_ddtm_pref                        packbridle_cm_ph_cmd_ddtm_pref						
#define cm_ph_cmd_avoid_sys                        packbridle_cm_ph_cmd_avoid_sys						
#define cm_ph_cmd_answer_voice                     packbridle_cm_ph_cmd_answer_voice					
#define cm_ph_cmd_nam_sel                          packbridle_cm_ph_cmd_nam_sel						   
#define cm_ph_cmd_get_ph_info                      packbridle_cm_ph_cmd_get_ph_info						
#define cm_ph_cmd_rssi_delta_threshold             packbridle_cm_ph_cmd_rssi_delta_threshold			
#define cm_ph_cmd_subscription_available           packbridle_cm_ph_cmd_subscription_available		
#define cm_ph_cmd_subscription_not_available       packbridle_cm_ph_cmd_subscription_not_available	
#define cm_ph_cmd_subscription_changed             packbridle_cm_ph_cmd_subscription_changed			
#define cm_ph_cmd_get_networks                     packbridle_cm_ph_cmd_get_networks					
#define cm_ph_cmd_terminate_get_networks           packbridle_cm_ph_cmd_terminate_get_networks		
#define cm_ph_cmd_set_preferred_networks           packbridle_cm_ph_cmd_set_preferred_networks		
#define cm_ph_cmd_packet_state                     packbridle_cm_ph_cmd_packet_state					
#define cm_ph_cmd_voc_activity                     packbridle_cm_ph_cmd_voc_activity					
#define cm_ph_cmd_wakeup_from_standby              packbridle_cm_ph_cmd_wakeup_from_standby			
#define cm_ph_cmd_change_rtre_config               packbridle_cm_ph_cmd_change_rtre_config			
#define cm_ph_cmd_aoc_reset_acm                    packbridle_cm_ph_cmd_aoc_reset_acm					
#define cm_ph_cmd_aoc_set_acmmax                   packbridle_cm_ph_cmd_aoc_set_acmmax					
#define cm_ph_cmd_aoc_get_ccm                      packbridle_cm_ph_cmd_aoc_get_ccm						
#define cm_ph_cmd_aoc_get_acm                      packbridle_cm_ph_cmd_aoc_get_acm						
#define cm_ph_cmd_aoc_get_acmmax                   packbridle_cm_ph_cmd_aoc_get_acmmax					
#define cm_ph_cmd_aoc_get_puct                     packbridle_cm_ph_cmd_aoc_get_puct					
#define cm_ss_cmd_get_ss_info                      packbridle_cm_ss_cmd_get_ss_info						
#define cm_mm_inband_cmd_burst_dtmf                packbridle_cm_mm_inband_cmd_burst_dtmf				
#define cm_mm_inband_cmd_start_cont_dtmf           packbridle_cm_mm_inband_cmd_start_cont_dtmf		
#define cm_mm_inband_cmd_stop_cont_dtmf            packbridle_cm_mm_inband_cmd_stop_cont_dtmf		
#define cm_sms_cmd_mo_msg                          packbridle_cm_sms_cmd_mo_msg						   
#define cm_sms_cmd_awi_ack                         packbridle_cm_sms_cmd_awi_ack						   
#define cm_sms_cmd_bc_enable                       packbridle_cm_sms_cmd_bc_enable						
#define cm_pd_cmd_session_start                    packbridle_cm_pd_cmd_session_start					
#define cm_pd_cmd_session_end                      packbridle_cm_pd_cmd_session_end						
#ifdef FEATURE_GPSONE
#define cm_pd_cmd_reva_mo_msg                      packbridle_cm_pd_cmd_reva_mo_msg						
#endif
#define cm_pd_reg                                  packbridle_cm_pd_reg						            
#define cm_sups_cmd_register                       packbridle_cm_sups_cmd_register						
#define cm_sups_cmd_erase                          packbridle_cm_sups_cmd_erase						   
#define cm_sups_cmd_activate                       packbridle_cm_sups_cmd_activate						
#define cm_sups_cmd_deactivate                     packbridle_cm_sups_cmd_deactivate					
#define cm_sups_cmd_interrogate                    packbridle_cm_sups_cmd_interrogate					
#define cm_sups_cmd_process_uss                    packbridle_cm_sups_cmd_process_uss					
#define cm_sups_cmd_reg_password                   packbridle_cm_sups_cmd_reg_password					
#define cm_sups_cmd_release                        packbridle_cm_sups_cmd_release						
#define cm_sups_cmd_get_password_res               packbridle_cm_sups_cmd_get_password_res			
#define cm_sups_cmd_lcs_molr                       packbridle_cm_sups_cmd_lcs_molr						
#define cm_sups_cmd_lcs_location_notification_res  packbridle_cm_sups_cmd_lcs_location_notification_res
#define cm_sups_cmd_lcs_molr_completed             packbridle_cm_sups_cmd_lcs_molr_completed			
#define cm_sups_cmd_uss_notify_res                 packbridle_cm_sups_cmd_uss_notify_res				
#define cm_sups_cmd_uss_res                        packbridle_cm_sups_cmd_uss_res						
#define cm_dbm_cmd_mo_msg                          packbridle_cm_dbm_cmd_mo_msg						   
#define cm_client_init                             packbridle_cm_client_init						      
#define cm_client_release                          packbridle_cm_client_release						   
#define cm_mm_client_call_reg                      packbridle_cm_mm_client_call_reg						
#define cm_client_ph_reg                           packbridle_cm_client_ph_reg						   
#define cm_mm_client_ss_reg                        packbridle_cm_mm_client_ss_reg						
#define cm_mm_client_inband_reg                    packbridle_cm_mm_client_inband_reg					
#define cm_client_sms_reg                          packbridle_cm_client_sms_reg						   
#define cm_client_pd_reg                           packbridle_cm_client_pd_reg						   
#define cm_client_dbm_event_reg                    packbridle_cm_client_dbm_event_reg					
#define cm_client_dbm_class_reg                    packbridle_cm_client_dbm_class_reg					
#define cm_client_sups_reg                         packbridle_cm_client_sups_reg						   
#define cm_client_act                              packbridle_cm_client_act						      
#define cm_client_deact                            packbridle_cm_client_deact						      
#define cmclient_get_client_type                   packbridle_cmclient_get_client_type					
#define cm_change_m511_mode                        packbridle_cm_change_m511_mode						
#define cm_change_m512_mode                        packbridle_cm_change_m512_mode						
#define cm_change_m513_mode                        packbridle_cm_change_m513_mode						
#define cm_m51_mode_reg                            packbridle_cm_m51_mode_reg						      
#define cm_is_valid_mode_band_pref                 packbridle_cm_is_valid_mode_band_pref				
#define cm_is_valid_mode_pref                      packbridle_cm_is_valid_mode_pref						
#define cm_is_sys_mode_digital                     packbridle_cm_is_sys_mode_digital					
#define cm_get_pref_srv_type_for_packet_orig       packbridle_cm_get_pref_srv_type_for_packet_orig	
#define cm_get_curr_nam                            packbridle_cm_get_curr_nam						      
#define cm_get_cur_hybr_status                     packbridle_cm_get_cur_hybr_status					
#define cm_num_init                                packbridle_cm_num_init						         
#define cm_num_fill                                packbridle_cm_num_fill						         
#define cm_num_get                                 packbridle_cm_num_get						         
#define cm_num_cmp                                 packbridle_cm_num_cmp						         
#define cm_num_cmp_exact                           packbridle_cm_num_cmp_exact						   
#define cm_num_copy                                packbridle_cm_num_copy						         
#define cm_num_ep_msg_copy                         packbridle_cm_num_ep_msg_copy						   
#define cm_num_ep_cli_copy                         packbridle_cm_num_ep_cli_copy						   
#define cm_num_attrib_copy                         packbridle_cm_num_attrib_copy						   
#define cm_num_validate                            packbridle_cm_num_validate						      
#define cm_ext_disp_itr_reset                      packbridle_cm_ext_disp_itr_reset						
#define cm_ext_disp_itr_next                       packbridle_cm_ext_disp_itr_next						
#define cm_ext_disp_itr_more                       packbridle_cm_ext_disp_itr_more						
#define cm_ext_disp_itr_get                        packbridle_cm_ext_disp_itr_get						
#define cm_get_current_acq_sys_mode                packbridle_cm_get_current_acq_sys_mode				
#if defined FEATURE_HDR_HYBRID && defined FEATURE_GPSONE
#define cm_pd_cmd_fix_start                        packbridle_cm_pd_cmd_fix_start						
#define cm_pd_cmd_fix_end                          packbridle_cm_pd_cmd_fix_end						   
#endif
#endif /* !BRIDLE_CM_IMPL */

#endif /* BRIDLE_CM_H_ */
