/*======================================================
FILE:  BRIDLEInit_OEM.c

SERVICES:  Reference OEM specific BRIDLE Initialization table

GENERAL DESCRIPTION:
   This file contains the list of BRIDLE-ized modules 
   specific to OEM platform that need to be initialized. 
   These get initialized by the bridle_InitSWITable function. 


PUBLIC CLASSES AND STATIC FUNCTIONS:
   List the class(es) and static functions included in this file

INITIALIZATION & SEQUENCING REQUIREMENTS:

   See Exported Routines

        Copyright  1999-2003 QUALCOMM Incorporated.
               All Rights Reserved.
            QUALCOMM Proprietary/GTDR
=====================================================*/

#include "OEMFeatures.h"
#include "BRIDLEInit_OEM.h"

#ifndef AEE_SIMULATOR
#if defined(FEATURE_BREW_TAPI)
extern int RegisterPhoneForSWI(void *po);
#endif
#endif

const PFNBRIDLEINIT gOEMBridleInit[] = 
{
#if defined(OEMDISP) && defined(FEATURE_BRIDLE)
   RegisterOEMDispForSWI,
#endif // defined(OEMDISP)

#ifdef FEATURE_LOGGER_DMSS
   RegisterLoggerDMSSForSWI,
#endif /* FEATURE_LOGGER_DMSS */

#ifdef FEATURE_GSM1x
   RegisterGSM1xControlForSWI,
   RegisterGSM1xCardHandlerForSWI,
   RegisterGSM1xMessageForSWI,
   RegisterGSM1xSIGForSWI,
   RegisterGSMSMSForSWI,
#endif /* FEATURE_GSM1x */

#if defined(FEATURE_ADDRBOOK_RUIM)
   RegisterAddrBookRUIMForSWI,
#endif

#if defined(FEATURE_BREW_MULTIMEDIA)
   bridle_MediaCMX_RegisterSubSystem,
#endif //FEATURE_BREW_MULTIMEDIA

#ifndef AEE_SIMULATOR
#if defined(FEATURE_BREW_TAPI)
   RegisterPhoneForSWI,
#endif /* FEATURE_BREW_TAPI */

#if defined(FEATURE_OEMSVC)
   bridle_oemsvc_RegisterSubSystem,
#endif //FEATURE_OEMSVC
#endif
   
#if defined(FEATURE_ICM)
   bridle_cm_RegisterSubSystem,
#endif

   NULL
};
