#ifndef AEECLASSIDS_H
#define AEECLASSIDS_H
/*======================================================
FILE:  AEECLASSIDS.h

SERVICES:  AEE Classes

GENERAL DESCRIPTION:
        Base level definitions, typedefs, etc. for AEE

        Copyright  1999-2002 QUALCOMM Incorporated.
               All Rights Reserved.
            QUALCOMM Proprietary/GTDR
=====================================================*/

#define QVERSION                    0x01000000        // Most significant 8-bits are version

// CLSIDs (Class ID's)

#define AEECLSID_PRIV              (QVERSION)
#define AEECLSID_GROUPS            (QVERSION + 0x0800)
#define AEECLSID_CORE              (QVERSION + 0x1000)
#define AEECLSID_ENH               (QVERSION + 0x2000)
#define AEECLSID_CONTROL           (QVERSION + 0x3000)
#define AEECLSID_VIEW              (QVERSION + 0x4000)
#define AEECLSID_PROTO             (QVERSION + 0x5000)
#define AEECLSID_MULTIMEDIA        (QVERSION + 0x5500)
#define AEECLSID_OEM               (QVERSION + 0x6000)
#define AEECLSID_OEM_APP           (QVERSION + 0x7000)
#define AEECLSID_SAMPLE_APP        (QVERSION + 0x8000)
#define AEECLSID_USAGE_APP         (QVERSION + 0x9000)
#define AEECLSID_BREWFONTS         (QVERSION + 0xA000)

#define AEECLSID_APP               0x01010100
#define AEECLSID_APPLET            AEECLSID_APP
#define AEECLSID_SCREEN_SAVER      (AEECLSID_APP + 1)
#define AEECLSID_EXTENSION         0x01800000

// BREW Application Manager
#define AEECLSID_APPMANAGER        (AEECLSID_SAMPLE_APP)

#define AEECLSID_RANGE             (0x00000fff)

// Protected Classes - Cannot be updated

#define AEECLSID_DOWNLOAD          (AEECLSID_PRIV)
#define AEECLSID_QUERYINTERFACE    (AEECLSID_PRIV+1)
#define AEECLSID_COREAPP           (AEECLSID_PRIV+2)
#define AEECLSID_ADSQUERY          (AEECLSID_PRIV+3)
#define AEECLSID_CORENOTIFIER      (AEECLSID_PRIV+4)
#define AEECLSID_PRIV_LAST         (AEECLSID_PRIV+4)


// 
// Core Classes
//
#define AEECLSID_SHELL             (AEECLSID_CORE)
#define AEECLSID_DISPLAY           (AEECLSID_CORE+1)
#define AEECLSID_HEAP              (AEECLSID_CORE+2)
#define AEECLSID_FILEMGR           (AEECLSID_CORE+3)
#define AEECLSID_NET_10            (AEECLSID_CORE+5)
#define AEECLSID_TAPI              (AEECLSID_CORE+7)
#define AEECLSID_DBMGR             (AEECLSID_CORE+8)
#define AEECLSID_DIALOG            (AEECLSID_CORE+9)
#define AEECLSID_STATIC_10         (AEECLSID_CORE+10)
#define AEECLSID_SOUND_10          (AEECLSID_CORE+11)
#define AEECLSID_MEMASTREAM        (AEECLSID_CORE+12)
#define AEECLSID_PHONE             (AEECLSID_CORE+14)
#define AEECLSID_LICENSE           (AEECLSID_CORE+15)
#define AEECLSID_CERTCACHE         (AEECLSID_CORE+16)
#define AEECLSID_SOURCEUTIL        (AEECLSID_CORE+17)
#define AEECLSID_SOURCE            (AEECLSID_CORE+18)
#define AEECLSID_GETLINE           (AEECLSID_CORE+19)
#define AEECLSID_UNZIPSTREAM       (AEECLSID_CORE+20)
#define AEECLSID_MD5               (AEECLSID_CORE+21)
#define AEECLSID_RSCPOOL           (AEECLSID_CORE+22)
#define AEECLSID_THREAD            (AEECLSID_CORE+23)
#define AEECLSID_PORT              (AEECLSID_CORE+24)
#define AEECLSID_ARC4              (AEECLSID_CORE+25)
#define AEECLSID_RSA               (AEECLSID_CORE+26)
#define AEECLSID_POSDET_11         (AEECLSID_CORE+27)
#define AEECLSID_PEEK              (AEECLSID_CORE+28)
#define AEECLSID_PROVISION         (AEECLSID_CORE+29)
#define AEECLSID_RESTORE           (AEECLSID_CORE+30)
#define AEECLSID_PROVISIONITEM     (AEECLSID_CORE+31)
#define AEECLSID_CLIPBOARD         (AEECLSID_CORE+32)
#define AEECLSID_BITMAP            (AEECLSID_CORE+33)
#define AEECLSID_FONT              (AEECLSID_CORE+34)
#define AEECLSID_AEEDIB            (AEECLSID_CORE+35)
#define AEECLSID_DEVPORTMGR        (AEECLSID_CORE+36)
#define AEECLSID_SERIALPORTMGR     (AEECLSID_CORE+37)
#define AEECLSID_SERIALCONFIG      (AEECLSID_CORE+38)
#define AEECLSID_CONFIG            (AEECLSID_CORE+39)
#define AEECLSID_SPRITE            (AEECLSID_CORE+40)
#define AEECLSID_TRANSFORM         (AEECLSID_CORE+41)
#define AEECLSID_POSDET_20         (AEECLSID_CORE+42)
#define AEECLSID_DISPLAYCLONE      (AEECLSID_CORE+43)
#define AEECLSID_DIB_20            (AEECLSID_CORE+44)  // value of AEECLSID_DIB in 2.0
#define AEECLSID_SOCKET            (AEECLSID_CORE+45)
#define AEECLSID_NET               (AEECLSID_CORE+46)
#define AEECLSID_ASTREAM           (AEECLSID_CORE+47)
#define AEECLSID_BASE              (AEECLSID_CORE+48)
#define AEECLSID_X509CHAIN         (AEECLSID_CORE+49)
#define AEECLSID_SSLROOTCERTS      (AEECLSID_CORE+50)
#define AEECLSID_MD2               (AEECLSID_CORE+51)
#define AEECLSID_SHA1              (AEECLSID_CORE+52)
#define AEECLSID_DES_ENCRYPT       (AEECLSID_CORE+53)
#define AEECLSID_DES_DECRYPT       (AEECLSID_CORE+54)
#define AEECLSID_3DES_ENCRYPT      (AEECLSID_CORE+55)
#define AEECLSID_3DES_DECRYPT      (AEECLSID_CORE+56)
#define AEECLSID_MD5CTX            (AEECLSID_CORE+57)
#define AEECLSID_MD2CTX            (AEECLSID_CORE+58)
#define AEECLSID_SHA1CTX           (AEECLSID_CORE+59)
#define AEECLSID_RANDOM            (AEECLSID_CORE+60)
#define AEECLSID_RAMCACHE          (AEECLSID_CORE+61)
#define AEECLSID_REGISTRY          (AEECLSID_CORE+62)
#define AEECLSID_VIEWAPP           (AEECLSID_CORE+63)
#define AEECLSID_MOBILEID          (AEECLSID_CORE+64)
#define AEECLSID_POSDET_302        (AEECLSID_CORE+65)
#define AEECLSID_SERIAL            (AEECLSID_CORE+66)
#define AEECLSID_AES_ENCRYPT       (AEECLSID_CORE+67)
#define AEECLSID_AES_DECRYPT       (AEECLSID_CORE+68)
#define AEECLSID_DIB               (AEECLSID_CORE+69)
#define AEECLSID_FIFO              (AEECLSID_CORE+70)
#define AEECLSID_SEED_ENCRYPT      (AEECLSID_CORE+71)
#define AEECLSID_SEED_DECRYPT      (AEECLSID_CORE+72)
#define AEECLSID_HMAC_MD5          (AEECLSID_CORE+73)
#define AEECLSID_HMAC_MD2          (AEECLSID_CORE+74)
#define AEECLSID_HMAC_SHA1         (AEECLSID_CORE+75)
#define AEECLSID_HMAC_MD5CTX       (AEECLSID_CORE+76)
#define AEECLSID_HMAC_MD2CTX       (AEECLSID_CORE+77)
#define AEECLSID_HMAC_SHA1CTX      (AEECLSID_CORE+78)
#define AEECLSID_APPHISTORY        (AEECLSID_CORE+79)
#define AEECLSID_TELEPHONE         (AEECLSID_CORE+80)
#define AEECLSID_PHONENOTIFIER     (AEECLSID_CORE+81)
#define AEECLSID_CALLMGR           (AEECLSID_CORE+82)
#define AEECLSID_CALL              (AEECLSID_CORE+83)
#define AEECLSID_MULTIPARTYCALL    (AEECLSID_CORE+84)
#define AEECLSID_PHONECTL          (AEECLSID_CORE+85)
#define AEECLSID_SOUND             (AEECLSID_CORE+86)
#define AEECLSID_CALLORIGOPTS      (AEECLSID_CORE+87)
#define AEECLSID_APPLETCTL         (AEECLSID_CORE+88)
#define AEECLSID_POSDET            (AEECLSID_CORE+89)
#define AEECLSID_CORE_LAST         (AEECLSID_CORE+89)
#define AEECLSID_DEVICENOTIFIER    (AEECLSID_CORE+90)
//
// Enhanced Classes
//
#define AEECLSID_SOUNDPLAYER       (AEECLSID_ENH)
#define AEECLSID_GRAPHICS          (AEECLSID_ENH+1)
#define AEECLSID_VOICE             (AEECLSID_ENH+2)
#define AEECLSID_RINGERMGR         (AEECLSID_ENH+3)
#define AEECLSID_ADDRBOOK_20       (AEECLSID_ENH+4) 
#define AEECLSID_SAXREADER         (AEECLSID_ENH+5)
#define AEECLSID_SAXCONTENTHANDLER (AEECLSID_ENH+6)
#define AEECLSID_SAXATTRIBUTES     (AEECLSID_ENH+7)
#define AEECLSID_SAXLOCATOR        (AEECLSID_ENH+8)
//#define AEECLSID_BTSIOPORT         (AEECLSID_ENH+9)
#define AEECLSID_VOCODER           (AEECLSID_ENH+10)
//#define AEECLSID_BTSDP             (AEECLSID_ENH+11)
#define AEECLSID_CALLHISTORY_30    (AEECLSID_ENH+12)
#define AEECLSID_RUIM              (AEECLSID_ENH+13)
#define AEECLSID_LOGGER_FILE       (AEECLSID_ENH+14)
#define AEECLSID_LOGGER_SERIAL     (AEECLSID_ENH+15)
#define AEECLSID_LOGGER_DMSS       (AEECLSID_ENH+16)
#define AEECLSID_LOGGER_WIN        (AEECLSID_ENH+17)
#define AEECLSID_CAMERA            (AEECLSID_ENH+19)
//#define AEECLSID_BTAG              (AEECLSID_ENH+22)
#define AEECLSID_ADDRBOOK_21       (AEECLSID_ENH+23) 
#define AEECLSID_ADDRBOOK          (AEECLSID_ENH+24) 
#define AEECLSID_CALLHISTORY       (AEECLSID_ENH+25)
#define AEECLSID_ENH_LAST          (AEECLSID_ENH+25)

// AEECLSID_ENH + 0xff0 .. AEECLSID_ENH + 0xfff reserved

//
// UI Controls
//
#define AEECLSID_MENUCTL_10        (AEECLSID_CONTROL)
#define AEECLSID_SOFTKEYCTL_10     (AEECLSID_CONTROL+1)
#define AEECLSID_LISTCTL_10        (AEECLSID_CONTROL+2)
#define AEECLSID_ICONVIEWCTL_10    (AEECLSID_CONTROL+3)
#define AEECLSID_DATEPICKCTL       (AEECLSID_CONTROL+4)   
#define AEECLSID_DATECTL           (AEECLSID_CONTROL+5)   
#define AEECLSID_STOPWATCHCTL      (AEECLSID_CONTROL+6)
#define AEECLSID_CLOCKCTL          (AEECLSID_CONTROL+7)
#define AEECLSID_COUNTDOWNCTL      (AEECLSID_CONTROL+8)
#define AEECLSID_TEXTCTL           (AEECLSID_CONTROL+9)
#define AEECLSID_ACLOCKCTL         (AEECLSID_CONTROL+10)
#define AEECLSID_IMAGECTL          (AEECLSID_CONTROL+11)
#define AEECLSID_CONTROL_LAST      (AEECLSID_CONTROL+11)

// 1.NNN Versions...

#define AEECLSID_NET_11            (AEECLSID_NET_10 + 0x100)
#define AEECLSID_STATIC            (AEECLSID_STATIC_10 + 0x100)
#define AEECLSID_MENUCTL           (AEECLSID_MENUCTL_10 + 0x100)
#define AEECLSID_SOFTKEYCTL        (AEECLSID_SOFTKEYCTL_10 + 0x100)
#define AEECLSID_LISTCTL           (AEECLSID_LISTCTL_10 + 0x100)
#define AEECLSID_ICONVIEWCTL       (AEECLSID_ICONVIEWCTL_10 + 0x100)

//
// Viewers
//
#define AEECLSID_WINBMP             (AEECLSID_VIEW+1)
#define AEECLSID_NATIVEBMP          (AEECLSID_VIEW+2)
#define AEECLSID_GIF                (AEECLSID_VIEW+3)
#define AEECLSID_PNG                (AEECLSID_VIEW+4)
#define AEECLSID_JPEG               (AEECLSID_VIEW+5)
#define AEECLSID_BCI                (AEECLSID_VIEW+6)
#define AEECLSID_HTML               (AEECLSID_VIEW+7)
#define AEECLSID_VIEW_LAST          (AEECLSID_VIEW+7)


//
// Encodings
// 
#define AEECLSID_ENCODING		(AEECLSID_VIEW   + 0x100)

#define AEECLSID_ENCODING_UTF16		(AEECLSID_ENCODING + 0x01)
#define AEECLSID_ENCODING_UTF8		(AEECLSID_ENCODING + 0x02)
#define AEECLSID_ENCODING_USASCII	(AEECLSID_ENCODING_UTF8)
#define AEECLSID_ENCODING_ISOLATIN1	(AEECLSID_ENCODING + 0x03)


//
// Encoding Transformations
//
#define AEECLSID_ENCODE                   (AEECLSID_ENCODING + 0x200)

#define AEECLSID_ENCODE_UTF16TOUTF8       (AEECLSID_ENCODE + 0x01)
#define AEECLSID_ENCODE_ISOLATIN1TOUTF8   (AEECLSID_ENCODE + 0x02)

//
// Protocol Handlers
//
#define AEECLSID_WEB                (AEECLSID_PROTO)
#define AEECLSID_WEBUTIL            (AEECLSID_PROTO+1)
#define AEECLSID_WEBRESP            (AEECLSID_PROTO+2)
#define AEECLSID_WEBREQ             (AEECLSID_PROTO+3)
#define AEECLSID_WEBOPTS            (AEECLSID_PROTO+4)
#define AEECLSID_WEBENG             (AEECLSID_PROTO+5)
#define AEECLSID_DNS                (AEECLSID_PROTO+6)
#define AEECLSID_SSL                (AEECLSID_PROTO+7)
#define AEECLSID_SMSMSG             (AEECLSID_PROTO+8)
#define AEECLSID_SMS                (AEECLSID_PROTO+9)
#define AEECLSID_SMSNOTIFIER        (AEECLSID_PROTO+10)
#define AEECLSID_SMSSTORAGE         (AEECLSID_PROTO+11)
#define AEECLSID_SMSBCSRVOPTS       (AEECLSID_PROTO+12)
#define AEECLSID_SMSBCCONFIG        (AEECLSID_PROTO+13)
#define AEECLSID_SMSMAINCLIENT      (AEECLSID_PROTO+14)
#define AEECLSID_PROTO_LAST         (AEECLSID_PROTO+14)

#define AEECLSID_BROWSER            0x01007100

//
// Multimedia classes
//
#define AEECLSID_MEDIA              (AEECLSID_MULTIMEDIA)      
#define AEECLSID_MEDIAMIDI          (AEECLSID_MULTIMEDIA + 1)
#define AEECLSID_MEDIAMP3           (AEECLSID_MULTIMEDIA + 2)
#define AEECLSID_MEDIAQCP           (AEECLSID_MULTIMEDIA + 3)
#define AEECLSID_MEDIAPMD           (AEECLSID_MULTIMEDIA + 4)
#define AEECLSID_MEDIAMIDIOUTMSG    (AEECLSID_MULTIMEDIA + 5)
#define AEECLSID_MEDIAMIDIOUTQCP    (AEECLSID_MULTIMEDIA + 6)
#define AEECLSID_MEDIAMPEG4         (AEECLSID_MULTIMEDIA + 7)
#define AEECLSID_MEDIAMMF           (AEECLSID_MULTIMEDIA + 8)
#define AEECLSID_MEDIAPHR           (AEECLSID_MULTIMEDIA + 9)
#define AEECLSID_MEDIAADPCM         (AEECLSID_MULTIMEDIA + 10)
#define AEECLSID_MEDIAAAC           (AEECLSID_MULTIMEDIA + 11)
#define AEECLSID_MEDIAIMELODY       (AEECLSID_MULTIMEDIA + 12)
#define AEECLSID_MEDIAUTIL          (AEECLSID_MULTIMEDIA + 13)
#define AEECLSID_MEDIAAMR           (AEECLSID_MULTIMEDIA + 14)
#define AEECLSID_MEDIAHVS           (AEECLSID_MULTIMEDIA + 15)
#define AEECLSID_MEDIASAF           (AEECLSID_MULTIMEDIA + 16)
#define AEECLSID_MEDIAPCM           (AEECLSID_MULTIMEDIA + 17)
#define AEECLSID_MEDIAXMF           (AEECLSID_MULTIMEDIA + 18)
#define AEECLSID_MEDIADLS           (AEECLSID_MULTIMEDIA + 19)
#define AEECLSID_MULTIMEDIA_LAST    (AEECLSID_MULTIMEDIA + 19)

//
// Class IDs for OEM display devices
//

#define AEECLSID_DISPMAIN           (AEECLSID_OEM + 1)  
#define AEECLSID_DISP2              (AEECLSID_OEM + 2)   // Deprecated  
#define AEECLSID_DISP3              (AEECLSID_OEM + 3)   // Deprecated
#define AEECLSID_DISP4              (AEECLSID_OEM + 4)   // Deprecated
#define AEECLSID_OEM_LAST           (AEECLSID_OEM + 4)   

//
// Extension Classes
// 
#define AEECLSID_ENCODE_SHIFTJIS    (AEECLSID_EXTENSION + 1)


//
// Fonts
//

#define AEECLSID_FONT_FIXED4X6     (AEECLSID_BREWFONTS + 1)
#define AEECLSID_FONT_BASIC6       (AEECLSID_BREWFONTS + 2)
#define AEECLSID_FONT_BASIC9       (AEECLSID_BREWFONTS + 3)
#define AEECLSID_FONT_BASIC10      (AEECLSID_BREWFONTS + 4)
#define AEECLSID_FONT_BASIC11      (AEECLSID_BREWFONTS + 5)
#define AEECLSID_FONT_BASIC11B     (AEECLSID_BREWFONTS + 6)
#define AEECLSID_FONT_BASIC14      (AEECLSID_BREWFONTS + 7)
#define AEECLSID_FONT_BASIC12      (AEECLSID_BREWFONTS + 8)
#define AEECLSID_FONT_BASIC12B     (AEECLSID_BREWFONTS + 9)
#define AEECLSID_FONT_BASIC15      (AEECLSID_BREWFONTS + 10)
#define AEECLSID_BREWFONTS_LAST    (AEECLSID_BREWFONTS + 10)

#define AEECLSID_BITFONTFOUNDRY    (AEECLSID_BREWFONTS + 0x100)

#endif   // AEECLASSIDS_H

/*=============================================================================
  CLASSES DOCUMENTATION
===============================================================================

AEECLSID

===H2> CLSIDs (Class ID's) 
===/H2>

AEECLSID_PRIV              (QVERSION)    ~
AEECLSID_GROUPS            (QVERSION + 0x0800)    ~
AEECLSID_CORE              (QVERSION + 0x1000)    ~
AEECLSID_ENH               (QVERSION + 0x2000)    ~
AEECLSID_CONTROL           (QVERSION + 0x3000)    ~
AEECLSID_VIEW              (QVERSION + 0x4000)    ~
AEECLSID_PROTO             (QVERSION + 0x5000)    ~
AEECLSID_MULTIMEDIA        (QVERSION + 0x5500)    ~
AEECLSID_OEM               (QVERSION + 0x6000)    ~
AEECLSID_OEM_APP           (QVERSION + 0x7000)    ~
AEECLSID_SAMPLE_APP        (QVERSION + 0x8000)    ~
AEECLSID_USAGE_APP         (QVERSION + 0x9000)    ~
AEECLSID_BREWFONTS         (QVERSION + 0xA000)    ~

AEECLSID_APP               0x01010100
AEECLSID_APPLET            AEECLSID_APP
AEECLSID_SCREEN_SAVER      (AEECLSID_APP + 1)    ~
AEECLSID_EXTENSION         0x01800000

===H2> BREW Application Manager 
===/H2>
AEECLSID_APPMANAGER        (AEECLSID_SAMPLE_APP)    ~

AEECLSID_RANGE             (0x00000fff)    ~

===H2> Protected Classes
===/H2>

AEECLSID_DOWNLOAD          (AEECLSID_PRIV)    ~
AEECLSID_QUERYINTERFACE    (AEECLSID_PRIV+1)    ~
AEECLSID_COREAPP           (AEECLSID_PRIV+2)    ~
AEECLSID_ADSQUERY          (AEECLSID_PRIV+3)    ~
AEECLSID_CORENOTIFIER      (AEECLSID_PRIV+4)    ~
AEECLSID_PRIV_LAST         (AEECLSID_PRIV+4)    ~



===H2> Core Classes 
===/H2>

AEECLSID_SHELL             (AEECLSID_CORE)    ~
AEECLSID_DISPLAY           (AEECLSID_CORE+1)    ~
AEECLSID_HEAP              (AEECLSID_CORE+2)    ~
AEECLSID_FILEMGR           (AEECLSID_CORE+3)    ~
AEECLSID_NET_10            (AEECLSID_CORE+5)    ~
AEECLSID_TAPI              (AEECLSID_CORE+7)    ~
AEECLSID_DBMGR             (AEECLSID_CORE+8)    ~
AEECLSID_DIALOG            (AEECLSID_CORE+9)    ~
AEECLSID_STATIC_10         (AEECLSID_CORE+10)    ~
AEECLSID_SOUND_10          (AEECLSID_CORE+11)    ~
AEECLSID_MEMASTREAM        (AEECLSID_CORE+12)    ~
AEECLSID_PHONE             (AEECLSID_CORE+14)    ~
AEECLSID_LICENSE           (AEECLSID_CORE+15)    ~
AEECLSID_CERTCACHE         (AEECLSID_CORE+16)    ~
AEECLSID_SOURCEUTIL        (AEECLSID_CORE+17)    ~
AEECLSID_SOURCE            (AEECLSID_CORE+18)    ~
AEECLSID_GETLINE           (AEECLSID_CORE+19)    ~
AEECLSID_UNZIPSTREAM       (AEECLSID_CORE+20)    ~
AEECLSID_MD5               (AEECLSID_CORE+21)    ~
AEECLSID_RSCPOOL           (AEECLSID_CORE+22)    ~
AEECLSID_THREAD            (AEECLSID_CORE+23)    ~
AEECLSID_PORT              (AEECLSID_CORE+24)    ~
AEECLSID_ARC4              (AEECLSID_CORE+25)    ~
AEECLSID_RSA               (AEECLSID_CORE+26)    ~
AEECLSID_POSDET_11         (AEECLSID_CORE+27)    ~
AEECLSID_PEEK              (AEECLSID_CORE+28)    ~
AEECLSID_PROVISION         (AEECLSID_CORE+29)    ~
AEECLSID_RESTORE           (AEECLSID_CORE+30)    ~
AEECLSID_PROVISIONITEM     (AEECLSID_CORE+31)    ~
AEECLSID_CLIPBOARD         (AEECLSID_CORE+32)    ~
AEECLSID_BITMAP            (AEECLSID_CORE+33)    ~
AEECLSID_FONT              (AEECLSID_CORE+34)    ~
AEECLSID_AEEDIB            (AEECLSID_CORE+35)    ~
AEECLSID_DEVPORTMGR        (AEECLSID_CORE+36)    ~
AEECLSID_SERIALPORTMGR     (AEECLSID_CORE+37)    ~
AEECLSID_SERIALCONFIG      (AEECLSID_CORE+38)    ~
AEECLSID_CONFIG            (AEECLSID_CORE+39)    ~
AEECLSID_SPRITE            (AEECLSID_CORE+40)    ~
AEECLSID_TRANSFORM         (AEECLSID_CORE+41)    ~
AEECLSID_POSDET_20         (AEECLSID_CORE+42)    ~
AEECLSID_DISPLAYCLONE      (AEECLSID_CORE+43)    ~
AEECLSID_DIB_20            (AEECLSID_CORE+44)    ~ //  value of AEECLSID_DIB in 2.0
AEECLSID_SOCKET            (AEECLSID_CORE+45)    ~
AEECLSID_NET               (AEECLSID_CORE+46)    ~
AEECLSID_ASTREAM           (AEECLSID_CORE+47)    ~
AEECLSID_BASE              (AEECLSID_CORE+48)    ~
AEECLSID_X509CHAIN         (AEECLSID_CORE+49)    ~
AEECLSID_SSLROOTCERTS      (AEECLSID_CORE+50)    ~
AEECLSID_MD2               (AEECLSID_CORE+51)    ~
AEECLSID_SHA1              (AEECLSID_CORE+52)    ~
AEECLSID_DES_ENCRYPT       (AEECLSID_CORE+53)    ~
AEECLSID_DES_DECRYPT       (AEECLSID_CORE+54)    ~
AEECLSID_3DES_ENCRYPT      (AEECLSID_CORE+55)    ~
AEECLSID_3DES_DECRYPT      (AEECLSID_CORE+56)    ~
AEECLSID_MD5CTX            (AEECLSID_CORE+57)    ~
AEECLSID_MD2CTX            (AEECLSID_CORE+58)    ~
AEECLSID_SHA1CTX           (AEECLSID_CORE+59)    ~
AEECLSID_RANDOM            (AEECLSID_CORE+60)    ~
AEECLSID_RAMCACHE          (AEECLSID_CORE+61)    ~
AEECLSID_REGISTRY          (AEECLSID_CORE+62)    ~
AEECLSID_VIEWAPP           (AEECLSID_CORE+63)    ~
AEECLSID_MOBILEID          (AEECLSID_CORE+64)    ~
AEECLSID_POSDET_302        (AEECLSID_CORE+65)    ~
AEECLSID_SERIAL            (AEECLSID_CORE+66)    ~
AEECLSID_AES_ENCRYPT       (AEECLSID_CORE+67)    ~
AEECLSID_AES_DECRYPT       (AEECLSID_CORE+68)    ~
AEECLSID_DIB               (AEECLSID_CORE+69)    ~
AEECLSID_FIFO              (AEECLSID_CORE+70)    ~
AEECLSID_SEED_ENCRYPT      (AEECLSID_CORE+71)    ~
AEECLSID_SEED_DECRYPT      (AEECLSID_CORE+72)    ~
AEECLSID_HMAC_MD5          (AEECLSID_CORE+73)    ~
AEECLSID_HMAC_MD2          (AEECLSID_CORE+74)    ~
AEECLSID_HMAC_SHA1         (AEECLSID_CORE+75)    ~
AEECLSID_HMAC_MD5CTX       (AEECLSID_CORE+76)    ~
AEECLSID_HMAC_MD2CTX       (AEECLSID_CORE+77)    ~
AEECLSID_HMAC_SHA1CTX      (AEECLSID_CORE+78)    ~
AEECLSID_APPHISTORY        (AEECLSID_CORE+79)    ~
AEECLSID_TELEPHONE         (AEECLSID_CORE+80)    ~
AEECLSID_PHONENOTIFIER     (AEECLSID_CORE+81)    ~
AEECLSID_CALLMGR           (AEECLSID_CORE+82)    ~
AEECLSID_CALL              (AEECLSID_CORE+83)    ~
AEECLSID_MULTIPARTYCALL    (AEECLSID_CORE+84)    ~
AEECLSID_PHONECTL          (AEECLSID_CORE+85)    ~
AEECLSID_SOUND             (AEECLSID_CORE+86)    ~
AEECLSID_CALLORIGOPTS      (AEECLSID_CORE+87)    ~
AEECLSID_APPLETCTL         (AEECLSID_CORE+88)    ~
AEECLSID_POSDET            (AEECLSID_CORE+89)    ~
AEECLSID_CORE_LAST         (AEECLSID_CORE+89)    ~
AEECLSID_DEVICENOTIFIER    (AEECLSID_CORE+90)    ~

===H2> Enhanced Classes 
===/H2>

AEECLSID_SOUNDPLAYER       (AEECLSID_ENH)    ~
AEECLSID_GRAPHICS          (AEECLSID_ENH+1)    ~
AEECLSID_VOICE             (AEECLSID_ENH+2)    ~
AEECLSID_RINGERMGR         (AEECLSID_ENH+3)    ~
AEECLSID_ADDRBOOK_20       (AEECLSID_ENH+4)    ~ 
AEECLSID_SAXREADER         (AEECLSID_ENH+5)    ~
AEECLSID_SAXCONTENTHANDLER (AEECLSID_ENH+6)    ~
AEECLSID_SAXATTRIBUTES     (AEECLSID_ENH+7)    ~
AEECLSID_SAXLOCATOR        (AEECLSID_ENH+8)    ~
//AEECLSID_BTSIOPORT         (AEECLSID_ENH+9)    ~
AEECLSID_VOCODER           (AEECLSID_ENH+10)    ~
//AEECLSID_BTSDP             (AEECLSID_ENH+11)    ~
AEECLSID_CALLHISTORY_30    (AEECLSID_ENH+12)    ~
AEECLSID_RUIM              (AEECLSID_ENH+13)    ~
AEECLSID_LOGGER_FILE       (AEECLSID_ENH+14)    ~
AEECLSID_LOGGER_SERIAL     (AEECLSID_ENH+15)    ~
AEECLSID_LOGGER_DMSS       (AEECLSID_ENH+16)    ~
AEECLSID_LOGGER_WIN        (AEECLSID_ENH+17)    ~
AEECLSID_CAMERA            (AEECLSID_ENH+19)    ~
//AEECLSID_BTAG              (AEECLSID_ENH+22)    ~
AEECLSID_ADDRBOOK_21       (AEECLSID_ENH+23)    ~ 
AEECLSID_ADDRBOOK          (AEECLSID_ENH+24)    ~ 
AEECLSID_CALLHISTORY       (AEECLSID_ENH+25)    ~
AEECLSID_ENH_LAST          (AEECLSID_ENH+25)    ~

===H2> AEECLSID_ENH + 0xff0 .. AEECLSID_ENH + 0xfff reserved 
===/H2>


===H2> UI Controls 
===/H2>

AEECLSID_MENUCTL_10        (AEECLSID_CONTROL)    ~
AEECLSID_SOFTKEYCTL_10     (AEECLSID_CONTROL+1)    ~
AEECLSID_LISTCTL_10        (AEECLSID_CONTROL+2)    ~
AEECLSID_ICONVIEWCTL_10    (AEECLSID_CONTROL+3)    ~
AEECLSID_DATEPICKCTL       (AEECLSID_CONTROL+4)    ~   
AEECLSID_DATECTL           (AEECLSID_CONTROL+5)    ~   
AEECLSID_STOPWATCHCTL      (AEECLSID_CONTROL+6)    ~
AEECLSID_CLOCKCTL          (AEECLSID_CONTROL+7)    ~
AEECLSID_COUNTDOWNCTL      (AEECLSID_CONTROL+8)    ~
AEECLSID_TEXTCTL           (AEECLSID_CONTROL+9)    ~
AEECLSID_ACLOCKCTL         (AEECLSID_CONTROL+10)    ~
AEECLSID_IMAGECTL          (AEECLSID_CONTROL+11)    ~
AEECLSID_CONTROL_LAST      (AEECLSID_CONTROL+11)    ~

===H2> 1.NNN Versions
===/H2>

AEECLSID_NET_11            (AEECLSID_NET_10 + 0x100)    ~
AEECLSID_STATIC            (AEECLSID_STATIC_10 + 0x100)    ~
AEECLSID_MENUCTL           (AEECLSID_MENUCTL_10 + 0x100)    ~
AEECLSID_SOFTKEYCTL        (AEECLSID_SOFTKEYCTL_10 + 0x100)    ~
AEECLSID_LISTCTL           (AEECLSID_LISTCTL_10 + 0x100)    ~
AEECLSID_ICONVIEWCTL       (AEECLSID_ICONVIEWCTL_10 + 0x100)    ~


===H2> Viewers 
===/H2>

AEECLSID_WINBMP             (AEECLSID_VIEW+1)    ~
AEECLSID_NATIVEBMP          (AEECLSID_VIEW+2)    ~
AEECLSID_GIF                (AEECLSID_VIEW+3)    ~
AEECLSID_PNG                (AEECLSID_VIEW+4)    ~
AEECLSID_JPEG               (AEECLSID_VIEW+5)    ~
AEECLSID_BCI                (AEECLSID_VIEW+6)    ~
AEECLSID_HTML               (AEECLSID_VIEW+7)    ~
AEECLSID_VIEW_LAST          (AEECLSID_VIEW+7)    ~



===H2> Encodings 
===/H2>

AEECLSID_ENCODING

AEECLSID_ENCODING_UTF16
AEECLSID_ENCODING_UTF8
AEECLSID_ENCODING_USASCII
AEECLSID_ENCODING_ISOLATIN1



===H2> Encoding Transformations 
===/H2>

AEECLSID_ENCODE                   (AEECLSID_ENCODING + 0x200)    ~

AEECLSID_ENCODE_UTF16TOUTF8       (AEECLSID_ENCODE + 0x01)    ~
AEECLSID_ENCODE_ISOLATIN1TOUTF8   (AEECLSID_ENCODE + 0x02)    ~


===H2> Protocol Handlers 
===/H2>

AEECLSID_WEB                (AEECLSID_PROTO)    ~
AEECLSID_WEBUTIL            (AEECLSID_PROTO+1)    ~
AEECLSID_WEBRESP            (AEECLSID_PROTO+2)    ~
AEECLSID_WEBREQ             (AEECLSID_PROTO+3)    ~
AEECLSID_WEBOPTS            (AEECLSID_PROTO+4)    ~
AEECLSID_WEBENG             (AEECLSID_PROTO+5)    ~
AEECLSID_DNS                (AEECLSID_PROTO+6)    ~
AEECLSID_SSL                (AEECLSID_PROTO+7)    ~
AEECLSID_SMSMSG             (AEECLSID_PROTO+8)    ~
AEECLSID_SMS                (AEECLSID_PROTO+9)    ~
AEECLSID_SMSNOTIFIER        (AEECLSID_PROTO+10)    ~
AEECLSID_SMSSTORAGE         (AEECLSID_PROTO+11)    ~
AEECLSID_SMSBCSRVOPTS       (AEECLSID_PROTO+12)    ~
AEECLSID_SMSBCCONFIG        (AEECLSID_PROTO+13)    ~
AEECLSID_SMSMAINCLIENT      (AEECLSID_PROTO+14)    ~
AEECLSID_PROTO_LAST         (AEECLSID_PROTO+14)    ~

AEECLSID_BROWSER            0x01007100


===H2> Multimedia classes 
===/H2>

AEECLSID_MEDIA              (AEECLSID_MULTIMEDIA)    ~      
AEECLSID_MEDIAMIDI          (AEECLSID_MULTIMEDIA + 1)    ~
AEECLSID_MEDIAMP3           (AEECLSID_MULTIMEDIA + 2)    ~
AEECLSID_MEDIAQCP           (AEECLSID_MULTIMEDIA + 3)    ~
AEECLSID_MEDIAPMD           (AEECLSID_MULTIMEDIA + 4)    ~
AEECLSID_MEDIAMIDIOUTMSG    (AEECLSID_MULTIMEDIA + 5)    ~
AEECLSID_MEDIAMIDIOUTQCP    (AEECLSID_MULTIMEDIA + 6)    ~
AEECLSID_MEDIAMPEG4         (AEECLSID_MULTIMEDIA + 7)    ~
AEECLSID_MEDIAMMF           (AEECLSID_MULTIMEDIA + 8)    ~
AEECLSID_MEDIAPHR           (AEECLSID_MULTIMEDIA + 9)    ~
AEECLSID_MEDIAADPCM         (AEECLSID_MULTIMEDIA + 10)    ~
AEECLSID_MEDIAAAC           (AEECLSID_MULTIMEDIA + 11)    ~
AEECLSID_MEDIAIMELODY       (AEECLSID_MULTIMEDIA + 12)    ~
AEECLSID_MEDIAUTIL          (AEECLSID_MULTIMEDIA + 13)    ~
AEECLSID_MEDIAAMR           (AEECLSID_MULTIMEDIA + 14)    ~
AEECLSID_MEDIAHVS           (AEECLSID_MULTIMEDIA + 15)    ~
AEECLSID_MEDIASAF           (AEECLSID_MULTIMEDIA + 16)    ~
AEECLSID_MEDIAPCM           (AEECLSID_MULTIMEDIA + 17)    ~
AEECLSID_MEDIAXMF           (AEECLSID_MULTIMEDIA + 18)    ~
AEECLSID_MEDIADLS           (AEECLSID_MULTIMEDIA + 19)    ~
AEECLSID_MULTIMEDIA_LAST    (AEECLSID_MULTIMEDIA + 19)    ~


===H2> Class IDs for OEM display devices 
===/H2>


AEECLSID_DISPMAIN           (AEECLSID_OEM + 1)    ~  
AEECLSID_DISP2              (AEECLSID_OEM + 2)    ~   // Deprecated  
AEECLSID_DISP3              (AEECLSID_OEM + 3)    ~   // Deprecated
AEECLSID_DISP4              (AEECLSID_OEM + 4)    ~   // Deprecated
AEECLSID_OEM_LAST           (AEECLSID_OEM + 4)    ~   


===H2> Extension Classes 
===/H2>

AEECLSID_ENCODE_SHIFTJIS    (AEECLSID_EXTENSION + 1)    ~



===H2> Fonts 
===/H2>


AEECLSID_FONT_FIXED4X6     (AEECLSID_BREWFONTS + 1)    ~
AEECLSID_FONT_BASIC6       (AEECLSID_BREWFONTS + 2)    ~
AEECLSID_FONT_BASIC9       (AEECLSID_BREWFONTS + 3)    ~
AEECLSID_FONT_BASIC10      (AEECLSID_BREWFONTS + 4)    ~
AEECLSID_FONT_BASIC11      (AEECLSID_BREWFONTS + 5)    ~
AEECLSID_FONT_BASIC11B     (AEECLSID_BREWFONTS + 6)    ~
AEECLSID_FONT_BASIC14      (AEECLSID_BREWFONTS + 7)    ~
AEECLSID_FONT_BASIC12      (AEECLSID_BREWFONTS + 8)    ~
AEECLSID_FONT_BASIC12B     (AEECLSID_BREWFONTS + 9)    ~
AEECLSID_FONT_BASIC15      (AEECLSID_BREWFONTS + 10)    ~
AEECLSID_BREWFONTS_LAST    (AEECLSID_BREWFONTS + 10)    ~

AEECLSID_BITFONTFOUNDRY    (AEECLSID_BREWFONTS + 0x100)    ~
 
============================================================================*/
