#ifndef _IADDR_H_
#define _IADDR_H_
/*===========================================================================================

FILE            : IADDR.h

SERVICES        : IADDR Interface

DESCRIPTION     :
   This file provides the interface specification for
   the ADDRBOOK Interface for KDDI

PUBLIC CLASSES  : Not Applicable

INITIALIZATION AND SEQUENCING REQUIREMENTS :

      Copyright  1999-2004 QUALCOMM Incorporated.
               All Rights Reserved.
            QUALCOMM Proprietary/GTDR

===========================================================================================*/

/*===========================================================================================

                        EDIT HISTORY FOR MODULE

When        Who    what, where, why
----------  -----  --------------------------------------------------------------------------
10/26/04           VK쐬
05/30/05    ˎR   uADDRBOOK_MAX_PHOTO_FILE_NAME_LENGTHv̒`l45256ɕύX @PTX804-001
05/30/05    ˎR   d`폜                                                     @PTX804-002
05/30/05    ˎR   \́uADDR_BOOK_INFOṽouwMailNumvǉΉ             @PTX804-003
yPTX805ɔŗz
10/19/05    ˎR   includeǉ (KDDI_ADDR_CREDENTIAL.BID)                           @PTX805-004

===========================================================================================*/
/******************************************************************************
//  [PTX-804C]
//		PTX-804 BREW-20050304002 NJK  
//		       IAddr_SearchNoAIAddr_GetGroupName̎Ή
******************************************************************************/

/*===========================================================================================
 INCLUDES AND VARIABLE DEFINITIONS
===========================================================================================*/
/*-------------------------------------------------------------------------------------------
   Defines
-------------------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------------------
   Include Files
-------------------------------------------------------------------------------------------*/
#include "AEE.h"
#include "IADDR.BID"
/* .Start ADD Kiriyama @PTX805-004 */
#include "KDDI_ADDR_CREDENTIAL.BID"
/* .End   ADD Kiriyama @PTX805-004 */

typedef struct IAddr IAddr;

/*-------------------------------------------------------------------------------------------
   Constant Declarations
-------------------------------------------------------------------------------------------*/
#define ADDR_BOOK_RECORD_VERSION                 1

#define ADDRBOOK_MAX_NAME_LENGTH                24    // O
#define ADDRBOOK_MAX_YOMI_LENGTH                24    // ǂ
#define ADDRBOOK_MAX_TEL_NO_LENGTH              36    // dbԍ
#define ADDRBOOK_MAX_MAIL_ADDR_LENGTH           64    // E[AhX
#define ADDRBOOK_MAX_BIRTHDAY_LENGTH            10    // a
#define ADDRBOOK_MAX_HOBBY_LENGTH               20    // 
#define ADDRBOOK_MAX_ADDRESS_LENGTH             80    // Z
#define ADDRBOOK_MAX_URL_LENGTH                 256   // URL
#define ADDRBOOK_MAX_MEMO_LENGTH                80    // 
#define ADDRBOOK_MAX_LOCATION_LENGTH            66    // ʒu
/* .Start Kiriyama @PTX804-001 */
//#define ADDRBOOK_MAX_PHOTO_FILE_NAME_LENGTH     45    // PHOTO
#define ADDRBOOK_MAX_PHOTO_FILE_NAME_LENGTH     256   // PHOTO
/* .End   Kiriyama @PTX804-001 */
#define ADDRBOOK_MAX_POSTAL_NO_LENGTH           10    // X֔ԍ
#define ADDRBOOK_MAX_ORGANIZATION_LENGTH        40    // gD
#define ADDRBOOK_MAX_SECTION_LENGTH             40    // 


#define FIELD_MASK_LAST_MODIFY            0x00000001  // ŏI
#define FIELD_MASK_GROUP_NO               0x00000002  // O[vNo.
#define FIELD_MASK_MEMORY_NO              0x00000004  // No.
#define FIELD_MASK_SECRET                 0x00000008  // V[Nbg
#define FIELD_MASK_NAME                   0x00000010  // O
#define FIELD_MASK_YOMI                   0x00000020  // ǂ
#define FIELD_MASK_TEL_NO1                0x00000040  // dbԍP
#define FIELD_MASK_TEL_NO2                0x00000080  // dbԍQ
#define FIELD_MASK_TEL_NO3                0x00000100  // dbԍR
#define FIELD_MASK_MAIL_ADDR1             0x00000200  // E[AhXP
#define FIELD_MASK_MAIL_ADDR2             0x00000400  // E[AhXQ
#define FIELD_MASK_MAIL_ADDR3             0x00000800  // E[AhXR
#define FIELD_MASK_BIRTHDAY               0x00001000  // a
#define FIELD_MASK_HOBBY                  0x00002000  // 
#define FIELD_MASK_ADDRESS                0x00004000  // Z
#define FIELD_MASK_URL                    0x00008000  // URL
#define FIELD_MASK_MEMO                   0x00010000  // 
#define FIELD_MASK_CONSTELLATION          0x00020000  // 
#define FIELD_MASK_BLOOD                  0x00040000  // t^
#define FIELD_MASK_LOCATION               0x00080000  // ʒu
#define FIELD_MASK_PHOTO                  0x00100000  // PHOTO
#define FIELD_MASK_POSTAL_NO              0x00200000  // X֔ԍ
#define FIELD_MASK_ORGANIZATION           0x00400000  // gD
#define FIELD_MASK_SECTION                0x00800000  // 

//PTX-804 EMUI-20050218001 NJK  

//
//	\̂̃o[Wԍ
//
/* .Start Kiriyama @PTX804-002 */
//#define	ADDR_BOOK_RECORD_VERSION				1
/* .End   Kiriyama @PTX804-002 */
//
//	etB[h̍ő咷
//
//	łtB[h̍ő咷B̒͏I[(0x00)͊܂܂ȂB
//
/* .Start Kiriyama @PTX804-002 */
//#define	ADDRBOOK_MAX_NAME_LENGTH 				24		// O
//#define	ADDRBOOK_MAX_YOMI_LENGTH 				24		// ǂ
//#define	ADDRBOOK_MAX_TEL_NO_LENGTH 			36		// dbԍ
//#define	ADDRBOOK_MAX_MAIL_ADDR_LENGTH 		64		// E[AhX
//#define	ADDRBOOK_MAX_BIRTHDAY_LENGTH 			10		// a
//#define	ADDRBOOK_MAX_HOBBY_LENGTH 				20		// 
//#define	ADDRBOOK_MAX_ADDRESS_LENGTH 			80		// Z
//#define	ADDRBOOK_MAX_URL_LENGTH 				256	// URL
//#define	ADDRBOOK_MAX_MEMO_LENGTH 				80		// 
// Porting Package-Nakagomi-11/21/03 [S]
//#define	ADDRBOOK_MAX_LOCATION_LENGTH 			66		// ʒu
// Porting Package-Nakagomi-11/21/03 [E]
//#define	ADDRBOOK_MAX_PHOTO_FILE_NAME_LENGTH	45		// 摜t@C
//#define	ADDRBOOK_MAX_POSTAL_NO_LENGTH			10		// X֔ԍ
//#define	ADDRBOOK_MAX_ORGANIZATION_LENGTH		40		// gD
//#define	ADDRBOOK_MAX_SECTION_LENGTH			40		// 
//PTX-804 EMUI-20050218001 NJK  
/* .End   Kiriyama @PTX804-002 */

//
//	db
//
#define ADDRBOOK_TEL_ATTR_NONE                  0     // Ȃ
#define ADDRBOOK_TEL_ATTR_CELLULAR              1     // g
#define ADDRBOOK_TEL_ATTR_PHS                   2     // PHS
#define ADDRBOOK_TEL_ATTR_HOME                  3     // 
#define ADDRBOOK_TEL_ATTR_OFFICE                4     // d
#define ADDRBOOK_TEL_ATTR_FAX                   5     // FAX

//
//	EMAIL
//
#define ADDRBOOK_EMAIL_ATTR_NONE                0     // Ȃ
#define ADDRBOOK_EMAIL_ATTR_CELLULAR            1     // g
#define ADDRBOOK_EMAIL_ATTR_PHS                 2     // PHS
#define ADDRBOOK_EMAIL_ATTR_HOME                3     // 
#define ADDRBOOK_EMAIL_ATTR_SCHOOL              4     // wZ
#define ADDRBOOK_EMAIL_ATTR_OFFICE              5     // d

//
//	Z
//
#define ADDRBOOK_ADDRESS_ATTR_NONE              0     // Ȃ
#define ADDRBOOK_ADDRESS_ATTR_HOME              1     // 
#define ADDRBOOK_ADDRESS_ATTR_OFFICE            2     // d

//
//	t^
//
#define ADDRBOOK_BLOOD_NONE                     0     // Ȃ
#define ADDRBOOK_BLOOD_A                        1     // A^
#define ADDRBOOK_BLOOD_B                        2     // B^
#define ADDRBOOK_BLOOD_O                        3     // O^
#define ADDRBOOK_BLOOD_AB                       4     // AB^

//
//	
//
#define ADDRBOOK_CONSTELLATION_NONE             0     // Ȃ
#define ADDRBOOK_CONSTELLATION_ARIES            1     // r
#define ADDRBOOK_CONSTELLATION_TAURUS           2     // 
#define ADDRBOOK_CONSTELLATION_GEMINI           3     // oq
#define ADDRBOOK_CONSTELLATION_CANCER           4     // I
#define ADDRBOOK_CONSTELLATION_LEO              5     // q
#define ADDRBOOK_CONSTELLATION_VIRGO            6     // 
#define ADDRBOOK_CONSTELLATION_LIBRA            7     // V
#define ADDRBOOK_CONSTELLATION_SCORPIO          8     // 嶍
#define ADDRBOOK_CONSTELLATION_OPHIUCHUS        9     // ֌
#define ADDRBOOK_CONSTELLATION_SAGITTARIUS      10    // ˎ
#define ADDRBOOK_CONSTELLATION_CAPRICORN        11    // Rr
#define ADDRBOOK_CONSTELLATION_AQUARIUS         12    // r
#define ADDRBOOK_CONSTELLATION_PISCES           13    // 


#define MEM_NO_STATUS_UNUSED                    0     // gp
#define MEM_NO_STATUS_USED                      1     // gp
#define MEM_NO_STATUS_SECRET                    2     // V[NbgŎgp


#define MEMORY_NO_AUTO                     0xffff     //  ԍ擾

//PTX-804 BREW-20050304002 NJK  
#define SEARCHNO_INPUTMODE_DIALNUM						0
#define SEARCHNO_INPUTMODE_MAILADD						1
#define SEARCHNO_OUTPUTMODE_MEMORYNUM					0
#define SEARCHNO_OUTPUTMODE_GROUPNUM					1
//PTX-804 BREW-20050304002 NJK  

/*-------------------------------------------------------------------------------------------
   Type Declarations
-------------------------------------------------------------------------------------------*/

typedef struct _ADDR_BOOK_RECORD {
   uint32   dwVersionNo;
   uint32   dwLastModify;
   uint16   wGroupNo;
   uint16   wMemoryNo;
   boolean  bSecret;
   char     szName[ADDRBOOK_MAX_NAME_LENGTH+1];
   char     szYomi[ADDRBOOK_MAX_YOMI_LENGTH+1];
   char     szTelNo1[ADDRBOOK_MAX_TEL_NO_LENGTH+1];
   byte     byTelNo1Attr;
   char     szTelNo2[ADDRBOOK_MAX_TEL_NO_LENGTH+1];
   byte     byTelNo2Attr;
   char     szTelNo3[ADDRBOOK_MAX_TEL_NO_LENGTH+1];
   byte     byTelNo3Attr;
   char     szEmailAddr[ADDRBOOK_MAX_MAIL_ADDR_LENGTH+1];
   byte     byEmail1Attr;
   char     szEmailAddr2[ADDRBOOK_MAX_MAIL_ADDR_LENGTH+1];
   byte     byEmail2Attr;
   char     szEmailAddr3[ADDRBOOK_MAX_MAIL_ADDR_LENGTH+1];
   byte     byEmail3Attr;
   char     szBirthday[ADDRBOOK_MAX_BIRTHDAY_LENGTH+1];
   char     szHobby[ADDRBOOK_MAX_HOBBY_LENGTH+1];
   char     szAddress[ADDRBOOK_MAX_ADDRESS_LENGTH+1];
   byte     byAddressAttr;
   char     szUrl[ADDRBOOK_MAX_URL_LENGTH+1];
   char     szMemo[ADDRBOOK_MAX_MEMO_LENGTH+1];
   byte     byConstellation;
   byte     byBlood;
   char     szLocation[ADDRBOOK_MAX_LOCATION_LENGTH+1];
   char     szPhotoFileName[ADDRBOOK_MAX_PHOTO_FILE_NAME_LENGTH+1];
   char     szPostalNo[ADDRBOOK_MAX_POSTAL_NO_LENGTH+1];
   char     szOrganization[ADDRBOOK_MAX_ORGANIZATION_LENGTH+1];
   char     szSection[ADDRBOOK_MAX_SECTION_LENGTH+1];
} ADDR_BOOK_RECORD;


typedef struct _ADDR_BOOK_INFO{
   uint16   wMaxMno;
   uint16   wHistryNum;
/* .Start Kiriyama @PTX804-003 */
   uint16   wMailNum;
/* .End   Kiriyama @PTX804-003 */
} ADDR_BOOK_INFO;


typedef struct _MEMORY_NO_STATUS{
   byte     byStatus;
   uint32   dwLastModify;
}MEMORY_NO_STATUS;

//
//	ԍXe[^X
//
#define	MEM_NO_STATUS_UNUSED					0		// gp
#define	MEM_NO_STATUS_USED					1		// gp
#define	MEM_NO_STATUS_SECRET					2		// V[NbgŎgp

/*-------------------------------------------------------------------------------------------
   Macros Declarations
-------------------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------------------
   Function Declarations
-------------------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------------------
   Data Declarations
-------------------------------------------------------------------------------------------*/


/*===========================================================================================
 FUNCTION DECLARATIONS AND INLINE FUNCTION DEFINITIONS
===========================================================================================*/
/*-------------------------------------------------------------------------------------------
   Interface Definitions
-------------------------------------------------------------------------------------------*/
AEEINTERFACE(IAddr)
{
   INHERIT_IBase(IAddr);
   int (*Get)           (IAddr * pIAddr, uint16 wMemoryNo, uint32 dwFieldMask, ADDR_BOOK_RECORD * pAddrBookRecord);
   int (*GetInfo)       (IAddr * pIAddr, ADDR_BOOK_INFO * pAddrBookInfo);
   int (*GetMemNoStatus)(IAddr * pIAddr, MEMORY_NO_STATUS MemoryNoStatus[]);
   int (*Put)           (IAddr * pIAddr, uint16 * pwMemoryNo, uint32 dwFieldMask, ADDR_BOOK_RECORD * pAddrBookRecord, boolean bUpdate);
   int (*SearchNo)      (IAddr * pIAddr, int nInputMode, int nSearchMode, char * pInbuf, uint16 * pnRet);
   int (*GetGroupName)  (IAddr * pIAddr, uint16 usGroupNum, char * pszGroupName, int * pnSize);
};


/*-------------------------------------------------------------------------------------------
   Access Macros
-------------------------------------------------------------------------------------------*/
#define IADDR_AddRef(po)                  AEEGETPVTBL(po,IAddr)->AddRef(po)
#define IADDR_Release(po)                 AEEGETPVTBL(po,IAddr)->Release(po)
#define IADDR_Get(po,mn,fm,prec)          AEEGETPVTBL(po,IAddr)->Get(po,mn,fm,prec)
#define IADDR_GetInfo(po,pinf)            AEEGETPVTBL(po,IAddr)->GetInfo(po,pinf)
#define IADDR_GetMemNoStatus(po,ms)       AEEGETPVTBL(po,IAddr)->GetMemNoStatus(po,ms)
#define IADDR_Put(po,pmn,fm,prec,bu)      AEEGETPVTBL(po,IAddr)->Put(po,pmn,fm,prec,bu)
#define IADDR_SearchNo(po,ni,ns,pb,pn)    AEEGETPVTBL(po,IAddr)->SearchNo(po,ni,ns,pb,pn)
#define IADDR_GetGroupName(po,us,psz,pn)  AEEGETPVTBL(po,IAddr)->GetGroupName(po,us,psz,pn)


/*===========================================================================================
   DATA STRUCTURE DOCUMENTATION
=============================================================================================
=============================================================================================
ADDR_BOOK_RECORD

Description:
   AhXf[^\́B̃tB[h́AS0x00 I[łB

Definition:

   typedef struct _ADDR_BOOK_RECORD {
      uint32   dwVersionNo;
      uint32   dwLastModify;
      uint16   wGroupNo;
      uint16   wMemoryNo;
      boolean  bSecret;
      char     szName[ADDRBOOK_MAX_NAME_LENGTH+1];
      char     szYomi[ADDRBOOK_MAX_YOMI_LENGTH+1];
      char     szTelNo1[ADDRBOOK_MAX_TEL_NO_LENGTH+1];
      byte     byTelNo1Attr;
      char     szTelNo2[ADDRBOOK_MAX_TEL_NO_LENGTH+1];
      byte     byTelNo2Attr;
      char     szTelNo3[ADDRBOOK_MAX_TEL_NO_LENGTH+1];
      byte     byTelNo3Attr;
      char     szEmailAddr[ADDRBOOK_MAX_MAIL_ADDR_LENGTH+1];
      byte     byEmail1Attr;
      char     szEmailAddr2[ADDRBOOK_MAX_MAIL_ADDR_LENGTH+1];
      byte     byEmail2Attr;
      char     szEmailAddr3[ADDRBOOK_MAX_MAIL_ADDR_LENGTH+1];
      byte     byEmail3Attr;
      char     szBirthday[ADDRBOOK_MAX_BIRTHDAY_LENGTH+1];
      char     szHobby[ADDRBOOK_MAX_HOBBY_LENGTH+1];
      char     szAddress[ADDRBOOK_MAX_ADDRESS_LENGTH+1];
      byte     byAddressAttr;
      char     szUrl[ADDRBOOK_MAX_URL_LENGTH+1];
      char     szMemo[ADDRBOOK_MAX_MEMO_LENGTH+1];
      byte     byConstellation;
      byte     byBlood;
      char     szLocation[ADDRBOOK_MAX_LOCATION_LENGTH+1];
      char     szPhotoFileName[ADDRBOOK_MAX_PHOTO_FILE_NAME_LENGTH+1];
      char     szPostalNo[ADDRBOOK_MAX_POSTAL_NO_LENGTH+1];
      char     szOrganization[ADDRBOOK_MAX_ORGANIZATION_LENGTH+1];
      char     szSection[ADDRBOOK_MAX_SECTION_LENGTH+1];
   } ADDR_BOOK_RECORD;

Members:
   dwVersionNo:      \̂̃o[W
   dwLastModify:     ŏIBnԂɒ߂1980 N1 6 00:00:00 ̕b
   wGroupNo:         O[vNo.
   wMemoryNo:        No.
   bSecret:          V[Nbgݒ
                     FALSE V[Nbg
                     TRUE  V[NbgBړ@V[Nbg[h̏ꍇ̂݃ANZX\
   szName:           O
   szYomi:           ǂ
   szTelNo1:         dbԍ1
   byTelNo1Attr:     dbԍ1 
   szTelNo2:         dbԍ2
   byTelNo2Attr:     dbԍ2 
   szTelNo3:         dbԍ3
   byTelNo3Attr:     dbԍ3 
   szEmailAddr:      E [AhX1
   byEmail1Attr:     E [AhX1 
   szEmailAddr2:     E [AhX2
   byEmail2Attr:     E [AhX2 
   szEmailAddr3:     E [AhX3
   byEmail3Attr:     E [AhX3 
   szBirthday:       ayyyymmdd
   szHobby:          
   szAddress:        Z
   byAddressAttr:    Z
   szUrl:            URL
   szMemo:           
   byConstellation:  
   byBlood:          t^
   szLocation:       ʒu
   szPhotoFileName:  PHOTO
   szPostalNo:       X֔ԍ
   szOrganization:   gD
   szSection:        

Comments:
   {\̂IADDR_Get() / IADDR_Put()̈ƂĎw肷ꍇAołdwVersionNo(\
   ̂̃o[Wԍ)ɂ͕KADDR_BOOK_RECORD_VERSION ݒ肵Ȃ΂ȂȂB

   ADDR_BOOK_RECORD_VERSION   1  \̂̃o[Wԍ

See Also:
   

=============================================================================================
etB[h̍ő咷

Description:
   łtB[h̍ő咷B̒͏I[(0x00)͊܂܂ȂB

Definition:
   ADDRBOOK_MAX_NAME_LENGTH:               24    O
   ADDRBOOK_MAX_YOMI_LENGTH:               24    ǂ
   ADDRBOOK_MAX_TEL_NO_LENGTH:             36    dbԍ
   ADDRBOOK_MAX_MAIL_ADDR_LENGTH:          64    E[AhX
   ADDRBOOK_MAX_BIRTHDAY_LENGTH:           10    a
   ADDRBOOK_MAX_HOBBY_LENGTH:              20    
   ADDRBOOK_MAX_ADDRESS_LENGTH:            80    Z
   ADDRBOOK_MAX_URL_LENGTH:                256   URL
   ADDRBOOK_MAX_MEMO_LENGTH:               80    
   ADDRBOOK_MAX_LOCATION_LENGTH:           66    ʒu
// .Start Kiriyama @PTX804-001
// ADDRBOOK_MAX_PHOTO_FILE_NAME_LENGTH:    45    PHOTO
   ADDRBOOK_MAX_PHOTO_FILE_NAME_LENGTH:    256   PHOTO
// .End   Kiriyama @PTX804-001
   ADDRBOOK_MAX_POSTAL_NO_LENGTH           10    X֔ԍ
   ADDRBOOK_MAX_ORGANIZATION_LENGTH        40    gD
   ADDRBOOK_MAX_SECTION_LENGTH             40    

Members:
   

Comments:
   

See Also:
   

=============================================================================================
tB[h}XN

Description:
   AhXɃANZXꍇɎgpAetB[hɑΉ}XNȉɒ`B

Definition:
   FIELD_MASK_LAST_MODIFY            0x00000001  ŏI
   FIELD_MASK_GROUP_NO               0x00000002  O[vNo.
   FIELD_MASK_MEMORY_NO              0x00000004  No.
   FIELD_MASK_SECRET                 0x00000008  V[Nbg
   FIELD_MASK_NAME                   0x00000010  O
   FIELD_MASK_YOMI                   0x00000020  ǂ
   FIELD_MASK_TEL_NO1                0x00000040  dbԍP
   FIELD_MASK_TEL_NO2                0x00000080  dbԍQ
   FIELD_MASK_TEL_NO3                0x00000100  dbԍR
   FIELD_MASK_MAIL_ADDR1             0x00000200  E[AhXP
   FIELD_MASK_MAIL_ADDR2             0x00000400  E[AhXQ
   FIELD_MASK_MAIL_ADDR3             0x00000800  E[AhXR
   FIELD_MASK_BIRTHDAY               0x00001000  a
   FIELD_MASK_HOBBY                  0x00002000  
   FIELD_MASK_ADDRESS                0x00004000  Z
   FIELD_MASK_URL                    0x00008000  URL
   FIELD_MASK_MEMO                   0x00010000  
   FIELD_MASK_CONSTELLATION          0x00020000  
   FIELD_MASK_BLOOD                  0x00040000  t^
   FIELD_MASK_LOCATION               0x00080000  ʒu
   FIELD_MASK_PHOTO                  0x00100000  PHOTO
   FIELD_MASK_POSTAL_NO              0x00200000  X֔ԍ
   FIELD_MASK_ORGANIZATION           0x00400000  gD
   FIELD_MASK_SECTION                0x00800000  

Members:
   

Comments:
   

See Also:
   

=============================================================================================
db

Description:
   

Definition:
   ADDRBOOK_TEL_ATTR_NONE                  0     Ȃ
   ADDRBOOK_TEL_ATTR_CELLULAR              1     g
   ADDRBOOK_TEL_ATTR_PHS                   2     PHS
   ADDRBOOK_TEL_ATTR_HOME                  3     
   ADDRBOOK_TEL_ATTR_OFFICE                4     d
   ADDRBOOK_TEL_ATTR_FAX                   5     FAX

Members:
   

Comments:
   

See Also:
   

=============================================================================================
EMAIL 

Description:
   

Definition:
   ADDRBOOK_EMAIL_ATTR_NONE                0     Ȃ
   ADDRBOOK_EMAIL_ATTR_CELLULAR            1     g
   ADDRBOOK_EMAIL_ATTR_PHS                 2     PHS
   ADDRBOOK_EMAIL_ATTR_HOME                3     
   ADDRBOOK_EMAIL_ATTR_SCHOOL              4     wZ
   ADDRBOOK_EMAIL_ATTR_OFFICE              5     d

Members:
   

Comments:
   

See Also:
   

=============================================================================================
Z

Description:
   

Definition:
   ADDRBOOK_ADDRESS_ATTR_NONE              0     Ȃ
   ADDRBOOK_ADDRESS_ATTR_HOME              1     
   ADDRBOOK_ADDRESS_ATTR_OFFICE            2     d

Members:
   

Comments:
   

See Also:
   

=============================================================================================
t^

Description:
   

Definition:
   ADDRBOOK_BLOOD_NONE                     0     Ȃ
   ADDRBOOK_BLOOD_A                        1     A^
   ADDRBOOK_BLOOD_B                        2     B^
   ADDRBOOK_BLOOD_O                        3     O^
   ADDRBOOK_BLOOD_AB                       4     AB^

Members:
   

Comments:
   

See Also:
   

=============================================================================================


Description:
   

Definition:
   ADDRBOOK_CONSTELLATION_NONE             0     Ȃ
   ADDRBOOK_CONSTELLATION_ARIES            1     r
   ADDRBOOK_CONSTELLATION_TAURUS           2     
   ADDRBOOK_CONSTELLATION_GEMINI           3     oq
   ADDRBOOK_CONSTELLATION_CANCER           4     I
   ADDRBOOK_CONSTELLATION_LEO              5     q
   ADDRBOOK_CONSTELLATION_VIRGO            6     
   ADDRBOOK_CONSTELLATION_LIBRA            7     V
   ADDRBOOK_CONSTELLATION_SCORPIO          8     嶍
   ADDRBOOK_CONSTELLATION_OPHIUCHUS        9     ֌
   ADDRBOOK_CONSTELLATION_SAGITTARIUS      10    ˎ
   ADDRBOOK_CONSTELLATION_CAPRICORN        11    Rr
   ADDRBOOK_CONSTELLATION_AQUARIUS         12    r
   ADDRBOOK_CONSTELLATION_PISCES           13    

Members:
   

Comments:
   

See Also:
   

=============================================================================================
ADDR_BOOK_INFO

Description:
   AhXf[^\

Definition:
   typedef struct _ADDR_BOOK_INFO{
      uint16   wMaxMno;
      uint16   wHistryNum;
// .Start Kiriyama @PTX804-003
      uint16   wMailNum;
// .End   Kiriyama @PTX804-003
   } ADDR_BOOK_INFO;

Members:
   wMaxMno:       ő僁ԍ
   wHistryNum:    o^ς݃R[h
// .Start Kiriyama @PTX804-003
   wMailNum:      E[AhXo^Ă郌R[h̐
// .End   Kiriyama @PTX804-003

Comments:
// .Start Kiriyama @PTX804-003
   wMaxMnoɊi[l0ł邱ƂɒӁB
   wMailNum̒ĺAE[AhX1`3Sēo^ĂĂA1ƂĈƁB
   V[Nbg[hOFF̏ꍇɕԋpĺAoɉL̂悤ɈقȂ_ɒӂ邱
      wHistryNumFV[Nbgo^Ă郌R[hJEg
      wMailNumFV[Nbgo^Ă郌R[h̓JEgȂ
// .End   Kiriyama @PTX804-003

See Also:
   

=============================================================================================
MEMORY_NO_STATUS

Description:
   AhX\

Definition:
   typedef struct _MEMORY_NO_STATUS{
      byte     byStatus;
      uint32   dwLastModify;
   }MEMORY_NO_STATUS;

Members:
   byStatus:      L̏Ԃ
                  MEM_NO_STATUS_UNUSED    0  gp
                  MEM_NO_STATUS_USED      1  gp
                  MEM_NO_STATUS_SECRET    2  V[NbgŎgp

   dwLastModify:  ŏIXVtBnԂɒ߂1980 N1 6 00:00:00 ̕b

Comments:
   

See Also:
   

=============================================================================================
ԍ擾p`l

Description:
   AhXVKo^̏ꍇAԍƂĉL̒lw肷ƁAIɃ
   擾B

Definition:
   MEMORY_NO_AUTO    0xffff   ԍ擾

Members:
   

Comments:
   

See Also:
   

=============================================================================================
=============================================================================================
   INTERFACE DOCUMENTATION
=============================================================================================

Interface Name: IADDRC^[tF[X

Description:
   IADDRKDDIdlłAhXɑ΂AǂݏoA݁Ȃ擾T|[gB

   Ew\tB[h
     IADDRɂăANZX\ȃtB[h͈ȉ̒ʂB
        No   
        1    ŏI
        2    V[Nbg
        3    O
        4    
        5    dbԍP
        6    dbԍP
        7    dbԍQ
        8    dbԍQ
        9    dbԍR
        10   dbԍR
        11   E[AhXP
        12   E[AhXP
        13   E[AhXQ
        14   E[AhXQ
        15   E[AhXR
        16   E[AhXR
        17   O[vNo.
        18   No.
        19   a
        20   
        21   Z
        22   Z
        23   URL
        24   
        25   t^
        26   
        27   ʒu
        28   PHOTO
        29   X֔ԍ
        30   gD
        31   

   EŏIANo
      {tB[hɑ΂ẮAǂݍ݂݂̂\ƂA݂̓T|[gȂB

   EPhoto
      {tB[hɊi[́Af[^tH_̎t@CƂB
      ܂A{tB[hւ݂̏́Af[^tH_ɑΏۂ̃t@C݂鎞̂݉\ƂB
      ȂAt@CpXɊւẮAuBREW3.1 ڈړ@vdl Xg[WҁvQƂ̂ƁB

   EtB[ḧ
      AhX̎dlŁuvƂȂĂtB[hɊւĂNativẽAhXT|[g
      Ăꍇ̂ݑΉBȂAAhXŃT|[gĂȂꍇɁA{tB[hɑ΂
      ݁A܂͓ǂݍݏsۂɂ́A𐬌ƂŁAi[
      tB[h́uI[vAli[tB[h͢0ꂼꏑ/ǂݍ݂
      邱ƁB
      ڍׂȏ́Au5.5 IADDR_Put()vAu5.2 IADDR_Get()vQƂ̂ƁB
      ȂÃtB[h͈ȉ̂ƂB

      EdbԍR
      EdbԍR
      EE[AhXR
      EE[AhXR
      EX֔ԍ
      EgD
      E


Functions in this interface include:
   IADDR_AddRef
   IADDR_Release
   IADDR_Get
   IADDR_GetInfo
   IADDR_GetMemNoStatus
   IADDR_Put
   IADDR_SearchNo
   IADDR_GetGroupName
=============================================================================================
IADDR_AddRef()

Description:
   C^[tFCXIuWFNg̎QƃJE^CNgB

Prototype:
   uint32 IADDR_AddRef(IAddr * pIAddr);

Parameters:
   pIAddr : IAddr InterfaceIuWFNg̃|C^

Return Value:
   CNg̃IuWFNgQƃJE^l

Comments:
   IuWFNgLȏꍇA̎QƃJE^lԂB

Side Effects:
   

See Also:
   IADDR_Release()

=============================================================================================
IADDR_Get()

Description:
   AhXw肵ԍ̃R[h擾B

Prototype:
   int IADDR_Get(IAddr * pIAddr, uint16 wMemoryNo, uint32 dwFieldMask, ADDR_BOOK_RECORD * pAddrBookRecord);

Parameters:
   pIAddr          : IAddr InterfaceIuWFNg̃|C^
   wMemoryNo       : 擾ׂR[h̃ԍ
   dwFieldMask     : 擾ׂtB[hɑΉrbg}XNAw肷ۂɂORŎw肷
   pAddrBookRecord : 擾R[hi[̈̃|C^

Return Value:
   KDDI_SUCCESS      .
   KDDI_EFAILED      s
   KDDI_EBADPARAM    ԍs
   KDDI_ERESTRICTED  AhXANZXĂ
   KDDI_ESECRET      V[NbgR[hɃANZX

Comments:
   EAhXɍڂ݂͑Ăeݒ肳ĂȂԁiuȂvuIvƑI
     ԁjłꍇ́Ȁꍇ́uI[vAl̏ꍇ́u0v
     ԋp邱ƁB
   EAhXdlɂĐ̃tB[h(dbԍRAdbԍRAE[AhXRA
     E[AhXRAX֔ԍAgD́A)ɑ΂ēǂݍ݂sہA{tB[h
     AhXɂđΉĂȂꍇɂ́A񎝂tB[hł΁uI[vA
     ltB[hł΁u0v擾A߂lƂāuKDDI_SUCCESSvԋp邱ƁB
   EԍƂ0xffffw肳ꂽۂɂ́AvtB[ԋp邱ƁB
     ȂA̍ۂ̋͑SĒʏ̃R[h擾ƓlƂ邱ƁB

See Also:
   

=============================================================================================
IADDR_GetInfo()

Description:
   AhX擾B

Prototype:
   int IADDR_GetInfo(IAddr * pIAddr, ADDR_BOOK_INFO * pAddrBookInfo);

Parameters:
   pIAddr         : IAddr InterfaceIuWFNg̃|C^
   pAddrBookInfo  : AhX񂪕ԋp̈̃|C^
                    ƂẮAő僁ԍAo^ς݃R[hԋp

Return Value:
   KDDI_SUCCESS      .
   KDDI_EFAILED      s
   KDDI_ERESTRICTED  AhXANZXĂ

Comments:
   Eo^R[hԋpۂɂ́AV[Nbgo^Ăf[^܂߂ĕԋp邱ƁB
   EvtB[͖{֐ɂJEg̑ΏۊOƂ邱ƁB

See Also:
   None

=============================================================================================
IADDR_GetMemNoStatus()

Description:
   ԍ̏Ԃ擾B{APIgpꍇ́AIADDR_GetInfo()
   ړ@Ŏgpłő僁ԍ擾AŜi[ł邾̃̈
   pӂȂ΂ȂȂB

Prototype:
   int IADDR_GetMemNoStatus(IAddr * pIAddr, MEMORY_NO_STATUS MemoryNoStatus[]);

Parameters:
   pIAddr         : IAddr InterfaceIuWFNg̃|C^
   MemoryNoStatus : MEMORY_NO_STATUS̔zw肷B
                    ̔źAő僁ԍpӂȂ΂ȂȂ
                    eԍɑΉ̈ɊeԍɑΉR[h񂪕ԋpB

Return Value:
   KDDI_SUCCESS      .
   KDDI_EFAILED      s
   KDDI_ERESTRICTED  AhXANZXĂ

Comments:
   

See Also:
   

=============================================================================================
IADDR_Put()

Description:
   w肵R[hAhXɏށB

Prototype:
   int IADDR_Put(IAddr * pIAddr, uint16 * pwMemoryNo, uint32 dwFieldMask, ADDR_BOOK_RECORD * pAddrBookRecord, boolean bUpdate);

Parameters:
   pIAddr          : IAddr InterfaceIuWFNg̃|C^
   pwMemoryNo      : ނׂR[h̃ԍi[Ă̈̃|C^w肷B
                     MEMORY_NO_AUTOw肳ꂽꍇ́AԍԋpB
                     ̎ẃAVKo^̏ꍇ̂ݗLł
   dwFieldMask     : 擾ׂtB[hɑΉrbg}XN
   pAddrBookRecord : 擾R[hi[̈̃|C^
   bUpdate         : XVVK

                     TRUE XVi㏑jBio^ĂG[ɂȂj
                          tB[h}XNŎw肳ꂽtB[ĥ݂܂B
                          tB[h}XNŎw肳ĂȂtB[h͕ύXȂB

                     FALSE VKo^Bw肵ԍɃR[hɓo^Ăꍇ́A
                           G[ɂȂBtB[h}XNŎw肳ꂽtB[hȊO͏l܂B

Return Value:
   KDDI_SUCCESS      .
   KDDI_EFAILED      s
   KDDI_EALREADY     ɓo^ς
   KDDI_EBADPARAM    ԍs
   KDDI_ERESTRICTED  AhXANZXĂ
   KDDI_ESECRET      V[NbgR[hɃANZX
   KDDI_EFULL        󂫃ԍȂ

Comments:
   EAhXdlɂĐ̃tB[h(dbԍRAdbԍRAE[AhXRA
     E[AhXRAX֔ԍAgD́A)ɑ΂ēǂݍ݂sہA{tB[h
     AhXɂđΉĂȂꍇɂ́A݂͍s킸A߂lƂ
     uKDDI_SUCCESSvԋp邱ƁB

   Eu݁vŎgp镶ɉ͈ȉ̒ʂƂ邱ƁB

      ͕     ߂l
                 KDDI_EFAILEDԋp
      Ђ炪       KDDI_EFAILEDԋp
      s           KDDI_EFAILEDԋp
      G         KDDI_EFAILEDԋp
      SpJ^Ji   pɕϊAKDDI_SUCCESSԋp
      Spp     pɕϊAKDDI_SUCCESSԋp
      SpL       pɕϊAKDDI_SUCCESSԋp
      pJ^Ji   KDDI_SUCCESSԋp
      pp     KDDI_SUCCESSԋp
      pL       KDDI_SUCCESSԋp

   EuPHOTOvڂ̏ݎAf[^tH_ɑΏۂ̃t@C݂Ȃꍇ́A
     uKDDI_EBADPARMvԋp邱ƁB

   Eo^̎wɊ֘AIADDR_Put()̘Agp[^́Aȉ5z肵ĂB
      @ IADDR_Put()̑2pwMemoryNo Ƀԍw
      A IADDR_Put()̑2pwMemoryNo MEMORY_NO_AUTO w
      B ADDR_BOOK_RECORD \̂wMemoryNo Ƀԍw
      C IADDR_Put()̑5bUpdate TRUEi㏑jw
      D IADDR_Put()̑5bUpdate FALSEiVKo^jw

      Lp[^̑gݍ킹̃p^[yѓAȉ̒ʂK肷B
      g                                         l
      @{B{C  @Ŏw肳ꂽԍɏ㏑o^
      @{B{D  @Ŏw肳ꂽԍɐVKo^     o^ς݂̏ꍇ́uKDDI_EALREADYvԋp
      @{C      @Ŏw肳ꂽԍɏ㏑o^
      @{D      @Ŏw肳ꂽԍɐVKo^     o^ς݂̏ꍇ́uKDDI_EALREADYvԋp

      g                                         l
      A{B{C  uKDDI_EBADPARMvԋp
      A{B{D  ԎႢ󂫔ԍɐVKo^
      A{C      uKDDI_EBADPARMvԋp
      A{D      ԎႢ󂫔ԍɐVKo^

      g                                         l
      B{C     uKDDI_EBADPARMvԋp
      B{D     uKDDI_EBADPARMvԋp

      g                                         l
      C         uKDDI_EBADPARMvԋp

      g                                         l
      D         uKDDI_EBADPARMvԋp

   EtB[h񂪁uI[v݂̂łꍇAG[Ƃɏ݂sƁB
   Eړ@gpLȒlAp[^ɂPłw肳Ă΁A݉\Ƃ邱ƁB
   E㏑A܂ȂtB[hɑ΂ẮAł΁uI[vAl
     ΁u0vi[邱ƁB
   EAhX̍ڂɉāAIvVڂ̍őo^AAhXR[hőo^
     A𒴂ăIvVڂo^悤Ƃꍇɂ̓G[Ƃ
     uKDDI_EFULLvԋp邱ƁB
     iFőo^500ɑ΂AIvV̓o^100̏ԂŁA101̃IvV
       o^悤Ƃꍇj

See Also:
   None

=============================================================================================
IADDR_SearchNo()

Description:
   ̃tB[hR[h̃ԍ܂̓O[vԍB

Prototype:
   int IADDR_SearchNo(IAddr * pIAddr, int nInputMode, int nSearchMode, char * pInbuf, uint16 * pnRet);

Parameters:
   pIAddr      : IADDR Interface IuWFNg̃|C^
   nInputMode  : ̓[h
                 0 : dbԍi09܂ł̐l݂̂MAX36+1byteNULLI[j
                 1 : E[AhXiMAX64+1byteNULLI[j
   nSearchMode : [h
                 0 : ԍ[h
                 1 : O[vԍ[h
   pInbuf      : p̃tB[h͂obt@
   pnRet       : 
                 R[h̃ԍ   : ̓[AhXR[h݂A
                                          [h0(ԍ[h)̎
                 R[h̃O[vԍ : ̓[AhXR[h݂
                                          [h1(O[vԍ[h)̎

Return Value:
   KDDI_SUCCESS      .
   KDDI_EFAILED      s
   KDDI_EBADPARAM    p[^s
   KDDI_EUNSUPPORTED ̓[AhXR[h݂Ȃ

Comments:
   E̓[AhXR[h݂ꍇɂ͐揟Ƃ邱ƁB
   EO[vԍ[hA̓AhXR[hɃO[vԍo^ĂȂ
     ꍇɂ́AuKDDI_EUNSUPPORTEDvԋp邱ƁB
   EV[Nbgo^Ă郌R[hłĂԍԋp邱ƁB
   E{֐ɂẮAAhXłĂG[ƂɐɏsƁB
   EvtB[͖{̑ΏۊOƂ邱ƁB

Side Effects:
   

See Also:
   

=============================================================================================
IADDR_GetGroupName

Description:
   w肵O[vԍ̃O[v擾B

Prototype:
   int IADDR_GetGroupName(IAddr * pIAddr, uint16 usGroupNum, char * pszGroupName, int * pnSize);

Parameters:
   pIAddr       : IADDR Interface IuWFNg̃|C^
   usGroupNum   : 擾ׂO[vԍ
   pszGroupName : 擾O[vi[̈̃|C^B
   pnSize       : pGroupNamẽTCYw肷B^[ɍڃTCYԋpB

Return Value:
   KDDI_SUCCESS      .
   KDDI_EFAILED      s
   KDDI_EBADPARAM    p[^s
   KDDI_EUNSUPPORTED ΉO[v̂o^

Comments:
   EpGroupNameNULLw肳Ăꍇɂ́ApSizeɕԋpO[ṽoCgiI[܂ށj
     ԋp邱ƁB
   EԋpO[vpSizeŎw肳ꂽl傫ꍇɂ́AKDDI_EBADPARAMԋp邱ƁB
   Ew肵O[vԍɑ΂ăO[vݒ肳ĂȂۂɂ́AuKDDI_EUNSUPPORTEDvԋpApszGroupNameɂ́uI[v݂̂ApnSizeɂ́u0vԋp邱ƁB
   E{֐̓AhXłĂAG[ƂɐɏsƁB

Side Effects:
   

See Also:
   None

=============================================================================================
IADDR_Release()

Description:
   C^[tFCXIuWFNg̎QƃJE^fNgB

Prototype:
   uint32 IADDR_Release(IAddr * pIAddr)

Parameters:
   pIAddr : IAddr InterfaceIuWFNg̃|C^

Return Value:
   fNg̃IuWFNgQƃJE^l
   0 ([) IuWFNgAƂȂĂꍇ

Comments:
   None

Side Effects:
   None

See Also:
   IADDR_AddRef()

===========================================================================================*/


#endif //_IADDR_H_
