#ifndef IFELICA_H
#define IFELICA_H
/*=============================================================================================

FILE            : IFeliCa.h

SERVICES        : BREW Felica

DESCRIPTION     : Felica Extension Global Header

PUBLIC CLASSES  : Ȃ

INITIALIZATION AND SEQUENCING REQUIREMENTS : Ȃ

     Copyright 2004-2005 Felica Networks, Inc.
              All Rights Reserved.
        Felica Networks, Inc. Proprietary

=============================================================================================*/

/*=============================================================================================
 INCLUDES AND VARIABLE DEFINITIONS
=============================================================================================*/

/*=====================================================================
 Include Files
=====================================================================*/
#include "AEE.h"
//#include "AEEInterface.h"

/*=====================================================================
 Macros
=====================================================================*/

//---------------------------------------------------------------------
// FeliCa Extension Al/
//---------------------------------------------------------------------
//#define SUCCESS                         (0)                   // AEEError.hɂĒ`Ă
#define EFELICA_FAILED                  (-1)
#define EFELICA_BADPARAM                (-2)
#define EFELICA_CLOSED                  (-3)
#define EFELICA_ALREADY                 (-4)
#define EFELICA_BADSTATE                (-5)
#define EFELICA_NOMEMORY                (-6)
#define EFELICA_EXIST                   (-7)
#define EFELICA_NOTEXIST                (-8)
#define EFELICA_PRIVLEVEL               (-9)
#define EFELICA_TIMEOUT                 (-10)
#define EFELICA_BADSERVICE              (-11)
#define EFELICA_BADBLOCKNO              (-12)
#define EFELICA_PURSE_FAILED            (-13)
#define EFELICA_CASHBACK_FAILED         (-14)
#define EFELICA_CYCLIC_FAILED           (-15)
#define EFELICA_PIN_FAILED              (-16)
#define EFELICA_PARENT_PIN_FAILED       (-17)
#define EFELICA_PIN_COUNT_OVER          (-18)
#define EFELICA_PIN_LOCKOUT             (-19)
#define EFELICA_PIN_ATTRIBUTE           (-20)
#define EFELICA_INTERRUPTED             (-21)
#define EFELICA_TCAP                    (-22)
#define EFELICA_CONNECT                 (-23)
#define EFELICA_HTTP                    (-24)
#define EFELICA_BUSY                    (-25)

//---------------------------------------------------------------------
// FeliCa Extension Timeout Value
//---------------------------------------------------------------------
#define FELICA_TIMEOUT_MIN              (500)
#define FELICA_TIMEOUT_MAX              (60000)

//---------------------------------------------------------------------
// FeliCa Extension Retry Count
//---------------------------------------------------------------------
#define FELICA_RETRY_MIN                (0)
#define FELICA_RETRY_MAX                (10)

//---------------------------------------------------------------------
// FeliCa Extension Service List Max Value
//---------------------------------------------------------------------
#define FELICA_SERVICELIST_MAX          (32)

//---------------------------------------------------------------------
// FeliCa Extension Block List Max Value
//---------------------------------------------------------------------
#define FELICA_BLOCKLIST_MAX            (16)

//---------------------------------------------------------------------
// FeliCa Extension PIN Max Value
//---------------------------------------------------------------------
#define FELICA_PINLIST_MAX              (8)

//---------------------------------------------------------------------
// Mobile FeliCa Chip Block Size
//---------------------------------------------------------------------
#define FELICA_BLOCKSIZE                (16)

//---------------------------------------------------------------------
// Purse Service User Data Value
//---------------------------------------------------------------------
#define FELICA_PURSE_USERDATASIZE       (6)

//---------------------------------------------------------------------
// f[^MpPbgőTCY
//---------------------------------------------------------------------
#define FELICA_COMMANDSIZE              (245)

//---------------------------------------------------------------------
// Default Device Info
//---------------------------------------------------------------------
#define FELICA_DEVICE_TYPE_FELICA       "FeliCa"
#define FELICA_DEVICE_TYPE_GENERIC      "Generic"
#define FELICA_DEVICE_NAME_RW           "R/W"
#define FELICA_DEVICE_NAME_DISPLAY      "Display"
#define FELICA_DEVICE_ID001             (0x0001)
#define FELICA_DEVICE_ID002             (0x0002)
#define FELICA_DEVICE_ID_BASE            FELICA_DEVICE_ID001

//---------------------------------------------------------------------
// _T[rXɂēǂݍ񂾃f[^̎擾
//---------------------------------------------------------------------
#define FELICA_GET_BLOCKLIST_RANDOM(pBlockData, pData) \
{ \
   MEMCPY((pData), \
          (pBlockData)->BlockData.RandomData.byBlockData, \
          sizeof((pBlockData)->BlockData.RandomData.byBlockData)); \
}

//---------------------------------------------------------------------
// _T[rXɂďނ߂̃f[^ݒ
//---------------------------------------------------------------------
#define FELICA_SET_BLOCKLIST_RANDOM(pBlockData, pData) \
{ \
   MEMCPY((pBlockData)->BlockData.RandomData.byBlockData, \
          (pData), \
          sizeof((pBlockData)->BlockData.RandomData.byBlockData)); \
}

//---------------------------------------------------------------------
// TCNbNT[rXɂēǂݍ񂾃f[^̎擾
//---------------------------------------------------------------------
#define     FELICA_GET_BLOCKLIST_CYCLIC(pBlockData, pData) \
{ \
   MEMCPY((pData), \
          (pBlockData)->BlockData.CyclicData.byBlockData, \
          sizeof((pBlockData)->BlockData.CyclicData.byBlockData)); \
}

//---------------------------------------------------------------------
// TCNbNT[rXɂďނ߂̃f[^ݒ
//---------------------------------------------------------------------
#define FELICA_SET_BLOCKLIST_CYCLIC(pBlockData, pData) \
{ \
   MEMCPY((pBlockData)->BlockData.CyclicData.byBlockData, \
          (pData), \
          sizeof((pBlockData)->BlockData.CyclicData.byBlockData)); \
}

//---------------------------------------------------------------------
// p[XT[rXɂēǂݍ񂾃f[^̎擾
//---------------------------------------------------------------------
#define FELICA_GET_BLOCKLIST_PURSEDIRECT(pBlockData, pdwPurse, pdwCashback, pUser, pwExID) \
{ \
   *(pdwPurse)    = (pBlockData)->BlockData.PurseDirectData.dwPurseData; \
   *(pdwCashback) = (pBlockData)->BlockData.PurseDirectData.dwCashBackData; \
   MEMCPY((pUser), \
          (pBlockData)->BlockData.PurseDirectData.byUserData, \
          sizeof((pBlockData)->BlockData.PurseDirectData.byUserData)); \
   *(pwExID)      = (pBlockData)->BlockData.PurseDirectData.wExecutionID; \
}

//---------------------------------------------------------------------
// p[XT[rX(_CNgANZX)ɂďނ߂̃f[^ݒ
//---------------------------------------------------------------------
#define FELICA_SET_BLOCKLIST_PURSEDIRECT(pBlockData, pdwPurse, pdwCashback, pUser, pwExID) \
{ \
   (pBlockData)->BlockData.PurseDirectData.dwPurseData = (*pdwPurse); \
   (pBlockData)->BlockData.PurseDirectData.dwCashBackData  = (*pdwCashback); \
   MEMCPY((pBlockData)->BlockData.PurseDirectData.byUserData, \
          (pUser), \
          sizeof((pBlockData)->BlockData.PurseDirectData.byUserData)); \
   (pBlockData)->BlockData.PurseDirectData.wExecutionID = (*pwExID); \
}

//---------------------------------------------------------------------
// p[XT[rX(fNgANZX)ɂďނ߂̃f[^ݒ
//---------------------------------------------------------------------
#define FELICA_SET_BLOCKLIST_PURSEDECREMENT(pBlockData, pdwDecrement, pwExID) \
{ \
   (pBlockData)->BlockData.PurseCashBackData.bDecrementWriteFlag = TRUE; \
   (pBlockData)->BlockData.PurseDecrementData.dwDecrementData = (*pdwDecrement); \
   (pBlockData)->BlockData.PurseDecrementData.wExecutionID = (*pwExID); \
}

//---------------------------------------------------------------------
// p[XT[rX(LbVobNANZX)ɂďނ߂̃f[^ݒ
//---------------------------------------------------------------------
#define FELICA_SET_BLOCKLIST_PURSECASHBACK(pBlockData, pdwCashback, pwExID) \
{ \
   (pBlockData)->BlockData.PurseCashBackData.bDecrementWriteFlag = FALSE; \
   (pBlockData)->BlockData.PurseCashBackData.dwCashBackData = (*pdwCashback); \
   (pBlockData)->BlockData.PurseCashBackData.wExecutionID = (*pwExID); \
}

/*=====================================================================
 Type Declarations
=====================================================================*/

//---------------------------------------------------------------------
// IDmi[邽߂̃f[^^
//---------------------------------------------------------------------
typedef struct _FeliCaIDm {
   uint8        IDm[8];
} FeliCaIDm;

//---------------------------------------------------------------------
// T[rXXgi[f[^^
//---------------------------------------------------------------------
typedef struct _FeliCaServiceList {
   uint32       nCount;
   uint16       wList[FELICA_SERVICELIST_MAX];
} FeliCaServiceList;

//---------------------------------------------------------------------
// o[Wi[邽߂̃f[^^
//---------------------------------------------------------------------
typedef FeliCaServiceList   FeliCaKeyVersionList;

//---------------------------------------------------------------------
// _T[rXANZXɎgpubNf[^^
//---------------------------------------------------------------------
typedef struct _FeliCaRandomData {
   uint8        byBlockData[FELICA_BLOCKSIZE];
} FeliCaRandomData;

//---------------------------------------------------------------------
// TCNbNT[rXANZXɎgpubNf[^^
//---------------------------------------------------------------------
typedef struct _FeliCaCyclicData {
   uint8        byBlockData[FELICA_BLOCKSIZE];
} FeliCaCyclicData;

//---------------------------------------------------------------------
// p[XT[rX̃_CNgANZXƁAp[XT[rX̃f[^ǂݏoɎgpubN
// f[^^
//---------------------------------------------------------------------
typedef struct _FeliCaPurseDirectData {
   uint32       dwPurseData;
   uint32       dwCashBackData;
   uint8        byUserData[FELICA_PURSE_USERDATASIZE];
   uint16       wExecutionID;
} FeliCaPurseDirectData;

//---------------------------------------------------------------------
// p[XT[rX̃fNgANZXɎgpubNf[^^
//---------------------------------------------------------------------
typedef struct _FeliCaPurseDecrementData {
   uint32       dwDecrementData;
   boolean      bDecrementWriteFlag;
   uint8        byReserve[9];
   uint16       wExecutionID;
} FeliCaPurseDecrementData;

//---------------------------------------------------------------------
// p[XT[rX̃LbVobNANZXɎgpubNf[^^
//---------------------------------------------------------------------
typedef struct _FeliCaPurseCashBackData {
   uint32       dwCashBackData;
   boolean      bDecrementWriteFlag;
   uint8        byReserve[9];
   uint16       wExecutionID;
} FeliCaPurseCashBackData;

//---------------------------------------------------------------------
// eT[rX̃ubNf[^`f[^^
//---------------------------------------------------------------------
typedef union _FeliCaBlockData {
   FeliCaRandomData             RandomData;
   FeliCaCyclicData             CyclicData;
   FeliCaPurseDirectData        PurseDirectData;
   FeliCaPurseDecrementData     PurseDecrementData;
   FeliCaPurseCashBackData      PurseCashBackData;
} FeliCaBlockData;

//---------------------------------------------------------------------
// ubNf[^Read/WriteۂɎgpf[^^
//---------------------------------------------------------------------
typedef struct _FeliCaBlock {
   uint16           wService;
   uint16           wBlockNo;
   FeliCaBlockData  BlockData;
} FeliCaBlock;

//---------------------------------------------------------------------
// ubNf[^Read/WriteۂɎgpf[^Xg^
//---------------------------------------------------------------------
typedef struct _FeliCaBlockList {
   uint32       nCount;
   FeliCaBlock  BlockList[FELICA_BLOCKLIST_MAX];
} FeliCaBlockList;

//---------------------------------------------------------------------
// PINƍŎgpf[^^
//---------------------------------------------------------------------
typedef struct _FeliCaPinCheck {
   uint16       wServiceCode;
   uint32       dwPIN;
} FeliCaPinCheck;

//---------------------------------------------------------------------
// PINƍŎgpf[^Xg^
//---------------------------------------------------------------------
typedef struct _FeliCaPinCheckList {
   uint32           nCount;
   FeliCaPinCheck   PinCheckList[FELICA_PINLIST_MAX];
} FeliCaPinCheckList;

//---------------------------------------------------------------------
// PINL/PINŎgpf[^^
//---------------------------------------------------------------------
typedef struct _FeliCaPinEnable {
   uint16       wServiceCode; 
   uint32       dwPIN;
   boolean      bFlag;
} FeliCaPinEnable;

//---------------------------------------------------------------------
// PINL/PINŎgpf[^Xg^
//---------------------------------------------------------------------
typedef struct _FeliCaPinEnableList {
   uint32           nCount; 
   FeliCaPinEnable  PinEnableList[FELICA_PINLIST_MAX]; 
} FeliCaPinEnableList;


//---------------------------------------------------------------------
// PINύXŎgpf[^^
//---------------------------------------------------------------------
typedef struct _FeliCaPinChange {
   uint16       wServiceCode; 
   uint32       dwOldPIN;
   uint32       dwNewPIN;
} FeliCaPinChange;

//---------------------------------------------------------------------
// PINύXŎgpf[^Xg^
//---------------------------------------------------------------------
typedef struct _FeliCaPinChangeList {
   uint32           nCount;
   FeliCaPinChange  PinChangeList[FELICA_PINLIST_MAX];
} FeliCaPinChangeList;

//---------------------------------------------------------------------
// ePIN^`f[^^
//---------------------------------------------------------------------
typedef union _FeliCaPinOperateInfo {
   FeliCaPinCheckList  PinCheck; 
   FeliCaPinEnableList PinEnable; 
   FeliCaPinChangeList PinChange; 
} FeliCaPinOperateInfo;

//---------------------------------------------------------------------
// PINw肷ۂɎgp񋓌^
//---------------------------------------------------------------------
typedef enum _FeliCaPinOperate {
   FELICA_PIN_CHECK,
   FELICA_PIN_ENABLE, 
   FELICA_PIN_CHANGE
} FeliCaPinOperate;

//---------------------------------------------------------------------
// oCFeliCa`bṽI[v/N[YԂ\񋓌^
//---------------------------------------------------------------------
typedef enum _FeliCaStatus {
   FELICA_STATUS_OPENING,
   FELICA_STATUS_OPENED,
   FELICA_STATUS_CLOSING,
   FELICA_STATUS_CLOSED
} FeliCaStatus;

//---------------------------------------------------------------------
// oCFeliCa`bv̏[h\񋓌^
//---------------------------------------------------------------------
typedef enum _FeliCaMode {
   FELICA_MODE_ONLINE, 
   FELICA_MODE_OFFLINE 
} FeliCaMode;
//---------------------------------------------------------------------
// oCFeliCa`bvR}hMp\
//---------------------------------------------------------------------
typedef struct _FeliCaCommand {
   uint32            dwSize;
   uint8             byCommand[FELICA_COMMANDSIZE];
} FeliCaCommand;

//---------------------------------------------------------------------
// oCFeliCa`bvɃANZXAPǏʒʒmɎgpR[obN֐̌^
//---------------------------------------------------------------------
typedef void (*PFFELICARESULT)(void    *pUser, 
                               int      Result);

//---------------------------------------------------------------------
//ICɂĐICxgꍇɎs郊Xi[֐
//---------------------------------------------------------------------
typedef void (*PFFELICALISTENERFINISH)(void    *pUser,
                                       uint32   dwStatus);

//---------------------------------------------------------------------
// ICɂăfoCXCxgꍇɎs郊Xi[֐
//---------------------------------------------------------------------
typedef void (*PFFELICALISTENERDEVICE)(void     *pUser,
                                       uint16    wDeviceID,
                                       char     *pszParam,
                                       uint8    *pbyData,
                                       uint16    wSize);

//---------------------------------------------------------------------
// ICɂĈُICxgꍇɎs郊Xi[֐
//---------------------------------------------------------------------
typedef void (*PFFELICALISTENERERROR)(void         *pUser,
                                      int           Type,
                                      const char   *pszMessage);

/*=====================================================================
 Interface Definitions
=====================================================================*/
typedef struct IFeliCa IFeliCa;

/*=====================================================================
 IFELICA Interface
=====================================================================*/
AEEINTERFACE(IFeliCa){
   INHERIT_IBase(IFeliCa);
   // Common
   int          (*Open)                 (IFeliCa *po, PFFELICARESULT pfn, void *pUser);
   int          (*Close)                (IFeliCa *po, PFFELICARESULT pfn, void *pUser);
   FeliCaStatus (*GetStatus)            (IFeliCa *po);
   FeliCaMode   (*GetMode)              (IFeliCa *po);
   // Online
   int          (*Start)                (IFeliCa *po, const char *pszURL);
   int          (*Stop)                 (IFeliCa *po);
   int          (*SetListener)          (IFeliCa *po, 
                                         PFFELICALISTENERFINISH pfnFinish, void *pFinish,
                                         PFFELICALISTENERDEVICE pfnDevice, void *pDevice,
                                         PFFELICALISTENERERROR  pfnError,  void *pError);
   int          (*AddDevice)            (IFeliCa *po, const char *pszDeviceType, const char *pszDeviceName, uint16 *pwDeviceID);
   int          (*GetDeviceID)          (IFeliCa *po, const char *pszDeviceType, const char *pszDeviceName, uint16 *pwDeviceID);
   int          (*GetDevice)            (IFeliCa *po, uint16 wDeviceID, char *pszDeviceType, char *pszDeviceName);
   int          (*ClearAllDevices)      (IFeliCa *po);
   int          (*CompleteOperateDevice)(IFeliCa *po, const char *pszSendMsg, uint16 wSize, int nResult);
   // Offline
   int          (*SetSystemCode)        (IFeliCa *po, uint16 wSystemCode, PFFELICARESULT pfn, void *pUser);
   int          (*GetSystemCode)        (IFeliCa *po, uint16 *pwSystemCode);
   int          (*GetIDm)               (IFeliCa *po, FeliCaIDm *pIDm);
   int          (*GetICCode)            (IFeliCa *po, uint16 *pwICCode);
   int          (*GetKeyVersion)        (IFeliCa *po, FeliCaServiceList *pServiceList, FeliCaKeyVersionList *pKeyVersionList,
                                         PFFELICARESULT pfn, void *pUser);
   int          (*Read)                 (IFeliCa *po, FeliCaBlockList *pBlockList, PFFELICARESULT pfn, void *pUser);
   int          (*Write)                (IFeliCa *po, FeliCaBlockList *pBlockList, PFFELICARESULT pfn, void *pUser);
   int          (*PIN)                  (IFeliCa *po, FeliCaPinOperate Operate, FeliCaPinOperateInfo *pInfo, 
                                         PFFELICARESULT pfn, void *pUser);
   int          (*Activate)             (IFeliCa *po, PFFELICARESULT pfn, void *pUser);
   int          (*Inactivate)           (IFeliCa *po, PFFELICARESULT pfn, void *pUser);
   boolean      (*IsActivated)          (IFeliCa *po);
   int          (*SetTimeout)           (IFeliCa *po, uint32 nTimeout);
   int          (*GetTimeout)           (IFeliCa *po, uint32 *pnTimeout);
   int          (*SetRetryCount)        (IFeliCa *po, uint32 nCount);
   int          (*GetRetryCount)        (IFeliCa *po, uint32 *pnCount);
   int          (*ExecCommand)          (IFeliCa *po, FeliCaCommand *pReqCmd, FeliCaCommand *pResCmd, PFFELICARESULT pfn, void *pUser);
};

/*=====================================================================
 Function Declarations
=====================================================================*/

// Common
#define IFELICA_AddRef(p)                               AEEGETPVTBL((p),IFeliCa)->AddRef((p))
#define IFELICA_Release(p)                              AEEGETPVTBL((p),IFeliCa)->Release((p))
#define IFELICA_Open(p,pfn,pUser)                       AEEGETPVTBL((p),IFeliCa)->Open((p),(pfn),(pUser))
#define IFELICA_Close(p,pfn,pUser)                      AEEGETPVTBL((p),IFeliCa)->Close((p),(pfn),(pUser))
#define IFELICA_GetStatus(p)                            AEEGETPVTBL((p),IFeliCa)->GetStatus((p))
#define IFELICA_GetMode(p)                              AEEGETPVTBL((p),IFeliCa)->GetMode((p))
// Online
#define IFELICA_Start(p,pURL)                           AEEGETPVTBL((p),IFeliCa)->Start((p),(pURL))
#define IFELICA_Stop(p)                                 AEEGETPVTBL((p),IFeliCa)->Stop((p))
#define IFELICA_SetListener(p,pFE,pUE,pFD,pUD,pFF,pUF)  AEEGETPVTBL((p),IFeliCa)->SetListener((p),(pFE),(pUE),(pFD),(pUD),(pFF),(pUF))
#define IFELICA_AddDevice(p,pType,pName,pID)            AEEGETPVTBL((p),IFeliCa)->AddDevice((p),(pType),(pName),(pID))
#define IFELICA_GetDeviceID(p,pType,pName,pID)          AEEGETPVTBL((p),IFeliCa)->GetDeviceID((p),(pType),(pName),(pID))
#define IFELICA_GetDevice(p,ID,pType,pName)             AEEGETPVTBL((p),IFeliCa)->GetDevice((p),(ID),(pType),(pName))
#define IFELICA_ClearAllDevices(p)                      AEEGETPVTBL((p),IFeliCa)->ClearAllDevices((p))
#define IFELICA_CompleteOperateDevice(p,pMsg,pSize)     AEEGETPVTBL((p),IFeliCa)->CompleteOperateDevice((p),(pMsg),(pSize), SUCCESS)
#define IFELICA_AbortOperateDevice(p,pMsg)              AEEGETPVTBL((p),IFeliCa)->CompleteOperateDevice((p),(pMsg),(0), EFELICA_FAILED)
// Offline
#define IFELICA_SetSystemCode(p,Code,pfn,pUser)         AEEGETPVTBL((p),IFeliCa)->SetSystemCode((p),(Code),(pfn),(pUser))
#define IFELICA_GetSystemCode(p,pCode)                  AEEGETPVTBL((p),IFeliCa)->GetSystemCode((p),(pCode))
#define IFELICA_GetIDm(p,pIDm)                          AEEGETPVTBL((p),IFeliCa)->GetIDm((p),(pIDm))
#define IFELICA_GetICCode(p,pwICCode)                   AEEGETPVTBL((p),IFeliCa)->GetICCode((p),(pwICCode))
#define IFELICA_GetKeyVersion(p,pILst,pOLst,pfn,pUser)  AEEGETPVTBL((p),IFeliCa)->GetKeyVersion((p),(pILst),(pOLst),(pfn),(pUser))
#define IFELICA_Read(p,pList,pfn,pUser)                 AEEGETPVTBL((p),IFeliCa)->Read((p),(pList),(pfn),(pUser))
#define IFELICA_Write(p,pList,pfn,pUser)                AEEGETPVTBL((p),IFeliCa)->Write((p),(pList),(pfn),(pUser))
#define IFELICA_PIN(p,Ope,pInfo,pfn,pUser)              AEEGETPVTBL((p),IFeliCa)->PIN((p),(Ope),(pInfo),(pfn),(pUser))
#define IFELICA_Activate(p,pfn,pUser)                   AEEGETPVTBL((p),IFeliCa)->Activate((p),(pfn),(pUser))
#define IFELICA_Inactivate(p,pfn,pUser)                 AEEGETPVTBL((p),IFeliCa)->Inactivate((p),(pfn),(pUser))
#define IFELICA_IsActivated(p)                          AEEGETPVTBL((p),IFeliCa)->IsActivated((p))
#define IFELICA_SetTimeout(p,Time)                      AEEGETPVTBL((p),IFeliCa)->SetTimeout((p),(Time))
#define IFELICA_GetTimeout(p,pTime)                     AEEGETPVTBL((p),IFeliCa)->GetTimeout((p),(pTime))
#define IFELICA_SetRetryCount(p,Count)                  AEEGETPVTBL((p),IFeliCa)->SetRetryCount((p),(Count))
#define IFELICA_GetRetryCount(p,pCount)                 AEEGETPVTBL((p),IFeliCa)->GetRetryCount((p),(pCount))
#define IFELICA_ExecCommand(p,pRqCmd,pRsCmd,pfn,pUser)  AEEGETPVTBL((p),IFeliCa)->ExecCommand((p),(pRqCmd),(pRsCmd),(pfn),(pUser))

/*=============================================================================================

 C^tF[X

===============================================================================================

IFELICA_AddRef()

Description     :
  IFeliCaIuWFNg̎QƃJE^CNgB

Prototype       :
  uint32    IFELICA_AddRef(IFeliCa     *po);

Parameters      :
  po            : IFeliCaIuWFNgւ̃|C^

Return Value    :
  0ȏ         : I
                  CNg̎QƃJE^̒l

Comment         : 
  Ȃ

See Also        :
  IFELICA_Release()

===============================================================================================

IFELICA_Release()

Description     :
  IFeliCaIuWFNg̎QƃJE^CNgB

Prototype       :
  uint32    IFELICA_Release(IFeliCa    *po);
  
Parameters      :
  po            : IFeliCaIuWFNgւ̃|C^

Return Value    :
  0ȏ         : I
                  fNg̎QƃJE^̒l

Comment         : 
  EoCFeliCa`bv̏ԂN[YȊȌԂŃR[ꂽꍇ́AoCFeliCa`b
    vN[YԂɂB
  E{֐sꂽ_ŁAo^ĂSẴR[obN֐yуXi[֐͎s
    ɔjB
  EOnlineԂŃR[ꍇ̓́AIFELICA_Close()OnlineԂŃR[ꍇ̓
    lƂBڍׂIFELICA_Close()QƁB

See Also        :
  IFELICA_AddRef()
  IFELICA_Close()

===============================================================================================

IFELICA_Open()

Description     :
  oCFeliCa`bvI[vB
  {֐͑ɕAB
  {֐̕AlSUCCESSłꍇAI[v̗v𐳏Ɏ󂯕tƂӖB
  I[vɊǂ͎w肳ꂽR[obN֐ɂĒʒmB

Prototype       :
  int       IFELICA_Open(IFeliCa           *po,
                         PFFELICARESULT     pfn,
                         void              *pUser);

Parameters      :
  po            : IFeliCaIuWFNgւ̃|C^
  pfn           : I[vIiKŎsR[obN֐ւ̃|C^
  pUser         : R[Őݒ肷郆[Uf[^ւ̃|C^

Return Value    :
  SUCCESS               : vt
  EFELICA_BADPARAM      : pfnNULL
  EFELICA_BADSTATE      : IuWFNggp
  EFELICA_FAILED        : ُI

Comment         :
  EoCFeliCa`bvgpꍇAŏɖ{֐R[KvB
  ESUCCESSȊOAꍇAw肵R[obN֐̒ʒm͍sȂB
  EEFELICA_BADSTATEAꍇAIuWFNgɎgpłB
  ER[obN֐́AR[obN֐̎s^IFELICA_Close()̌Ăяo^IFELICA_Release()
    ̌Ăяo܂ŕێB
  Eʂ̓R[obN֐̃p[^ŒʒmBp[^̓e͈ȉƂB
      SUCCESS           : I
      EFELICA_TIMEOUT   : X|X^CAEgԓœȂꍇ
      EFELICA_FAILED    : ُI

See Also        :
  IFELICA_Close()
  PFFELICARESULT

===============================================================================================

IFELICA_Close()

Description     :
  oCFeliCa`bvN[YB
  {֐͑ɕAB
  {֐̕AlSUCCESSłꍇAN[Y̗v𐳏Ɏ󂯕tƂӖB
  N[YɊǂ͎w肳ꂽR[obN֐ɂĒʒmB

Prototype       :
  int       IFELICA_Close(IFeliCa          *po
                          PFFELICARESULT    pfn,
                          void             *pUser);

Parameters      :
  po            : IFeliCaIuWFNgւ̃|C^
  pfn           : N[YIiKŎsR[obN֐ւ̃|C^
  pUser         : R[Őݒ肷郆[Uf[^ւ̃|C^

Return Value    :
  SUCCESS               : vt
  EFELICA_BADPARAM      : pfnNULL
  EFELICA_CLOSED        : łɃN[Y
  EFELICA_FAILED        : ُI

Comment         :
  ESUCCESSAꍇAo^ĂSẴR[obN֐͎sɔjB
  ESUCCESSȊOAꍇAw肵R[obN֐̒ʒm͍sȂB
  EOnlineԂŃR[ꍇAFSSAvP[VƂ̒ʐMIɏIB
  ER[obN֐́AR[obN֐̎s^IFELICA_Release()̌Ăяo܂ŕێB
  Eʂ̓R[obN֐̃p[^ŒʒmBp[^̓e͈ȉƂB
      SUCCESS           : I
      EFELICA_FAILED    : ُI

See Also        :
  IFELICA_Open()
  PFFELICARESULT

===============================================================================================

IFELICA_GetStatus()

Description     :
  oCFeliCa`bṽI[v^N[YԂ擾B

Prototype       :
  FeliCaStatus  IFELICA_GetStatus(IFeliCa  *po) ;

Parameters      :
  po            : IFeliCaIuWFNgւ̃|C^

Return Value    :
  FELICA_STATUS_OPENING : wIuWFNg̃I[vs
  FELICA_STATUS_OPENED  : wIuWFNgɃI[vς
  FELICA_STATUS_CLOSING : wIuWFNg̃N[Ys
  FELICA_STATUS_CLOSED  : wIuWFNgɃN[Yς

Comment         :
  Ȃ

See Also        :
  IFELICA_Open()
  IFELICA_Close()
  FeliCaStatus

===============================================================================================

IFELICA_GetMode()

Description     :
  ݂̏[h擾B
  [hOnlineԂOfflineԂ̂ꂩłB

Prototype       :
  FeliCaMode    IFELICA_GetMode(IFeliCa    *po);

Parameters      :
  po            : IFeliCaIuWFNgւ̃|C^

Return Value    :
  FELICA_MODE_ONLINE    : Online
  FELICA_MODE_OFFLINE   : Offline

Comment         :
  EoCFeliCa`bvN[YԂ̏ꍇ́AFELICA_MODE_OFFLINEԂB

See Also        :
  FeliCaMode

===============================================================================================

IFELICA_Start()

Description     :
  URLŎw肵T[oƂ̃ICJnB
  {֐͑ɕAB
  {֐SUCCESSŕA_OnlineԂƂȂB
  ʐMIꍇAIFELICA_SetListener()ɂēo^ICxgpXi[
  (PFFELICALISTENERFINISH)sB
  ʐMُIꍇAIFELICA_SetListener()ɂēo^ُICxgpXi[
  (PFFELICALISTENERERROR)sB

Prototype       :
  int       IFELICA_Start(IFeliCa      *po,
                          const char   *pszURL);

Parameters      :
  po            : IFeliCaIuWFNgւ̃|C^
  pszURL        : URL񂪊i[Ă̈ւ̃|C^
                  URLNULLI[邱

Return Value    :
  SUCCESS               : vt
  EFELICA_BADPARAM      : pszURLNULL
  EFELICA_BADSTATE      : ȉ̂ꂩ̏Ԃłꍇ
                            Online
                            Active
  EFELICA_BUSY          : oCFeliCa`bvփANZX̏ꍇ
  EFELICA_CLOSED        : oCFeliCa`bvI[vĂȂ
  EFELICA_FAILED        : ُI
                          ׂẴXi[֐o^ĂȂꍇ

Comment         :
  {֐SUCCESS𕜋A_烊Xi[֐ŏIʒm܂ŁAOnlineԂƂȂB
  OnlineԂłOffline@\ׂ̂ĂOnline@\̈ꕔgpsƂȂB
  ׂẴXi[֐o^ĂȂԂŁA{֐sꍇAEFELICA_FAILEDԋp
  B]āA{֐gpOɁAIFELICA_SetListener()ɂāAׂẴXi[֐
  o^ĂƁB

See Also        :
  IFELICA_Stop()
  IFELICA_SetListener()
  PFFELICALISTENERFINISH
  PFFELICALISTENERERROR

===============================================================================================

IFELICA_Stop()

Description     :
  IC𒆒fB
  {֐͑ɕAB
  fꍇAOfflineԂƂAIFELICA_SetListener()ɂēo^ُI
  CxgpXi[֐(PFFELICALISTENERERROR)sB

Prototype       :
  int       IFELICA_Stop(IFeliCa   *po);

Parameters      :
  po            : IFeliCaIuWFNgւ̃|C^

Return Value    :
  SUCCESS               : vt
  EFELICA_CLOSED        : oCFeliCa`bvI[vĂȂ
  EFELICA_BADSTATE      : Offline
  EFELICA_FAILED        : ُI

Comment         :
  E{֐SUCCESSŕAꍇAʐMf̗v󂯕tƂӖB
    ۂ̒ʐMfُ͈ĨXi[֐(PFFELICALISTENERERROR)ɂĒʒmB
    ̃Xi[֐s܂ł̊Ԃɖ{֐R[ꍇA{֐SUCCESS𕜋AA
    sȂB

See Also        :
  IFELICA_Start()
  IFELICA_SetListener()
  PFFELICALISTENERERROR

===============================================================================================

IFELICA_SetListener()

Description     :
  ICɂăCxgꍇɃR[obN֐郊Xi[֐ݒ肷B

Prototype       :
  int       IFELICA_SetListener(IFeliCa                *po,
                                PFFELICALISTENERFINISH  pfnFinish,
                                void                   *pFinish,
                                PFFELICALISTENERDEVICE  pfnDevice,
                                void                   *pDevice,
                                PFFELICALISTENERERROR   pfnError,
                                void                   *pError);

Parameters      :
  po            : IFeliCaIuWFNgւ̃|C^
  pfnFinish     : ICɂĐICxg_ŁAs郊X
                  i[֐̃|C^
  pFinish       : R[Őݒ肷郆[Uf[^ւ̃|C^
                  (PFFELICALISTENERFINISHp)
  pfnDevice     : ICɂăfoCXCxg_ŁAs
                  Xi[֐̃|C^
  pDevice       : R[Őݒ肷郆[Uf[^ւ̃|C^
                  (PFFELICALISTENERDEVICEp)
  pfnError      : ICɂĈُICxg_ŁAs郊X
                  i[֐̃|C^
  pError        : R[Őݒ肷郆[Uf[^ւ̃|C^
                  (PFFELICALISTENERERRORp)

Return Value    :
  SUCCESS               : I
  EFELICA_BADSTATE      : OnlineԂłꍇ
  EFELICA_FAILED        : ُI

Comment         :
  E{֐ɂăXi[֐o^ꂽɁAēx{֐R[ꂽꍇ́Ao^Xi[
    ֐㏑B܂Ao^Xi[֐jꍇ͔jXi[֐̕
    (pfnFinish/pfnDevice/pfnError̂ꂩ́AS)NULLwɂĎsB
  Eݒ肵Xi[֐́Aēx{֐s邩AIFELICA_Release()s܂ŕێB

See Also        :
  IFELICA_Start()
  IFELICA_Stop()
  PFFELICALISTENERFINISH
  PFFELICALISTENERDEVICE
  PFFELICALISTENERERROR

===============================================================================================

IFELICA_AddDevice()

Description     :
  ICɂăCxgꍇɃR[obN֐郊Xi[֐ݒ肷B

Prototype       :
  int       IFELICA_AddDevice(IFeliCa      *po,
                              const char   *pszDeviceType,
                              const char   *pszDeviceName,
                              uint16       *pwDeviceID);

Parameters      :
  po            : IFeliCaIuWFNgւ̃|C^
  pszDeviceType : foCX^CvASCIIR[h(0x21 - 0x7E)Ŏw肷
                  񒷂1ȏ255ȉ(oCg)
                  NULLI[邱
  pszDeviceName : foCXASCIIR[h(0x21 - 0x7E)Ŏw肷
                  񒷂1ȏ255ȉ(oCg)
                  NULLI[邱
  pwDeviceID    : foCXIDi[̈ւ̃|C^
                  svȏꍇNULLw

Return Value    :
  SUCCESS               : I
  EFELICA_BADSTATE      : OnlineԂłꍇ
  EFELICA_EXIST         : łɓo^ς݂̃foCXo^̏ꍇ
  EFELICA_NOMEMORY      : s
  EFELICA_BADPARAM      : ȉ̂ꂩ̏ꍇ
                            pszDeviceTypeNULL
                            pszDeviceType̕񒷂1܂256ȏ
                            pszDeviceType\f[^[ 0x21 ] ȏ [ 0x7E ] ȉłȂꍇ
                            pszDeviceNameNULL
                            pszDeviceName̕񒷂1܂256ȏ
                            pszDeviceName\f[^[ 0x21 ] ȏ [ 0x7E ] ȉłȂꍇ
  EFELICA_FAILED        : ُI

Comment         :
  E{֐IFELICA_Start()sOɃR[ꂽ̂FSSAvP[VɃfoC
    X̒ǉsƂłB
  EpwDeviceIDNULLwsꍇAfoCXID͕ԋpȂA͒ʏʂ
    ɍsB
  EpszDeviceTypepszDeviceNamȇgݍ킹Aɓo^Ăꍇ́A炽߂Ēǉ
    ɂłɓo^ς݂ƂB
  Eȉ̃foCX͂炩߃T[oɓo^Ă̂ŁA{֐ɂēo^ȂĂgp
    邱Ƃ\łB

    foCX            foCX^Cv  foCX  foCXID
    
    oCFeliCa`bv"FeliCa"        "R/W"       0x0001
    ėpfBXvC    "Generic"       "Display"   0x0002

See Also        :
  IFELICA_GetDeviceID()
  IFELICA_GetDevice()
  IFELICA_ClearAllDevices()

===============================================================================================

IFELICA_GetDeviceID()

Description     :
  foCX^CvAfoCXw肵đΉfoCXID擾B

Prototype       :
  int       IFELICA_GetDeviceID(IFeliCa    *po,
                                const char *pszDeviceType,
                                const char *pszDeviceName,
                                uint16     *pwDeviceID);

Parameters      :
  po            : IFeliCaIuWFNgւ̃|C^
  pszDeviceType : foCX^CvASCIIR[h(0x21 - 0x7E)Ŏw肷
                  񒷂1ȏ255ȉ(oCg)
                  NULLI[邱
  pszDeviceName : foCXASCIIR[h(0x21 - 0x7E)Ŏw肷
                  񒷂1ȏ255ȉ(oCg)
                  NULLI[邱
  pwDeviceID    : foCXIDi[̈ւ̃|C^

Return Value    :
  SUCCESS               : I
  EFELICA_NOTEXIST      : w肳ꂽfoCX݂Ȃ
  EFELICA_BADPARAM      : ȉ̂ꂩ̏ꍇ
                            pszDeviceTypeNULL
                            pszDeviceType̕񒷂1܂256ȏ
                            pszDeviceType\f[^[ 0x21 ] ȏ [ 0x7E ] ȉłȂꍇ
                            pszDeviceNameNULL
                            pszDeviceName̕񒷂1܂256ȏ
                            pszDeviceName\f[^[ 0x21 ] ȏ [ 0x7E ] ȉłȂꍇ
  EFELICA_FAILED        : ُI

Comment         :
  IFELICA_AddDevice()ɂĒǉ/ԋpB

See Also        :
  IFELICA_AddDevice()
  IFELICA_GetDevice()
  IFELICA_ClearAllDevices()

===============================================================================================

IFELICA_GetDevice()

Description     :
  foCXIDw肵ăfoCX^CvAfoCX̎擾sB

Prototype       :
  int       IFELICA_GetDevice(IFeliCa      *po,
                              uint16        wDeviceID,
                              char         *pszDeviceType,
                              char         *pszDeviceName);


Parameters      :
  po            : IFeliCaIuWFNgւ̃|C^
  wDeviceID     : foCXIDw
  pszDeviceType : foCX^Cvi[̈w|C^
                  ̈̃TCY256oCgl邱
  pszDeviceName : foCXi[̈w|C^
                  ̈̃TCY256oCgl邱

Return Value    :
  SUCCESS               : I
  EFELICA_BADPARAM      : ȉ̂ꂩ̏ꍇ
                            pDeviceTypeNULL
                            pDeviceNameNULL
  EFELICA_NOTEXIST      : wDeviceIDɂĎw肳ꂽfoCXIDo^ĂȂ
  EFELICA_FAILED        : ُI

Comment         :
  IFELICA_AddDevice()ɂĒǉ/ԋpB

See Also        :
  IFELICA_AddDevice()
  IFELICA_GetDeviceID()
  IFELICA_ClearAllDevices()

===============================================================================================

IFELICA_ClearAllDevices()

Description     :
  IFELICA_AddDevice()ŒǉfoCXSč폜B

Prototype       :
  int       IFELICA_ClearAllDevices(IFeliCa     *po);

Parameters      :
  po            : IFeliCaIuWFNgւ̃|C^

Return Value    :
  SUCCESS               : I
  EFELICA_BADSTATE      : Online
  EFELICA_FAILED        : ُI

Comment         :
  IFELICA_AddDevice()ɂĒǉ/IuWFNgSč폜B

See Also        :
  IFELICA_AddDevice()
  IFELICA_GetDevice()
  IFELICA_GetDeviceID()

===============================================================================================

IFELICA_CompleteOperateDevice()

Description     :
  foCX삪IƂFeliCa Extensionɑ΂ĒʒmB

Prototype       :
  int     IFELICA_CompleteOperateDevice(IFeliCa    *po,
                                        const char *pszSendMsg,
                                        uint16      wSize);

Parameters      :
  po            : IFeliCaIuWFNgւ̃|C^
  pszSendMsg    : foCX쌋ʃbZ[Wi[Ă̈ւ̃|C^
  wSize         : foCX쌋ʃbZ[W̃TCY
                  (pszSendMsg̃TCY)
                  P : oCg
                  TCY(0)ȏ(2^16 - 17)ȉƂB

Return Value    :
  SUCCESS               : I
  EFELICA_BADPARAM      : p[^ُ
                            wSize(0)ȏ(2^16 - 17)ȉłȂꍇB
  EFELICA_NOMEMORY      : s
  EFELICA_FAILED        : ُI
                            CommentɎ^C~OȊOsꂽꍇB

Comment         :
  {֐́Aȉ̃^C~OŎs邱ƁB
    ^C~O :
      foCX샊Xi[sꂽƂAfoCX쐳IʒmA܂
      ̓foCXُIʒmR[܂(1)
      (1)
        foCX샊Xi[sAfoCX쐳IʒmA܂̓foCXُIʒm
        R[OɁAȉAPIR[ꍇA{֐͎ssƂȂB
          | ʐMf         : IFELICA_Stop()
          | N[Y         : IFELICA_Close()
          | IuWFNg : IFELICA_Release()

    foCX샊Xi[R[Å֐畜AiKŁAFeliCa Extension͑҂ԂƂȂB
    ̑҂Ԃ̉gK[foCX쐳IʒmA܂̓foCXُIʒmł邽
    ߁Aǂ炩APIKs邱ƁB
    foCX샊Xi[foCX쐳IʒmA܂̓foCXُIʒmR[
    ꂽꍇAFeliCa Extension͑҂ԂƂ͂Ȃ炸Â܂܏pB
    pszSendMsgNULL̏ꍇAFSSAvP[VɌ()݂̂ʒmB

See Also        :
  IFELICA_SetListener()
  IFELICA_AbortOperateDevice()
  IFELICA_AddDevice()
  IFELICA_GetDevice()
  IFELICA_GetDeviceID()

===============================================================================================

IFELICA_AbortOperateDevice()

Description     :
  foCX삪ُIƂFeliCa Extensionɑ΂ĒʒmB

Prototype       :
  int     IFELICA_AbortOperateDevice(IFeliCa    *po,
                                     const char *pszErrorMsg);

Parameters      :
  po            : IFeliCaIuWFNgւ̃|C^
  pszErrorMsg   : foCX쌋ʃbZ[WASCIIR[h(0x21 - 0x7E)Ŏw肷B
                  񒷂(0)ȏ(2^16 - 1)ȉ (oCg)
                  NULLI[邱

Return Value    :
  SUCCESS               : I
  EFELICA_BADPARAM      : p[^ُ
                            pszErrorMsg̕񒷂(0)ȏ(2^16 - 17)ȉłȂꍇB
  EFELICA_NOMEMORY      : s
  EFELICA_FAILED        : ُI
                            CommentɎ^C~OȊOsꂽꍇB

Comment         :
  {֐́Aȉ̃^C~OŎs邱ƁB
    ^C~O :
      foCX샊Xi[sꂽƂAfoCX쐳IʒmA܂
      ̓foCXُIʒmR[܂(1)
      (1)
        foCX샊Xi[sAfoCX쐳IʒmA܂̓foCXُIʒm
        R[OɁAȉAPIR[ꍇA{֐͎ssƂȂB
          | ʐMf         : IFELICA_Stop()
          | N[Y         : IFELICA_Close()
          | IuWFNg : IFELICA_Release()

    foCX샊Xi[R[Å֐畜AiKŁAFeliCa Extension͑҂ԂƂȂB
    ̑҂Ԃ̉gK[foCX쐳IʒmA܂̓foCXُIʒmł邽
    ߁Aǂ炩APIKs邱ƁB
    foCX샊Xi[foCX쐳IʒmA܂̓foCXُIʒmR[
    ꂽꍇAFeliCa Extension͑҂ԂƂ͂Ȃ炸Â܂܏pB
    pszErrorMsgNULL̏ꍇAFSSAvP[VɌ(s)݂̂ʒmB

See Also        :
  IFELICA_SetListener()
  IFELICA_CompleteOperateDevice()
  IFELICA_AddDevice()
  IFELICA_GetDevice()
  IFELICA_GetDeviceID()

===============================================================================================

IFELICA_SetSystemCode()

Description     :
  ΏۂƂVXẽVXeR[hݒ肷B
  {֐͑ɕAB
  {֐̕AlSUCCESSłꍇAVXeR[hݒ̗v𐳏Ɏ󂯕tƂ
  ӖB
  VXeR[h̐ݒ肪Ɋǂ́Aw肳ꂽR[obN֐ɂĒʒmB
  {֐ŁAw肳ꂽVXeR[hL[ƂIDm擾BIDm̎擾ɐꍇ
  ̂݁AVXeR[h̕ێsBɎ擾IDm̕ێsB
  ێVXeR[h́AIFELICA_Close()s܂ŗLƂB

Prototype       :
  int       IFELICA_SetSystemCode(IFeliCa          *po,
                                  uint16            wSystemCode,
                                  PFFELICARESULT    pfn,
                                  void             *pUser);

Parameters      :
  po            : IFeliCaIuWFNgւ̃|C^
  wSystemCode   : ݒ肷VXeR[h
  pfn           : VXeR[hݒ肪iKŎsR[obN֐ւ̃|C^
  pUser         : R[Őݒ肷郆[Uf[^ւ̃|C^

Return Value    :
  SUCCESS               : vt
  EFELICA_BADPARAM      : pfnNULL
  EFELICA_CLOSED        : oCFeliCa`bvI[vĂȂ
  EFELICA_BUSY          : oCFeliCa`bvփANZX̏ꍇ
  EFELICA_BADSTATE      : ȉ̂ꂩ̏Ԃłꍇ
                            Online
                            Active
  EFELICA_FAILED        : ُI

Comment         :
  EOffline@\gpꍇɍŏɎsKvB
  E߂lSUCCESSȊȌꍇAR[obN֐͎sȂB
  ER[obN֐́AR[obN֐̎s^IFELICA_Close()̌Ăяo^IFELICA_Release()
    ̌Ăяo܂ŕێB
  E{֐ŁAIDm擾ۂɎgp郂oCFeliCa`bvւ̃^CAEglAу
    gC񐔂́AIFELICA_SetTimeout()/IFELICA_SetRetryCount()ɂĐݒ肳ꂽlɈˑ
    AɈȉ̒lgpB
      ^CAEgl : FELICA_TIMEOUT_MIN    : [ 500 ](ms)
      gC   : FELICA_RETRY_MIN      : [   0 ]()
  Eʂ̓R[obN֐̃p[^ŒʒmBp[^̓e͈ȉƂB
      SUCCESS           : I
      EFELICA_TIMEOUT   : X|X^CAEgԓœȂꍇ
      EFELICA_FAILED    : ُI
                          X|Xf[^ُ킾ꍇ
                          ̑AVXeR[hݒɎsꍇ


See Also        :
  IFELICA_GetSystemCode()
  PFFELICARESULT
  FELICA_TIMEOUT_MIN
  FELICA_RETRY_MIN

===============================================================================================

IFELICA_GetSystemCode()

Description     :
  ΏۂƂȂĂVXẽVXeR[h擾B

Prototype       :
  int       IFELICA_GetSystemCode(IFeliCa  *po,
                                  uint16   *pwSystemCode);

Parameters      :
  po            : IFeliCaIuWFNgւ̃|C^
  pwSystemCode  : ΏۂƂȂĂVXeR[hi[̈ւ̃|C^

Return Value    :
  SUCCESS               : I
  EFELICA_BADPARAM      : pwSystemCodeNULL
  EFELICA_CLOSED        : oCFeliCa`bvI[vĂȂ
  EFELICA_BADSTATE      : OnlineԂłꍇ
  EFELICA_FAILED        : ُI
                          VXeR[hݒ肳ĂȂꍇ

Comment         :
  EIFELICA_SetSystemCode()ɂĐݒ肵VXeR[hԋpB

See Also        :
  IFELICA_SetSystemCode()

===============================================================================================

IFELICA_GetIDm()

Description     :
  ΏۂƂȂĂVXeIDm擾B

Prototype       :
  int       IFELICA_GetIDm(IFeliCa     *po,
                           FeliCaIDm   *pIDm);

Parameters      :
  po            : IFeliCaIuWFNgւ̃|C^
  pIDm          : IDmi[̈ւ̃|C^

Return Value    :
  SUCCESS               : I
  EFELICA_BADPARAM      : pIDmNULL
  EFELICA_CLOSED        : oCFeliCa`bvI[vĂȂ
  EFELICA_BADSTATE      : OnlineԂłꍇ
  EFELICA_FAILED        : ُI
                          VXeR[hݒ肳ĂȂꍇ

Comment         :
  EIFELICA_SetSystemCode()ɂĕێIDmԋpB

See Also        :
  IFELICA_SetSystemCode()
  FeliCaIDm

===============================================================================================

IFELICA_GetICCode()

Description     :
  ΏۂƂȂĂVXeICR[h擾B

Prototype       :
  int     IFELICA_GetICCode(IFeliCa         *po,
                            uint16          *pwICCode);

Parameters      :
  po            : IFeliCaIuWFNgւ̃|C^
  pwICCode      : ICR[hi[̈ւ̃|C^

Return Value    :
  SUCCESS               : I
  EFELICA_BADPARAM      : pwICCodeNULL
  EFELICA_CLOSED        : oCFeliCa`bvI[vĂȂ
  EFELICA_BADSTATE      : OnlineԂłꍇ
  EFELICA_FAILED        : ُI
                          VXeR[hݒ肳ĂȂꍇ

Comment         :
  EIFELICA_SetSystemCode()ɂĕێICR[hԋpB

See Also        :
  IFELICA_SetSystemCode()

===============================================================================================

IFELICA_GetKeyVersion()

Description     :
  w肵T[rX(܂̓GA)̌o[W擾B
  {֐͑ɕAB
  {֐̕AlSUCCESSłꍇAT[rXo[W擾̗v𐳏Ɏ󂯕t
  ƂӖB
  T[rXo[W擾Ɋǂ́Aw肳ꂽR[obN֐ɂĒʒmB
  o[W擾łꍇAf[^pKeyVersionList̃oɊi[B

Prototype       :
  int       IFELICA_GetKeyVersion(IFeliCa              *po,
                                  FeliCaServiceList    *pServiceList,
                                  FeliCaKeyVersionList *pKeyVersionList,
                                  PFFELICARESULT        pfn,
                                  void                 *pUser);

Parameters      :
  po                    : IFeliCaIuWFNgւ̃|C^
  pServiceList          : o[W擾T[rX(܂̓GA)w
                          T[rXɎwłől32łB
  pKeyVersionList       : o[Wi[̈ւ̃|C^
  pfn                   : T[rXo[W擾iKŎsR[obN֐ւ̃|C^
  pUser                 : R[Őݒ肷郆[Uf[^ւ̃|C^

Return Value    :
  SUCCESS               : vt
  EFELICA_BADPARAM      : ȉ̂ꂩ̏ꍇ
                            pServiceListNULL
                            pKeyVersionListNULL
                            pfnNULL
                            T[rX1ȏ32ȉłȂꍇ
  EFELICA_BUSY          : oCFeliCa`bvփANZX̏ꍇ
  EFELICA_CLOSED        : oCFeliCa`bvI[vĂȂ
  EFELICA_BADSTATE      : ȉ̂ꂩ̏Ԃłꍇ
                            Online
                            Active
  EFELICA_FAILED        : ُI
                          VXeR[hݒ肳ĂȂꍇ

Comment         :
  E߂lSUCCESSȊȌꍇAR[obN֐͎sȂB
  Ew肵T[rX(GA)݂ȂꍇAo[Wɂ0xffffi[B
  ET[rX(GA)0xffffw肵ꍇAo[WɃVXěo[Wi[B
  ER[obN֐́AR[obN֐̎s^IFELICA_Close()̌Ăяo^IFELICA_Release()
    ̌Ăяo܂ŕێB
  Eʂ̓R[obN֐̃p[^ŒʒmBp[^̓e͈ȉƂB
      SUCCESS           : I
      EFELICA_TIMEOUT   : X|X^CAEgԓœȂꍇ
      EFELICA_FAILED    : ُI
                          X|Xf[^ُ킾ꍇ
                          ̑AT[rXo[W擾Ɏsꍇ

See Also        :
  FeliCaServiceList()
  FeliCaKeyVersionList()
  PFFELICARESULT

===============================================================================================

IFELICA_Read()

Description     :
  oCFeliCa`bṽubNf[^ǂݍށB
  {֐͑ɕAB
  {֐̕AlSUCCESSłꍇAf[^ǂݍ݂̗v𐳏Ɏ󂯕tƂӖB
  f[^ǂݍ݂Ɋǂ́Aw肳ꂽR[obN֐ɂĒʒmB
  ɓǂݍ݂sꂽꍇAǂݍ݃f[^́ApBlockList̃oɊi[B

Prototype       :
  int       IFELICA_Read(IFeliCa           *po,
                         FeliCaBlockList   *pBlockList,
                         PFFELICARESULT     pfn,
                         void              *pUser);

Parameters      :
  po            : IFeliCaIuWFNgւ̃|C^
  pBlockList    : ubNXgf[^^̈ւ̃|C^
                  ubNXǵAȉ͈̔͂ƂB1ȏ12ȉ
  pfn           : f[^ǂݍ݂iKŎsR[obN֐ւ̃|C^
  pUser         : R[Őݒ肷郆[Uf[^ւ̃|C^

Return Value    :
  SUCCESS               : vt
  EFELICA_BADPARAM      : ȉ̂ꂩ̏ꍇ
                            pBlockListNULL
                            pfnNULL
                            ubNXg1ȏ12ȉłȂꍇ
  EFELICA_BUSY          : oCFeliCa`bvփANZX̏ꍇ
  EFELICA_CLOSED        : oCFeliCa`bvI[vĂȂ
  EFELICA_BADSTATE      : ȉ̂ꂩ̏Ԃłꍇ
                            Online
                            Active
  EFELICA_FAILED        : ُI
                          VXeR[hݒ肳ĂȂꍇ

Comment         :
  E߂lSUCCESSȊȌꍇAR[obN֐͎sȂB
  EpBlockListɐݒ肳Ă邷ׂẴubN̓ǂݍ݂ɐȂꍇ́ASĂ̓ǂݍ
    ݂̓LZAR[obN֐̃p[^ňُ킪|ʒmB
  ER[obN֐́AR[obN֐̎s^IFELICA_Close()̌Ăяo^IFELICA_Release()
    ̌Ăяo܂ŕێB
  Eʂ̓R[obN֐̃p[^ŒʒmBp[^̓e͈ȉƂB
      SUCCESS               : I
      EFELICA_TIMEOUT       : X|X^CAEgԓœȂꍇ
      EFELICA_BADSERVICE    : ȉ̂ꂩ̌œǂݏoɎsꍇw肵T[rX݂ĂȂw肵T[rXs
      EFELICA_BADBLOCKNO    : w肵ubNio[sœǂݏoɎsꍇ
      EFELICA_PIN_FAILED    : PINƍɂǂݏoɎsꍇ
      EFELICA_FAILED        : ُIX|Xf[^ُ킾ꍇ̑AǂݏoɎsꍇ

See Also        :
  IFELICA_Write()
  FeliCaBlockList
  PFFELICARESULT

===============================================================================================

IFELICA_Write()

Description     :
  oCFeliCa`bṽubNɃf[^ށB
  {֐͑ɕAB
  {֐̕AlSUCCESSłꍇAf[^݂̗v𐳏Ɏ󂯕tƂӖB
  f[^݂Ɋǂ́Aw肳ꂽR[obN֐ɂĒʒmB

Prototype       :
  int       IFELICA_Write(IFeliCa              *po,
                          FeliCaBlockList      *pBlockList,
                          PFFELICARESULT        pfn,
                          void                 *pUser);

Parameters      :
  po            : IFeliCaIuWFNgւ̃|C^
  pBlockList    : ubNXgf[^^̈ւ̃|C^
                  ubNXǵA1ȏ8ȉŎw肷邱
  pfn           : f[^݂iKŎsR[obN֐ւ̃|C^
  pUser         : R[Őݒ肷郆[Uf[^ւ̃|C^

Return Value    :
  SUCCESS               : vt
  EFELICA_BADPARAM      : ȉ̂ꂩ̏ꍇ
                            pBlockListNULL
                            pfnNULL
                            ubNXg1ȏ8ȉłȂꍇ
  EFELICA_BUSY          : oCFeliCa`bvփANZX̏ꍇ
  EFELICA_CLOSED        : oCFeliCa`bvI[vĂȂ
  EFELICA_BADSTATE      : ȉ̂ꂩ̏Ԃłꍇ
                            Online
                            Active
  EFELICA_FAILED        : ُI
                          VXeR[hݒ肳ĂȂꍇ

Comment         :
  E߂lSUCCESSȊȌꍇAR[obN֐͎sȂB
  EpBlockList̐ݒ肳ĂAׂẴubN݂̏ɐȂꍇ́ASĂ̏
    ݂̓LZAR[obN֐̃p[^ňُ킪|ʒmB
  ER[obN֐́AR[obN֐̎s^IFELICA_Close()̌Ăяo^IFELICA_Release()
    ̌Ăяo܂ŕێB
  Eʂ̓R[obN֐̃p[^ŒʒmBp[^̓e͈ȉƂB
      SUCCESS                   : I
      EFELICA_TIMEOUT           : X|X^CAEgԓœȂꍇ
      EFELICA_BADSERVICE        : ȉ̂ꂩ̌ŏ݂Ɏsꍇ
                                    w肵T[rX݂ĂȂ
                                    w肵T[rXs
      EFELICA_BADBLOCKNO        : w肵ubNio[sŏ݂Ɏsꍇ
      EFELICA_PIN_FAILED        : PINƍɂ菑݂Ɏsꍇ
      EFELICA_PURSE_FAILED      : ȉ̂ꂩ̌ŏ݂Ɏsꍇ
                                    fNg̃p[Xo[s
                                    LbVobÑp[Xo[I[o[t[
      EFELICA_CASHBACK_FAILED   : LbVobNlÕfNgl傫ꍇ
      EFELICA_CYCLIC_FAILED     : TCNbNA݃ubNTCNbNT[r
                                  X̂߂ɊmۂĂubN傫ꍇ
      EFELICA_FAILED            : ُI
                                  X|Xf[^ُ킾ꍇ
                                  ̑Af[^݂Ɏsꍇ

See Also        :
  IFELICA_Read()
  FeliCaBlockList
  PFFELICARESULT

===============================================================================================

IFELICA_PIN()

Description     :
  w肵PINp[^(PINƍ/PINL/PINύX)PINsB
  {֐͑ɕAB
  {֐̕AlSUCCESSłꍇAPIN̗v𐳏Ɏ󂯕tƂӖB
  PIN삪Ɋǂ́Aw肳ꂽR[obN֐ɂĒʒmB

Prototype       :
  int       IFELICA_PIN(IFeliCa                *po,
                        FeliCaPinOperate        Operate,
                        FeliCaPinOperateInfo   *pInfo,
                        PFFELICARESULT          pfn,
                        void                   *pUser);

Parameters      :
  po            : IFeliCaIuWFNgւ̃|C^
  Operate       : ʂw肷Bw\ȑʂ͈ȉ̂ꂩƂȂB
                    PINƍ   : FELICA_PIN_CHECK
                    PINL : FELICA_PIN_ENABLE
                    PINύX   : FELICA_PIN_CHANGE
  pInfo         : PINɕKvȏw肷BOperateɎw肵ʂɂgp\̂قȂB
                    PINƍ   : FeliCaPinCheck
                    PINL : FeliCaPinEnable
                    PINύX   : FeliCaPinChange
                    T[rX(GA)Ɏwłől8łB
  pfn           : PIN삪iKŎsR[obN֐ւ̃|C^
  pUser         : R[Őݒ肷郆[Uf[^ւ̃|C^

Return Value    :
  SUCCESS               : vt
  EFELICA_BADPARAM      : ȉ̂ꂩ̏ꍇ
                            Operates
                            pInfoNULL
                            pfnNULL
                            T[rX(GA)1ȏ8ȉłȂꍇ
  EFELICA_BUSY          : oCFeliCa`bvփANZX̏ꍇ
  EFELICA_CLOSED        : oCFeliCa`bvI[vĂȂ
  EFELICA_BADSTATE      : ȉ̂ꂩ̏Ԃłꍇ
                            Online
                            Active
  EFELICA_FAILED        : ُIVXeR[hݒ肳ĂȂꍇ

Comment         :
  E߂lSUCCESSȊȌꍇAR[obN֐͎sȂB
  ET[rX(GA)o^ĂāAȑɎsꍇAOperateɎw肳ꂽ
    lɂAU镑قȂB
      [ FELICA_PIN_CHECK  ]
        w肳ꂽPINƍsAr̃p[^PINɎsꍇłA
        ȑOŐĂPINƍ͗LƂȂBsȍ~̃T[rX(GA)PINƍ
        sȂB
        ̏ꍇAR[obN֐̃p[^ňُ킪|ʒmB
      [ FELICA_PIN_ENABLE ]
        w肳ꂽp[^̓A1łsꍇ́AׂĂPINL/͍sȂB
        ̏ꍇAR[obN֐̃p[^ňُ킪|ʒmB
      [ FELICA_PIN_CHANGE ]
        w肳ꂽp[^̓A1łsꍇ́AׂĂPINύX͍sȂB
        ̏ꍇAR[obN֐̃p[^ňُ킪|ʒmB
  Ew肳ꂽׂẴT[rX(GA)ɑ΂PIN삪Iꍇ̂݁AR[ob
    N֐̃p[^SUCCESSi[B
  ER[obN֐́AR[obN֐̎s^IFELICA_Close()̌Ăяo^IFELICA_Release()
    ̌Ăяo܂ŕێB
  E1̃I[vN[Y܂ł̊ԂɉłPIN̏8łB̏ꍇAoC
    FeliCa`bvN[YKvB
  Eʂ̓R[obN֐̃p[^ŒʒmBp[^̓e͈ȉƂB
      SUCCESS                   : I
      EFELICA_TIMEOUT           : X|X^CAEgԓœȂꍇ
      EFELICA_BADSERVICE        : ȉ̂ꂩ̌PINɎsꍇ
                                    w肵T[rX݂ĂȂ
                                    w肵T[rXs
      EFELICA_PIN_FAILEDPIN     : ƍɂPINɎsꍇ
      EFELICA_PARENT_PIN_FAILED : eGAPINƍɂPINɎsꍇ
      EFELICA_PIN_COUNT_OVERPIN : 𒴂ƂɂAPINɎsꍇ
      EFELICA_PIN_LOCKOUT       : PIN̏ƍs񐔂ɒBĂ邱ƂɂAPINɎsꍇ
      EFELICA_PIN_ATTRIBUTE     : PIN̗L/̐؂ւs̃T[rX(GA)ɑ΂āAPINL()sꍇ
      EFELICA_FAILED            : ُI
                                  X|Xf[^ُ킾ꍇ
                                  ̑APINɎsꍇ

See Also        :
  FeliCaPinOperate()
  FeliCaPinCheck()
  FeliCaPinEnable()
  FeliCaPinChange()
  FeliCaPinOperateInfo()
  PFFELICARESULT

===============================================================================================

IFELICA_Activate()

Description     :
  OҊԒʐMɎgp@\łB
  OR/WANZX҂Ԃɐݒ肷B
  {֐͑ɕAB
  {֐̕AlSUCCESSłꍇAOR/WANZX҂Ԑݒ̗v𐳏Ɏ󂯕t
  ƂӖB
  OR/WANZX҂ԂɂȂǂ́Aw肳ꂽR[obN֐ɂĒʒmB

Prototype       :
  int       IFELICA_Activate(IFeliCa           *po, 
                             PFFELICARESULT     pfn,
                             void              *pUser);

Parameters      :
  po            : IFeliCaIuWFNgւ̃|C^
  pfn           : OR/WANZX҂Ԑݒ肪iKŎsR[obN֐ւ̃|C^
  pUser         : R[Őݒ肷郆[Uf[^ւ̃|C^

Return Value    :
  SUCCESS               : vt
  EFELICA_BADPARAM      : pfnNULL
  EFELICA_ALREADY       : ActiveԂłꍇ
  EFELICA_BUSY          : oCFeliCa`bvփANZX̏ꍇ
  EFELICA_CLOSED        : oCFeliCa`bvI[vĂȂ
  EFELICA_BADSTATE      : OnlineԂłꍇ
  EFELICA_FAILED        : ُI
                          VXeR[hݒ肳ĂȂꍇ

Comment         :
  E߂lSUCCESSȊȌꍇAR[obN֐͎sȂB
  ER[obN֐́AR[obN֐̎s^IFELICA_Close()̌Ăяo^IFELICA_Release()
    ̌Ăяo܂ŕێB
  EActiveԂAēxoCFeliCa`bvփANZXꍇAIFELICA_Inactivate()
    sAAcitveԂ邩AIFELICA_Close()sAUoCFeliCa`bvN[
    YAēxIFELICA_Open()ɂăoCFeliCa`bvI[vKvB
  Eʂ̓R[obN֐̃p[^ŒʒmBp[^̓e͈ȉƂB
      SUCCESS           : I
      EFELICA_TIMEOUT   : X|X^CAEgԓœȂꍇ
      EFELICA_FAILED    : ُI
                          X|Xf[^ُ킾ꍇ

See Also        :
  IFELICA_Inactivate()
  IFELICA_IsActive()
  PFFELICARESULT

===============================================================================================

IFELICA_Inactivate()

Description     :
  OҊԒʐMɎgp@\łB
  OR/WANZX҂ԂB
  {֐̕AlSUCCESSłꍇAOR/WANZX҂ԉ̗v𐳏Ɏ󂯕t
  ƂӖB
  OR/WANZX҂Ԃłǂ́Aw肳ꂽR[obN֐ɂĒʒmB

Prototype       :
  int       IFELICA_Inactivate(IFeliCa         *po,
                               PFFELICARESULT   pfn,
                               void            *pUser);

Parameters      :
  po            : IFeliCaIuWFNgւ̃|C^
  pfn           : OR/WANZX҂ԉiKŎsR[obN֐ւ̃|C^
  pUser         : R[Őݒ肷郆[Uf[^ւ̃|C^

Return Value    :
  SUCCESS               : vt
  EFELICA_BADPARAM      : pfnNULL
  EFELICA_ALREADY       : InactiveԂłꍇ
  EFELICA_BUSY          : oCFeliCa`bvփANZX̏ꍇ
  EFELICA_CLOSED        : oCFeliCa`bvI[vĂȂ
  EFELICA_BADSTATE      : OnlineԂłꍇ
  EFELICA_FAILED        : ُI
                          VXeR[hݒ肳ĂȂꍇ

Comment         :
  E߂lSUCCESSȊȌꍇAR[obN֐͎sȂB
  ER[obN֐́AR[obN֐̎s^IFELICA_Close()̌Ăяo^IFELICA_Release()
    ̌Ăяo܂ŕێB
  E{֐ActivatedԂ̂ł邪AoCFeliCa`bv̏ԂA\ɂȂ
    ܂ł́A{֐pĂ邱ƂłȂB
  Eʂ̓R[obN֐̃p[^ŒʒmBp[^̓e͈ȉƂB
      SUCCESS           : I
      EFELICA_TIMEOUT   : X|X^CAEgԓœȂꍇ
      EFELICA_FAILED    : ُIX|Xf[^ُ킾ꍇ

See Also        :
  IFELICA_Activate()
  IFELICA_IsActive()
  PFFELICARESULT

===============================================================================================

IFELICA_IsActive()

Description     :
  OR/WANZX҂(Active)ǂ`FbNB

Prototype       :
  boolean   IFELICA_IsActive(IFeliCa   *po);

Parameters      :
  po            : IFeliCaIuWFNgւ̃|C^

Return Value    :
  TRUE          : Active
  FALSE         : ActiveԂł͂Ȃ(Inactive)

Comment         :
  None

See Also        :
  IFELICA_Activate()
  IFELICA_Inactivate()

===============================================================================================

IFELICA_SetTimeout()

Description     :
  oCFeliCa`bvɃR}h𑗐MĂ烌X|Xʒm܂ł̃^CAEglݒ肷B

Prototype       :
  int       IFELICA_SetTimeout(IFeliCa     *po,
                               uint32       nTimeout);

Parameters      :
  po            : IFeliCaIuWFNgւ̃|C^
  nTimeout      : ݒ肷^CAEgl
                  P : ~b
                  ől    : FELICA_TIMEOUT_MAX   [ 60000 ]
                  ŏl    : FELICA_TIMEOUT_MIN   [   500 ] (ftHg)

Return Value    :
  SUCCESS               : I
  EFELICA_BADPARAM      : nTimeout͈͊O
  EFELICA_BADSTATE      : OnlineԂłꍇ
  EFELICA_FAILED        : ُI
                          VXeR[hݒ肳ĂȂꍇ

Comment         :
  {֐Ń^CAEglݒsȂꍇ́AftHgl^CAEglƂĎgpB
  {֐Ń^CAEglݒ肪sꂽꍇAݒ肳ꂽĺÃoCFeliCa`bvւ
  R}hMKpB
  )
    IFELICA_Read()sÃR[obN֐sȑOɖ{֐sƂB
    ̏ꍇAɑMς݂łR}hɑ΂^CAEgl͐ݒÔ̂gpB
    oCFeliCa`bṽX|X^CAEgA܂̓X|Xf[^ُ킪A
    R}hđꍇA{֐Őݒ肳ꂽ^CAEglgpB

See Also        :
  IFELICA_GetTimeout()

===============================================================================================

IFELICA_GetTimeout()

Description     :
  oCFeliCa`bvɃR}h𑗐MĂ烌X|Xʒm܂ł̃^CAEgl擾B

Prototype       :
  int       IFELICA_GetTimeout(IFeliCa *po,
                               uint32  *pnTimeout);

Parameters      :
  po            : IFeliCaIuWFNgւ̃|C^
  pnTimeout     : ^CAEgli[邽߂̗̈ւ̃|C^
                  P : ~b

Return Value    :
  SUCCESS               : I
  EFELICA_BADPARAM      : pnTimeoutNULL
  EFELICA_BADSTATE      : OnlineԂłꍇ
  EFELICA_FAILED        : ُI
                          VXeR[hݒ肳ĂȂꍇ

Comment         :
  IFELICA_SetTimeout()Ŏw肳ꂽlԋpB
  IFELICA_SetTimeout()sĂȂꍇAftHglԋpB

See Also        :
  IFELICA_SetTimeout()

===============================================================================================

IFELICA_SetRetryCount()

Description     :
  oCFeliCa`bvփR}h𑗐MAX|XُA܂͉Ȃ^CAEg
  ꍇɁAR}hđ񐔒lݒ肷B

Prototype       :
  int       IFELICA_SetRetryCount(IFeliCa  *po,
                                  uint32    nCount);

Parameters      :
  po            : IFeliCaIuWFNgւ̃|C^
  nCount        : gC
                  P : 
                  ől    : FELICA_RETRY_MAX       [    10 ]
                  ŏl    : FELICA_RETRY_MIN       [     0 ] (ftHg)

Return Value    :
  SUCCESS               : I
  EFELICA_BADPARAM      : nCount͈͊O
  EFELICA_BADSTATE      : OnlineԂłꍇ
  EFELICA_FAILED        : ُI
                          VXeR[hݒ肳ĂȂꍇ

Comment         :
  {֐ŃgC񐔒lݒ肪sȂꍇ́AftHglgC񐔒lƂĎgpB
  {֐ŃgC񐔒lݒ肪sꂽꍇAݒ肳ꂽl͑ɓKpB
  AgC̉񐔂Alݒ肳ꂽꍇ́As̃gCŌ
  ̏ƂȂB
  )
    gC񐔒l0IFELICA_Read()sAʒʒmR[obN֐sOɁA
    {֐ŃgC񐔂5ɐݒ肵ƂB
    oCFeliCa`bṽX|X^CAEgA܂̓X|Xf[^ُ킪
    ꍇAݒ肳ꂽlɏ]gCsB

See Also        :
  IFELICA_GetRetryCount()

===============================================================================================

IFELICA_SetRetryCount()

Description     :
  oCFeliCa`bvփR}h𑗐MAX|XُA܂͉Ȃ^CAEg
  ꍇɁAR}hđ񐔒l擾B

Prototype       :
  int       IFELICA_GetRetryCount(IFeliCa  *po,
                                  uint32   *pnCount);

Parameters      :
  po            : IFeliCaIuWFNgւ̃|C^
  pnCount       : gC񐔂i[̈ւ̃|C^
                  P : 

Return Value    :
  SUCCESS               : I
  EFELICA_BADPARAM      : pnCountNULL
  EFELICA_BADSTATE      : OnlineԂłꍇ
  EFELICA_FAILED        : ُI
                          VXeR[hݒ肳ĂȂꍇ

Comment         :
  IFELICA_SetRetryCount()Ŏw肳ꂽlԋpB
  IFELICA_SetRetryCount()sĂȂꍇAftHglԋpB

See Also        :
  IFELICA_SetRetryCount()

===============================================================================================

IFELICA_ExecCommand()

Description     :
  FeliCa `bvɃR}h𑗐MAX|XM܂B
  R}hƃX|X́AWiredAccess ̃TuR}hƂȂ܂B

Prototype       :
  int       IFELICA_ExecCommand(IFeliCa         *po,
                                FeliCaCommand   *pRequest,
                                FeliCaCommand   *pResponse,
                                PFFELICARESULT   pfn,
                                void            *pUser);

Parameters      :
  po            : IFeliCa IuWFNgւ̃|C^
  pRequest      : R}hMpR}hf[^^̈ւ̃|C^
  pResponse     : X|XMpR}hf[^^̈ւ̃|C^
  pfn           : f[^ǂݍ݂iKŎsR[obN֐ւ̃|C^
  pUser         : R[Őݒ肷郆[Uf[^ւ̃|C^

Return Value    :
  SUCCESS               : vt
  EFELICA_BADPARAM      : p[^ُȉ̂ꂩ̏ꍇ
                            pRequest NULL
                            pResponse NULL
                            pRequest ̃R}hf[^TCY1 ȏ245 ȉłȂꍇ
  EFELICA_BUSY          : FeliCa `bvփANZX̏ꍇ
  EFELICA_CLOSED        : FeliCa `bvI[vĂȂ
  EFELICA_BADSTATE      : ȉ̂ꂩ̏ԂłꍇOnline Activated 
  EFELICA_FAILED        : ُI

Comment         :
  E߂lSUCCESS ȊȌꍇAR[obN֐͎s܂B
  ER[obN֐́AR[obN֐̎s^IFELICA_Close()̌Ăяo^IFELICA_Release()
    ̌Ăяo܂ŕێ܂B
  Eʂ̓R[obN֐̃p[^Œʒm܂Bp[^̓e͈ȉƂ܂B
      SUCCESS           : I
      EFELICA_TIMEOUT   : X|X^CAEgԓœȂꍇ
      EFELICA_FAILED    : ُIX|Xf[^ُ킾ꍇ̑AǂݏoɎsꍇ

See Also        :
  FeliCaCommand
  PFFELICARESULT

===============================================================================================

 }N

===============================================================================================

FELICA_GET_BLOCKLIST_RANDOM

Description     :
  IFELICA_Read()̏Aw肳ꂽ[Üɓǂݏoʂ擾B

Prototype       :
  FELICA_GET_BLOCKLIST_RANDOM(pBlockData, pData);

Parameters      :
  pBlockData    : FeliCaBlock^̈ւ̃|C^
  pData         : f[^ǂݍݗ̈ւ̃|C^̈
                  TCY : 16(bytes)

Comment         :
  IFELICA_Read()sAR[obN֐̒ʒmIꍇA{}Ngp邱
  ƂŁAǂݍ񂾃f[^Cӂ̗̈ɃRs[邱Ƃ\B

See Also        :
  IFELICA_Read()
  FeliCaBlock

===============================================================================================

FELICA_SET_BLOCKLIST_RANDOM

Description     :
  IFELICA_Write()̎sOɎw肳ꂽf[^IFELICA_Write()̃p[^֐ݒ肷B

Prototype       :
  FELICA_SET_BLOCKLIST_RANDOM(pBlockData, pData);

Parameters      :
  pBlockData    : FeliCaBlock^̈ւ̃|C^
  pData         : ݃f[^i[ꂽ̈ւ̃|C^̈
                  TCY : 16(bytes)

Comment         :
  None

See Also        :
  IFELICA_Write()
  FeliCaBlock

===============================================================================================

FELICA_GET_BLOCKLIST_CYCLIC

Description     :
  IFELICA_Read()̏Aw肳ꂽ[Üɓǂݏoʂ擾B

Prototype       :
  FELICA_GET_BLOCKLIST_CYCLIC(pBlockData, pData);

Parameters      :
  pBlockData    : FeliCaBlock^̈ւ̃|C^
  pData         : f[^ǂݍݗ̈ւ̃|C^̈
                  TCY : 16(bytes)

Comment         :
  IFELICA_Read()sAR[obN֐̒ʒmIꍇA{}Ngp邱
  ƂŁAǂݍ񂾃f[^Cӂ̗̈ɃRs[邱Ƃ\B

See Also        :
  IFELICA_Read()
  FeliCaBlock

===============================================================================================

FELICA_SET_BLOCKLIST_CYCLIC

Description     :
  IFELICA_Write()̎sOɎw肳ꂽf[^IFELICA_Write()̃p[^֐ݒ肷B

Prototype       :
  FELICA_SET_BLOCKLIST_CYCLIC(pBlockData, pData);

Parameters      :
  pBlockData    : FeliCaBlock^̈ւ̃|C^
  pData         : ݃f[^i[ꂽ̈ւ̃|C^̈
                  TCY : 16(bytes)

Comment         :
  None

See Also        :
  IFELICA_Write()
  FeliCaBlock

===============================================================================================

FELICA_GET_BLOCKLIST_PURSEDIRECT

Description     :
  IFELICA_Read()̏Aw肳ꂽ[Üɓǂݏoʂ擾B

Prototype       :
  FELICA_GET_BLOCKLIST_PURSEDIRECT(pBlockData, pdwPurse, pdwCashback, pUser, pwExID);

Parameters      :
  pBlockData    : FeliCaBlock^̈ւ̃|C^
  pdwPurse      : p[Xf[^ǂݍޗ̈ւ̃|C^̈
                  TCY : 4(bytes)
  pdwCashback   : LbVobNf[^ǂݍޗ̈ւ̃|C^̈
                  TCY : 4(bytes)
  pUser         : [Uf[^ǂݍޗ̈ւ̃|C^̈
                  TCY : 6(bytes)
  pwExID        : sIDǂݍޗ̈ւ̃|C^̈
                  TCY : 2(bytes)

Comment         :
  IFELICA_Read()sAR[obN֐̒ʒmIꍇA{}Ngp邱
  ƂŁAǂݍ񂾃f[^Cӂ̗̈ɃRs[邱Ƃ\B

See Also        :
  IFELICA_Read()
  FeliCaBlock

===============================================================================================

FELICA_SET_BLOCKLIST_PURSEDIRECT

Description     :
  IFELICA_Write()̎sOɎw肳ꂽf[^IFELICA_Write()̃p[^֐ݒ肷B

Prototype       :
  FELICA_SET_BLOCKLIST_PURSEDIRECT(pBlockData, pdwPurse, pdwCashback, pUser, pwExID);

Parameters      :
  pBlockData    : FeliCaBlock^̈ւ̃|C^
  pdwPurse      : ރp[Xf[^i[Ă̈ւ̃|C^
                  TCY : 4(bytes)
  pdwCashback   : ރLbVobNf[^i[Ă̈ւ̃|C^
                  TCY : 4(bytes)
  pUser         : ރ[Uf[^i[Ă̈ւ̃|C^
                  TCY : 6(bytes)
  pwExID        : ގsIDi[Ă̈ւ̃|C^
                  TCY : 2(bytes)

Comment         :
  None

See Also        :
  IFELICA_Write()
  FeliCaBlock

===============================================================================================

FELICA_SET_BLOCKLIST_PURSEDECREMENT

Description     :
  IFELICA_Write()̎sOɎw肳ꂽf[^IFELICA_Write()̃p[^֐ݒ肷B

Prototype       :
  FELICA_SET_BLOCKLIST_PURSEDECREMENT(pBlockData, pdwDecrement, pwExID);

Parameters      :
  pBlockData    : FeliCaBlock^̈ւ̃|C^
  pdwDecrement  : ރfNgf[^i[Ă̈ւ̃|C^
                  TCY : 4(bytes)
  pwExID        : ގsIDi[Ă̈ւ̃|C^
                  TCY : 2(bytes)

Comment         :
  None

See Also        :
  IFELICA_Write()
  FeliCaBlock

===============================================================================================

FELICA_SET_BLOCKLIST_PURSECASHBACK

Description     :
  IFELICA_Write()̎sOɎw肳ꂽf[^IFELICA_Write()̃p[^֐ݒ肷B

Prototype       :
  FELICA_SET_BLOCKLIST_PURSECASHBACK(pBlockData, pdwCashback, pwExID);

Parameters      :
  pBlockData    : FeliCaBlock^̈ւ̃|C^
  pdwCashback   : ރLbVobNf[^i[Ă̈ւ̃|C^
                  TCY : 4(bytes)
  pwExID        : ގsIDi[Ă̈ւ̃|C^
                  TCY : 2(bytes)

Comment         :
  None

See Also        :
  IFELICA_Write()
  FeliCaBlock

===============================================================================================

 f[^^

===============================================================================================

FeliCaIDm

Description     :
  IDmi[邽߂̃f[^^

Type Definition :
  typedef struct _FeliCaIDm {
     uint8        IDm[8];
  } FeliCaIDm;

Member          :
  IDm           : IDmi[̈

Comment         :
  None

See Also        :
  IFELICA_GetIDm()

===============================================================================================

FeliCaServiceList

Description     :
  T[rXXgi[f[^^

Type Definition :
  typedef struct _FeliCaServiceList {
     uint32       nCount;
     uint16       wList[FELICA_SERVICELIST_MAX];
  } FeliCaServiceList;

Member          :
  nCount        : T[rXXg
  wList         : T[rXXgi[̈

Comment         :
  E{f[^^́AȉAPIgpۂɎgpB
      IFELICA_GetKeyVersion()
      IFELICA_GetBlockInfo()
  EgpAPIɂT[rXXg̏قȂ邱Ƃɒӂ邱ƁBڍׂ͊eAPI̐QƂ邱ƁB
      wListnCountڈȍ~̗vf͖B

See Also        :
  IFELICA_GetKeyVersion()
  IFELICA_GetBlockInfo()
  FELICA_SERVICELIST_MAX

===============================================================================================

FeliCaKeyVersionList

Description     :
  T[rXXgi[f[^^

Type Definition :
  typedef FeliCaServiceList   FeliCaKeyVersionList;

Member          :
  FeliCaServiceListQ

Comment         :
  FeliCaServiceListQ

See Also        :
  FeliCaServiceList

===============================================================================================

FeliCaBlockInfoList

Description     :
  ubNi[邽߂̃f[^^

Type Definition :
  typedef FeliCaServiceList   FeliCaBlockInfoList;

Member          :
  FeliCaServiceListQ

Comment         :
  FeliCaServiceListQ

See Also        :
  FeliCaServiceList

===============================================================================================

FeliCaRandomData

Description     :
  _T[rXANZXɎgpubNf[^^

Type Definition :
  typedef struct _FeliCaRandomData {
     uint8        byBlockData[FELICA_BLOCKSIZE];
  } FeliCaRandomData;

Member          :
  byBlockData   : ubNf[^

Comment         :
  None

See Also        :
  FeliCaBlockData
  FELICA_BLOCKSIZE

===============================================================================================

FeliCaCyclicData

Description     :
  TCNbNT[rXANZXɎgpubNf[^^

Type Definition :
  typedef struct _FeliCaCyclicData {
     uint8        byBlockData[FELICA_BLOCKSIZE];
  } FeliCaCyclicData;

Member          :
  byBlockData   : ubNf[^

Comment         :
  None

See Also        :
  FeliCaBlockData
  FELICA_BLOCKSIZE

===============================================================================================

FeliCaPurseDirectData

Description     :
  p[XT[rX̃_CNgANZXƁAp[XT[rX̃f[^ǂݏoɎgpu
  bNf[^^

Type Definition :
  typedef struct _FeliCaPurseDirectData {
     uint32       dwPurseData;
     uint32       dwCashBackData;
     uint8        byUserData[FELICA_PURSE_USERDATASIZE];
     uint16       wExecutionID;
  } FeliCaPurseDirectData;

Member          :
  dwPurseData           : p[Xf[^
  dwCashBackData        : LbVobNf[^
  byUserData            : [Uf[^
  wExecutionID          : sID

Comment         :
  None

See Also        :
  FeliCaBlockData
  FELICA_PURSE_USERDATASIZE

===============================================================================================

FeliCaPurseDecrementData

Description     :
  p[XT[rX̃fNgANZXɎgpubNf[^^

Type Definition :
  typedef struct _FeliCaPurseDecrementData {
     uint32       dwDecrementData;
     uint8        byReserve[10];
     uint16       wExecutionID;
  } FeliCaPurseDecrementData;

Member          :
  dwDecrementData       : fNgf[^
  byReserve             : U[ü
  wExecutionID          : sID

Comment         :
  U[üɎw肳ꂽl͖B

See Also        :
  FeliCaBlockData

===============================================================================================

FeliCaPurseCashBackData

Description     :
  p[XT[rX̃LbVobNANZXɎgpubNf[^^

Type Definition :
  typedef struct _FeliCaPurseCashBackData {
     uint32       dwCashBackData;
     uint8        byReserve[10];
     uint16       wExecutionID;
  } FeliCaPurseCashBackData;

Member          :
  dwCashBackData        : LbVobNf[^
  byReserve             : U[ü
  wExecutionID          : sID

Comment         :
  U[üɎw肳ꂽl͖B

See Also        :
  FeliCaBlockData

===============================================================================================

FeliCaBlockData

Description     :
  eT[rX̃ubNf[^`f[^^

Type Definition :
  typedef union _FeliCaBlockData {
     FeliCaRandomData             RandomData;
     FeliCaCyclicData             CyclicData;
     FeliCaPurseDirectData        PurseDirectData;
     FeliCaPurseDecrementData     PurseDecrementData;
     FeliCaPurseCashBackData      PurseCashBackData;
  } FeliCaBlockData;

Member          :
  RandomData            : _T[rXŎgpubNf[^
  CyclicData            : TCNbNT[rXŎgpubNf[^
  PurseDirectData       : p[XT[rX̃_CNgANZXуf[^ǂݍݎɎgpubNf[^
  PurseDecrementData    : p[XT[rX̃fNgANZXɎgpubNf[^
  PurseCashBackData     : p[XT[rX̃LbVobNANZXɎgpubNf[^

Comment         :
  p̂ł邽߁Aw肷T[rXɂăANZX郁oύX邱ƁB

See Also        :
  FeliCaBlock

===============================================================================================

FeliCaBlock

Description     :
  ubNf[^Read/WriteۂɎgpf[^^

Type Definition :
  typedef struct _FeliCaBlock {
     uint16           wService;
     uint16           wBlockNo;
     FeliCaBlockData  BlockData;
  } FeliCaBlock;

Member          :
  wService      : T[rXR[hw
  wBlockNo      : ubNio[w
  BlockData     : ubNf[^w

Comment         :
  BlockDataoIFELICA_Read()̓AEgvbgƂȂAIFELIA_Write()̓CvbgƂȂB

See Also        :
  IFELICA_Read()
  IFELICA_Write()
  FeliCaBlockData
  FeliCaBlockList

===============================================================================================

FeliCaBlockList

Description     :
  ubNf[^Read/WriteۂɎgpf[^Xg^

Type Definition :
  typedef struct _FeliCaBlockList {
     uint32       nCount;
     FeliCaBlock  BlockList[FELICA_BLOCKLIST_MAX];
  } FeliCaBlockList;

Member          :
  nCount        : ubNXg
  BlockList     : ubNXg

Comment         :
  BlockListnCountڈȍ~̗vf͖B

See Also        :
  IFELICA_Read()
  IFELICA_Write()
  FeliCaBlockData
  FeliCaBlock

===============================================================================================

FeliCaPinCheck

Description     :
  PINƍŎgpf[^^

Type Definition :
  typedef struct _FeliCaPinCheck {
     uint16       wServiceCode;
     uint32       dwPIN;
  } FeliCaPinCheck;

Member          :
  wServiceCode  : T[rX(GA)
  dwPIN         : PIN

Comment         :
  None

See Also        :
  IFELICA_PIN()
  FeliCaPinCheckList

===============================================================================================

FeliCaPinCheckList

Description     :
  PINƍŎgpf[^Xg^

Type Definition :
  typedef struct _FeliCaPinCheckList {
     uint32           nCount;
     FeliCaPinCheck   PinCheckList[FELICA_PINLIST_MAX];
  } FeliCaPinCheckList;

Member          :
  nCount        : PINƍsT[rX(GA)
  PinCheckList  : PINƍXg

Comment         :
  PinCheckListnCountڈȍ~̗vf͖B

See Also        :
  IFELICA_PIN()
  FeliCaPinCheck

===============================================================================================

FeliCaPinEnable

Description     :
  PINL/PINŎgpf[^^

Type Definition :
  typedef struct _FeliCaPinEnable {
     uint16       wServiceCode; 
     uint32       dwPIN;
     boolean      bFlag;
  } FeliCaPinEnable;

Member          :
  wServiceCode  : T[rX(GA)
  dwPIN         : PIN
  bFlag         : L/̃tO
                    LFTRUE
                    FFALSE

Comment         :
  None

See Also        :
  IFELICA_PIN()
  FeliCaPinEnableList

===============================================================================================

FeliCaPinEnableList

Description     :
  PINL/PINŎgpf[^Xg^

Type Definition :
  typedef struct _FeliCaPinEnableList {
     uint32           nCount; 
     FeliCaPinEnable  PinEnableList[FELICA_PINLIST_MAX]; 
  } FeliCaPinEnableList;

Member          :
  nCount        : PINL/PINsT[rX(GA)
  PinEnableList : PINL/PINXg

Comment         :
  PinEnableListnCountڈȍ~̗vf͖B

See Also        :
  IFELICA_PIN()
  FeliCaPinEnable

===============================================================================================

FeliCaPinChange

Description     :
  PINύXŎgpf[^^

Type Definition :
  typedef struct _FeliCaPinChange {
     uint16       wServiceCode; 
     uint32       dwOldPIN;
     uint32       dwNewPIN;
  } FeliCaPinChange;

Member          :
  wServiceCode  : T[rX(GA)
  dwOldPIN      : ύXOPIN
  dwNewPIN      : ύXPIN

Comment         :
  None

See Also        :
  IFELICA_PIN()
  FeliCaPinChangeList

===============================================================================================

FeliCaPinChangeList

Description     :
  PINύXŎgpf[^Xg^

Type Definition :
  typedef struct _FeliCaPinChangeList {
     uint32           nCount;
     FeliCaPinChange  PinChangeList[FELICA_PINLIST_MAX];
  } FeliCaPinChangeList;


Member          :
  nCount        : PINύXsT[rX(GA)
  PinChangeList : PINύXXg

Comment         :
  PinChangeListnCountڈȍ~̗vf͖B

See Also        :
  IFELICA_PIN()
  FeliCaPinChange

===============================================================================================

FeliCaPinOperateInfo

Description     :
  ePIN`f[^^

Type Definition :
  typedef union _FeliCaPinOperateInfo {
     FeliCaPinCheckList  PinCheck; 
     FeliCaPinEnableList PinEnable; 
     FeliCaPinChangeList PinChange; 
  } FeliCaPinOperateInfo;

Member          :
  PinCheck      : PINƍ
  PinEnable     : PINL/PIN
  PinChange     : PINύX

Comment         :
  p̂ł邽߁Aw肷T[rXɂăANZX郁oύX邱ƁB

See Also        :
  IFELICA_PIN()
  FeliCaPinCheckList
  FeliCaPinEnableList
  FeliCaPinChangeList

===============================================================================================

FeliCaPinOperate

Description     :
  PINw肷ۂɎgp񋓌^

Type Definition :
  typedef enum _FeliCaPinOperate {
     FELICA_PIN_CHECK,
     FELICA_PIN_ENABLE, 
     FELICA_PIN_CHANGE
  } FeliCaPinOperate;

Member          :
  FELICA_PIN_CHECK      : PINƍ
  FELICA_PIN_ENABLE     : PINL/PIN
  FELICA_PIN_CHANGE     : PINύX

Comment         :
  IFELICA_PIN()̑ʂw肷ۂɎgpB

See Also        :
  IFELICA_PIN()

===============================================================================================

FeliCaPinOperate

Description     :
  oCFeliCa`bṽI[v/N[YԂ\񋓌^

Type Definition :
  typedef enum _FeliCaStatus {
     FELICA_STATUS_OPENING,
     FELICA_STATUS_OPENED,
     FELICA_STATUS_CLOSING,
     FELICA_STATUS_CLOSED
  } FeliCaStatus;

Member          :
  FELICA_STATUS_OPENING     : wIuWFNg̃I[vs
  FELICA_STATUS_OPENED      : wIuWFNgɃI[v
  FELICA_STATUS_CLOSING     : wIuWFNg̃N[Ys
  FELICA_STATUS_CLOSED      : wIuWFNgɃN[Y

Comment         :
  IFELICA_GetStatus()sꂽꍇɁA{񋓌^̃o߂lƂĎgpB

See Also        :
  IFELICA_GetStatus()

===============================================================================================

FeliCaMode

Description     :
  oCFeliCa`bv̏[h\񋓌^

Type Definition :
  typedef enum _FeliCaMode {
     FELICA_MODE_ONLINE, 
     FELICA_MODE_OFFLINE 
  } FeliCaMode;

Member          :
  FELICA_MODE_ONLINE    : Online
  FELICA_MODE_OFFLINE   : Offline

Comment         :
  IFELICA_GetMode()sꂽꍇɁA{񋓌^̃o߂lƂĎgpB

See Also        :
  IFELICA_GetMode()

===============================================================================================

PFFELICARESULT

Description     :
  oCFeliCa`bvɃANZXAPǏʒʒmɎgpR[obN֐̌^

Type Definition :
  typedef void (*PFFELICARESULT)(void *pUser, int Result);

Parameters      :
  pUser         : o^Ɏw肳ꂽ[Uf[^ւ̃|C^
  Result        : oCFeliCa`bv̏ʂi[

Comment         :
  Result̒lɂẮAeAPIQƁB

See Also        :
  IFELICA_Open()
  IFELICA_Close()
  IFELICA_SetSystemCode()
  IFELICA_GetKeyVersion()
  IFELICA_Read()
  IFELICA_Write()
  IFELICA_PIN()
  IFELICA_Activate()
  IFELICA_Inactivate()
  IFELICA_GetBlockInfo()

===============================================================================================

PFFELICALISTENERFINISH

Description     :
  ICɂĐICxgꍇɎs郊Xi[֐

Type Definition :
  typedef void (*PFFELICALISTENERFINISH)(void *pUser, uint16 wStatus);

Parameters      :
  pUser         : o^Ɏw肳ꂽ[Uf[^ւ̃|C^
  wStatus       : Xe[^X(FSSAvP[V̏IR[h)

Return Value    :
  None

Comment         :
  EoCFeliCa`bv̓ZbgAFSSAvP[VύXꂽ^CAEgl
    ƃgCAyђǉꂽfoCXXgNABoCFeliCa`bvZbg
    ƁAPIN̉NAB

See Also        :
  IFELICA_SetListener()

===============================================================================================

PFFELICALISTENERDEVICE

Description     :
  ICɂăfoCXCxgꍇɎs郊Xi[֐

Type Definition :
  typedef void (*PFFELICALISTENERDEVICE)(void   *pUser,
                                         uint16  wDeviceID,
                                         char   *pszParam,
                                         uint8  *pbyData,
                                         uint16  wSize);

Parameters      :
  pUser         : o^Ɏw肳ꂽ[Uf[^ւ̃|C^
  wDeviceID     : foCXID
  pszParam      : FSSAvP[Ṽp[^
                  NULLI[܂łLƂȂB
  pbyData       : FSSAvP[Ṽf[^
  wSize         : FSSAvP[Ṽf[^̃TCY(pbyDatãTCY)
                  P : oCg

Return Value    :
  SUCCESS               : I
  EFELICA_FAILED        : ُI

Comment         :
  E{֐sfoCX삪IꍇAfoCX쐳Iʒm
    (IFELICA_CompleteOperateDevice())Ks邱ƁB
  E{֐sfoCX삪ُIꍇAfoCXُIʒm
    (IFELIICA_AbortOperateDevice())Ks邱ƁB
  EfoCX̌ʂFSSAvP[Vɒʒmꍇ́AfoCX쐳I
    mA܂̓foCXُIʒm̃p[^ɌʃbZ[Wt邱ƁB

See Also        :
   IFELICA_SetListener()
   IFELICA_CompleteOperateDevice()
   IFELIICA_AbortOperateDevice()

===============================================================================================

PFFELICALISTENERERROR

Description     :
  ICɂĈُICxgꍇɎs郊Xi[֐

Type Definition :
  typedef void (*PFFELICALISTENERERROR)(void *pUser, int Type, const char *pszMessage);

Parameters      :
  pUser         : o^Ɏw肳ꂽ[Uf[^ւ̃|C^
  Type          : I^Cv
  pszMessage    : ڍ׃bZ[W

Return Value    :
  None

Comment         :
  EoCFeliCa`bv̓ZbgAFSSAvP[VύXꂽ^CAE
    glƃgCAyђǉꂽfoCXXgNABoCFeliCa`bv
    ZbgƁAPIN̉NAB
  EI^Cv^ڍ׃bZ[W̑gAȉɋLڂB

    ُǏ                    I^Cv                  ڍ׃bZ[W
    
    ICɁA              EFELICA_INTERRUPTED         Ȃ(NULL)
    IFELICA_Stop()Ăяoꍇ                                
    
    ICɁA              BREWK̃G[R[h      Ȃ(NULL)
    ʐMnG[ꍇ        yBrew API ReferencezQ  
    
    ICɁA              EFELICA_HTTP                "Http Error(XXX)"
    HTTP/HTTPSñG[ꍇ                            1
    
    ICɁA              EFELICA_TCAP                TCAPbZ[W̃f[^
    FSSAvP[VG[                             
    ʒmꂽꍇ                                                
    
    ICɁA              EFELICA_FAILED              Ȃ(NULL)
    ̑̃G[ꍇ                                  

    1 : XXXɂAEEWeb.hɂċK肳HTTP/HTTPSnG[R[h̒l𕶎ƂĊi[B

  E{Xi[֐ُ͈Ǐɂs^C~OقȂB
    s^C~Oȉ̕\ɎB

    ُǏ                    s^C~O
    
    ICɁA              FSSAvP[V̒ʐMIbZ[W
    IFELICA_Stop()Ăяoꍇ    M^C~O
    
    ICɁA              ʐMnG[m^C~O
    ʐMnG[ꍇ        
    
    ICɁA              HTTP/HTTPSñG[m^C~O
    HTTP/HTTPSñG[ꍇ
    
    ICɁA              FSSAvP[V̒ʐMIbZ[W
    FSSAvP[VG[ M^C~O
    ʒmꂽꍇ                    
    
    ICɁA              FSSAvP[V̒ʐMIbZ[W
    ̑̃G[ꍇ      M^C~O

See Also        :
  IFELICA_SetListener()

=============================================================================================*/

#endif // IFELICA_H
