#ifndef IFELICADEV_H
#define IFELICADEV_H
/*=============================================================================================

FILE            : IFeliCaDev.h

SERVICES        : BREW FeliCa gAPI

DESCRIPTION     : FeliCa Dev API

PUBLIC CLASSES  : Ȃ

INITIALIZATION AND SEQUENCING REQUIREMENTS : Ȃ

     Copyright 2004-2005 Felica Networks, Inc.
              All Rights Reserved.
        Felica Networks, Inc. Proprietary

=============================================================================================*/

/*=============================================================================================
 INCLUDES AND VARIABLE DEFINITIONS
=============================================================================================*/

/*=====================================================================
 Include Files
=====================================================================*/
#include "AEE.h"
#include "AEEError.h"
#include "IFeliCaDev.bid"

/*=====================================================================
 Macros
=====================================================================*/

//---------------------------------------------------------------------
// IFeliCaDev_IOCtl() Paramater
//---------------------------------------------------------------------
#define IFELICADEV_IOCTL_SETPOWERON  (1)  // Set PowerOn Status


//---------------------------------------------------------------------
// FeliCa Dev Al/
//---------------------------------------------------------------------
//#define SUCCESS             (0)         // AEEError.hɂĒ`Ă
#define EFELICADEV_FAILED     (-1)        // s
#define EFELICADEV_ALREADY    (-2)        // |[gIuWFNgɂI[vς
#define EFELICADEV_WOULDBLOCK (-3)        // 
#define EFELICADEV_NOTOPENED  (-4)        // IuWFNg|[gI[vĂȂꍇ
#define EFELICADEV_BADPARAM   (-5)        // p[^ُ
#define EFELICADEV_BADSTATE   (-6)        // ɃR[obNo^ς


/*=====================================================================
 Type Declarations
=====================================================================*/

/*=====================================================================
 Interface Definitions
=====================================================================*/
typedef struct IFeliCaDev IFeliCaDev;

/*=====================================================================
 IFELICA Interface
=====================================================================*/
AEEINTERFACE(IFeliCaDev)
{
   INHERIT_IQueryInterface(IFeliCaDev);
   int          (* Open)               (IFeliCaDev * po);
   int          (* Close)              (IFeliCaDev * po);
   int          (* Write)              (IFeliCaDev * po, const byte * pbyData, uint16 nSize);
   int          (* Writable)           (IFeliCaDev * po, AEECallback * pcb);
   int          (* Read)               (IFeliCaDev * po, byte * pbyData, uint16 nSize);
   int          (* Readable)           (IFeliCaDev * po, AEECallback * pcb);
   int          (* IOCtl)              (IFeliCaDev * po, int nOption, uint32 dwVal);
   int          (* GetLockStatus)      (IFeliCaDev * po, boolean * pbStatus);
};

/*=====================================================================
 Function Declarations
=====================================================================*/
#define IFELICADEV_AddRef(p)                       AEEGETPVTBL((p),IFeliCaDev)->AddRef((p))
#define IFELICADEV_Release(p)                      AEEGETPVTBL((p),IFeliCaDev)->Release((p))
#define IFELICADEV_QueryInterface(p, id, ppo)      AEEGETPVTBL((p),IFeliCaDev)->QueryInterface((p),(id),(ppo))
#define IFELICADEV_Open(p)                         AEEGETPVTBL((p),IFeliCaDev)->Open((p))
#define IFELICADEV_Close(p)                        AEEGETPVTBL((p),IFeliCaDev)->Close((p))
#define IFELICADEV_Write(p,pbyData,nSize)          AEEGETPVTBL((p),IFeliCaDev)->Write((p),(pbyData),(nSize))
#define IFELICADEV_Writable(p,pcb)                 AEEGETPVTBL((p),IFeliCaDev)->Writable((p),(pcb))
#define IFELICADEV_Read(p,pbyData,nSize)           AEEGETPVTBL((p),IFeliCaDev)->Read((p),(pbyData),(nSize))
#define IFELICADEV_Readable(p,pcb)                 AEEGETPVTBL((p),IFeliCaDev)->Readable((p),(pcb))
#define IFELICADEV_IOCtl(p,nOption,dwVal)          AEEGETPVTBL((p),IFeliCaDev)->IOCtl((p),(nOption),(dwVal))
#define IFELICADEV_GetLockStatus(p,pbStatus)       AEEGETPVTBL((p),IFeliCaDev)->GetLockStatus((p),(pbStatus))

/*=============================================================================================
    C^tF[X
===============================================================================================

IFELICADEV_AddRef()

Description     :
  IFeliCaIuWFNg̎QƃJE^CNgB

Prototype       :
  uint32    IFELICADEV_AddRef(IFeliCaDev * po);

Parameters      :
  po            : IFeliCaDevIuWFNgւ̃|C^

Return Value    :
  0ȏ         : I
                  CNg̎QƃJE^̒l

Comment         :
  Ȃ

See Also        :
  IFELICADEV_Release()

===============================================================================================

IFELICADEV_Release()

Description     :
  IFeliCaIuWFNg̎QƃJE^fNgB

Prototype       :
  uint32    IFELICADEV_Release(IFeliCaDev  * po) ;

Parameters      :
  po            : IFeliCaDevIuWFNgւ̃|C^

Return Value    :
  0ȏ         : I
                  fNg̎QƃJE^̒l

Comment         :
  EQƃJE^0ɂȂꍇAPortExclusion IuWFNg̉sB
    -IFELICADEV_Writable()yIFELICADEV_Readable()ɂēo^ĂR[obN֐jB
    -IuWFNgA|[gI[vĂꍇA|[g̃N[YsB

See Also        :
  IFELICADEV_AddRef()

===============================================================================================

IFELICADEV_QueryInterface()

Description     :
  ̃\bh́ÃIuWFNg̕ʂ̃IuWFNg₢킹B
  IFeliCaDevł́A₢킹ɑ΂ČJłIuWFNgȂ߁A
  FeliCaDevNX̗v̂ݎ󂯕t邱ƂƂB

Prototype       :
  int    IFELICADEV_QueryInterface(IFeliCaDev  * po,
                                   AEECLSID      idReq,
                                   void       ** ppo    );

Parameters      :
  po            : IFeliCaDevIuWFNgւ̃|C^
  idReq         : vClassIDBIuWFNgɂČJ
  ppo           : vꂽIuWFNgւ̃|C^i[|C^

Return Value    :
  SUCCESS          : I
  ENOMEMORY        : lɎsꍇ
  ECLASSNOTSUPPORT : vC^tF[XT|[gĂȂꍇ

Comment         :
  EvꂽNXIFeliCaDeṽNXłꍇA*ppoɊi[|C^ɂ́A
    IuWFNgC^tF[Xw悤ɐݒ肵AQƃJEgPCNgB
    FeliCaDevȊÕNXłꍇANULLݒ肷B

  E{\bh́AIQI̔hŃCX^XPQueryInterface()\bhƂȂA
    }NIQI_SELF()̎̂ƂĎgp邱ƂłB

See Also        :
  IFELICADEV_AddRef()

===============================================================================================

IFELICADEV_Open()

Description     :
  oCFeliCa`bvƐڑĂUART̃|[gI[vB

Prototype       :
  int       IFELICADEV_Open(IFeliCaDev * po);

Parameters      :
  po            : IFeliCaDevIuWFNgւ̃|C^

Return Value    :
  SUCCESS               : I[vA܂͊ɎIuWFNgŃI[vĂꍇB
  EFELICADEV_FAILED     : I[vs
  EFELICADEV_ALREADY    : IuWFNgI[vĂꍇ
  EFELICADEV_WOULDBLOCK : I[v

Comment         :
  EfoCX̐ɂAɃI[vłȂꍇ͕AlƂ
    EFELICADEV_WOULDBLOCKԋpB

  EI[vɁAIFELICADEV_Writable()ɂăR[obN֐o^ĂꍇA
    o^ĂR[obNsB

  E{֐̕AlSUCCESS܂EFELICADEV_WOULDBLOCKłꍇI[vԂłƂA
    ȍ~A|[gN[YI܂ł̊ԂɁÃIuWFNg{֐sꂽꍇ
    EFELICADEV_ALREADYԋpB

See Also        :
  IFELICADEV_Close()
  IFELICADEV_Writable()

===============================================================================================

IFELICADEV_Close()

Description     :
  oCFeliCa`bvƐڑĂUART̃|[gN[YB

Prototype       :
  int       IFELICADEV_Close(IFeliCaDev * po);

Parameters      :
  po            : IFeliCaDevIuWFNgւ̃|C^

Return Value    :
  SUCCESS              : N[Y
  EFELICADEV_NOTOPENED : IuWFNg|[gI[vĂȂꍇ(IuWFNg|[g
                         I[vĂA܂̓|[gN[Y)
  EFELICADEV_FAILED    : ̑G[ꍇ

Comment         :
  E{֐sꂽ_ŁAIuWFNg|[gI[vĂꍇ́A
    N[Y̌ʂɊ֌WȂIFELICADEV_Writable()IFELICADEV_Readable()ɂēo^
    ĂR[obN֐jB

  EIuWFNg|[gI[vĂȂꍇ(IuWFNg|[gI[vĂA
    ܂̓|[gN[Y)́AAlƂEFELICADEV_NOTOPENEDԋpB

See Also        :
  IFELICADEV_Open
  IFELICADEV_Writable
  IFELICADEV_Readable

===============================================================================================

IFELICADEV_Write()

Description     :
  oCFeliCa`bvɃf[^𑗐MB

Prototype       :
  int       IFELICADEV_Write(IFeliCaDev  * po,
                            const byte  * pbyData,
                            uint16        nSize);

Parameters      :
  po            : IFeliCaDevIuWFNgւ̃|C^
  pbyData       : Mf[^i[Ă̈ւ̃|C^
  nSize         : Mf[^̃TCY(pbyDatãTCY)

Return Value    :
  1ȏ                 : IMf[^̃oCgԋp
  EFELICADEV_BADPARAM   : p[^ُ
  EFELICADEV_NOTOPENED  : IuWFNg|[gI[vĂȂꍇ
                          (IuWFNg|[gI[vĂA܂̓|[gN[Y)
  EFELICADEV_WOULDBLOCK : UART|[gփf[^𑗐MłȂꍇ(M҂)
  EFELICADEV_FAILED     : ̑G[ꍇ

Comment         :
  EIꍇ͑MoCgԋpBԋpꂽoCgvoCgȂꍇ
    ēxA{֐sKvB

  EUART|[gփf[^1oCgMłȂꍇ́AAlƂEFELICADEV_WOULDBLOCKԋpB
    IFELICADEV_Writable()ɂăR[obN֐o^ĂꍇAM\ԂƂȂ_œo^
    R[obNsB

  Eȉ̏ꍇAEFELICADEV_BADPARAMԋpB
    -pbyDataNULL̏ꍇ
    -nSize0̏ꍇ

See Also        :
  IFELICADEV_Writable

===============================================================================================

IFELICADEV_Writable()

Description     :
  IFELICADEV_Open ܂ IFELICADEV_Write̕AlEFELICADEV_WOULDBLOCKꍇA
  M\ƂȂ_ŁA̎|ʒmR[obN֐o^֐B
  R[obN֐s^C~O͈ȉ̒ʂB
   -IFELICADEV_OpenŁAEFELICADEV_WOULDBLOCKԋpꍇEEE|[gI[v_
   -IFELICADEV_WriteŁAEFELICADEV_WOULDBLOCKԋpꍇEEEM\ƂȂ_

Prototype       :
  int       IFELICADEV_Writable(IFeliCaDev  * po,
                                AEECallback * pcb);

Parameters      :
  po            : IFeliCaDevIuWFNgւ̃|C^
  pcb           : M\ɂȂ_ŎsR[obN֐܂AEECallback̈ւ̃|C^

Return Value    :
  SUCCESS              : I
  EFELICADEV_BADPARAM  : p[^ُ
  EFELICADEV_NOTOPENED : IuWFNg|[gI[vĂȂꍇ(IuWFNg|[gI[vĂA
                         ܂̓|[gN[Y)
  EFELICADEV_BADSTATE  : ɃR[obNo^ς݂łꍇ
  EFELICADEV_FAILED    : ̑G[ꍇ

Comment         :
  EɃR[obNo^ς݂łꍇɖ{֐sꂽꍇAEFELICADEV_BADSTATEԋpB
    ̏ꍇAR[obN̓o^͍s킸AI[v܂́AM\ƂȂ_ŁA
    o^ĂR[obN֐sB

  E{֐R[ꂽ_ŁApcbpfnCancel(1)ɃR[obN̎sLZ邽߂̊֐o^B
    R[obN̎sLZ邽߂̊֐Ƃ́AR[obN̏j֐̂ƂłB
    pfnCancelgpAR[obNj邱ƂłB
    (1) AEECallback̃oByAEECallbackɂĂBREWAPIReferencezQ)

  Eȉ̏ꍇAEFELICADEV_BADPARAMԋpB
     -pcbNULL̏ꍇ

See Also        :
  IFELICADEV_Open
  IFELICADEV_Write

===============================================================================================

IFELICADEV_Read()

Description     :
  oCFeliCa`bṽf[^MB
Prototype       :
  int       IFELICADEV_Read(IFeliCaDev  * po,
                               byte        * pbyData,
                               uint16        nSize);

Parameters      :
  po            : IFeliCaDevIuWFNgւ̃|C^
  pbyData       : Mf[^i[̈ւ̃|C^
  nSize         : Mf[^̃TCY(pbyDatãTCY)

Return Value    :
  1ȏ                 : IMf[^̃oCgԋp
  EFELICADEV_BADPARAM   : p[^ُ
  EFELICADEV_NOTOPENED  : IuWFNg|[gI[vĂȂꍇ
                          (IuWFNg|[gI[vĂB܂́A|[gN[YԁB)
  EFELICADEV_WOULDBLOCK : UART|[gɎM\ȃf[^Ȃꍇ(M҂)
  EFELICADEV_FAILED     : ̑G[ꍇ

Comment         :
  EIꍇAMoCgԋpBf[^ׂĎMĂAnSizeɂĎw肳ꂽTCY
    Ȃꍇ́AMłTCYԋpB

  EUART|[gf[^1oCgMłȂꍇAEFELICADEV_WOULDBLOCKԋpB

  EIFELICADEV_Readable()ɂăR[obN֐o^ĂꍇAM\ԂƂȂ_
    o^ĂR[obNsB

See Also        :
  IFELICADEV_Readable

===============================================================================================

IFELICADEV_Readable()

Description     :
  IFELICADEV_Read̕AlEFELICADEV_WOULDBLOCKꍇAM\ƂȂ_ŁA
  ̎|ʒmR[obN֐o^֐B
  M\ɂȂ_ŕێR[obN֐sB
  IFELICADEV_Readsꂸɖ{֐sꂽꍇA
  M\ɂȂ_ŕێR[obN֐sB

Prototype       :
  int       IFELICADEV_Readable(IFeliCaDev  * po,
                                  AEECallback * pcb);

Parameters      :
  po            : IFeliCaDevIuWFNgւ̃|C^
  pcb           : M\ɂȂ_ŎsR[obN֐܂AEECallback̈ւ̃|C^

Return Value    :
  SUCCESS              : I
  EFELICADEV_BADPARAM  : p[^ُ
  EFELICADEV_NOTOPENED : IuWFNg|[gI[vĂȂꍇ
                         (IuWFNg|[gI[vĂB܂́A|[gN[YԁB)
  EFELICADEV_BADSTATE  : ɃR[obNo^ς݂łꍇ
  EFELICADEV_FAILED    : ̑G[ꍇ

Comment         :
  EɃR[obNo^ς݂łꍇɖ{֐sꂽꍇAEFELICADEV_BADSTATEԋpB
    ̏ꍇAR[obN̓o^͍s킸AM\ɂȂ_ŁAo^ĂR[obNsB

  E{֐R[ꂽ_ŁApcbpfnCancel(1)ɃR[obN̎sLZ邽߂̊֐o^B
    R[obN̎sLZ邽߂̊֐Ƃ́AR[obN̏j֐̂ƂłB
    pfnCancelgpAR[obNj邱ƂłB
    (1) AEECallback̃oByAEECallbackɂĂBREWAPIReferencezQ)

  EEFELICADEV_BADPARAM͈ȉ̏𖞂ꍇɕԋpB
     -pcbNULL̏ꍇ

See Also        :
  IFELICADEV_Read

===============================================================================================

IFELICADEV_IOCtl()

Description     :
  POWER ON[q̏Ԃݒ肷B

Prototype       :
  int       IFELICADEV_IOCtl(IFeliCaDev * po,
                             int          nOption,
                             uint32       dwVal   );

Parameters      :
  po            : IFeliCaDevIuWFNgւ̃|C^
  nOption       : IvVID   IFELICADEV_IOCTL_SETPOWERON - POWER ON[q̏Ԑݒ
  dwVal         : POWER ON[q̏Ԑݒ莞
                     High   :  != 0
                     Low    :  =  0

Return Value    :
  SUCCESS              : I
  EUNSUPPORTED         : IvVIDFȂꍇ
  EFELICADEV_NOTOPENED : IuWFNg|[gI[vĂȂꍇ
                         (IuWFNg|[gI[vĂA܂̓|[gN[Y)
  EFELICADEV_FAILED    : ̑G[ꍇ

Comment         :
  ɂȂB

See Also        :
  ɂȂB

===============================================================================================

IFELICADEV_GetLockStatus()

Description     :
  ړ@̕sɊi[ĂFeliCa Lock On/Off ̏Ԃ擾B

Prototype       :
  int       IFELICADEV_GetLockStatus(IFeliCaDev * po,
                                     boolean    * pbStatus);

Parameters      :
  po            : IFeliCaDevIuWFNgւ̃|C^
  pbStatus      : 擾Ԃi[̈ւ̃|C^
                     On  : TRUE
                     Off : FALSE

Return Value    :
  SUCCESS              : I
  EFELICADEV_BADPARAM  : p[^ُ
  EFELICADEV_FAILED    : ̑G[ꍇ

Comment         :
  EFELICADEV_BADPARAM ́ApbStatus NULL ̏ꍇɕԋp܂B
  {֐́A|[g̃I[vEN[YɊւ炸AĂяoƂ\łB

See Also        :
  ɂȂB

===============================================================================================
*/

#endif // __IFELICADEV_H__

