#ifndef _IKDDIDSR_H_
#define _IKDDIDSR_H_
/*======================================================================
FILE:	IKDDIDSR.h

SERVICES:
	This file provides the interfaze specification for
	the KDDI DSRSYSTEM Interface

CLASS IDs:

NOTES:

DISTRIBUTION:

Correction history:
11/29/2004:KDDI_DSR_CMDKDDI_DSR_CMD_INITIALIZEǉiސ{j
11/29/2004:KDDI_DSR_STATUSKDDI_DSR_STATUS_ERROR폜
				@KDDI_DSR_STATUS_REPORTAKDDI_DSR_STATUS_BADSTATEǉiސ{j
11/29/2004:KDDI_DSR_MASKKDDI_DSR_MASK_STARTTOBEGIN,KDDI_DSR_MASK_RESULT
                  KDDI_DSR_MASK_ERROR,KDDI_DSR_MASK_ABORT폜iސ{j
12/28/2004:KDDIDSRServerpServerPath̒ǉ(ސ{)
01/12/2005:KDDI_DSR_STATUSKDDI_DSR_STATUS_RECORDNOISEǉ(ސ{)
06/07/2005:VDSRpBREWC^tF[XɑΉ(ސ{)
07/12/2005:IKDDIDSR_SetRecognitionErrorMask̒ǋL(ސ{)
09/15/2005:KDDI Error Code̒ǋL(ސ{)
09/30/2005:KDDIDSRNetInfoAIKDDIDSR_SelectNetwork̒ǋL(ސ{)
10/20/2005:KDDI Error CodeցuKDDI_DSR_EUNSUPPORTEDv̒ǋLiސ{j
11/09/2005:u#define  KDDI_DSR_RESULT_LENGTH	128vǋLiސ{j
11/09/2005:KDDIDSRResult char* pWord  char cWord[128]ƕύXiސ{j
======================================================================*/

/*---------------------------------------------------------------------
		Include Files
---------------------------------------------------------------------*/
#include "AEE.h"
#include "KDDI_DSR.BID"


//-------------------------------------------------------------------
// Interface Definitions
//-------------------------------------------------------------------

typedef struct IKDDIDSR IKDDIDSR;

//---------------------------------------------------------------------
// KDDI DSR Error Code
//---------------------------------------------------------------------
#define  KDDI_DSR_SUCCESS			0x00000000				// 
#define  KDDI_DSR_EFAILED			0xFFFFFFFF				// s
#define  KDDI_DSR_EBADPARM			0xFFFFFFFE				// sȃp[^
#define  KDDI_DSR_EBADSTATE			0xFFFFFFFD				// ԕsv
#define  KDDI_DSR_ENORESULT			0xFFFFFFFC				// w肵ElementʓɂȂ
#define  KDDI_DSR_EUNSUPPORTED		0xFFFFFFFB				// ΉAPI̎gp

//---------------------------------------------------------------------
//KDDI_DSR_XXX_LENGTH
//	DSRp[^œ͂镶̒B
//---------------------------------------------------------------------
#define  KDDI_DSR_NAME_LENGTH			256			//RecvoC_\O̒
#define  KDDI_DSR_ADDRESS_LENGTH		16			//FT[õAhX̒
#define  KDDI_DSR_PATH_LENGTH			256			//FT[õpX̒
#define  KDDI_DSR_APPLICATION_LENGTH	1024		//AvP[V̒060705
#define  KDDI_DSR_RESULT_LENGTH			128			//Fʂ̒Pꕶ̒

//---------------------------------------------------------------------
//KDDI_DSR_ERRORMASK
//	F@\ɂG[ʁB
//071205
//---------------------------------------------------------------------
#define  KDDI_DSR_ERRORMASK_NOISE			0x00000001		//ߑwiG
#define  KDDI_DSR_ERRORMASK_OVERFLOW		0x00000002		//I[o[t[
#define  KDDI_DSR_ERRORMASK_BEGINNINGBREAK	0x00000004		//bؒf
#define  KDDI_DSR_ERRORMASK_DEFAULT			0x00000003		//ftHgݒ@ߑwiG{I[o[t[

/*PTX805	TRK1424	start	*/
//---------------------------------------------------------------------
//KDDI_DSR_DBPOWER_INTERVAL_XXX
//	p[iDBPowerjlʒmԊu̐ݒli~bj
//---------------------------------------------------------------------
#define  KDDI_DSR_DBPOWER_INTERVAL_DEFAULT	(0)				//DBPowerʒmԊu@ftHg
#define  KDDI_DSR_DBPOWER_INTERVAL_MIN		(100)			//DBPowerʒmԊu@ŏl
#define  KDDI_DSR_DBPOWER_INTERVAL_MAX		(20000)			//DBPowerʒmԊu@ől
/*PTX805	TRK1424		end	*/

//---------------------------------------------------------------------
//R}hR[h
//	R}hR[h́ACxg^Cv߂ƃNCAgɃf[^Ԃ߂ɁA
//	o^ς݃R[obN֐ĕԂB
//
//---------------------------------------------------------------------
typedef enum _KDDI_DSR_CMD
{
	KDDI_DSR_CMD_INITIALIZE,					//IKDDIDSR_Initialize()̃R}h112904
	KDDI_DSR_CMD_INITIALIZECAPTURE,				//IKDDIDSR_InitializeCapture()̃R}h060705
	KDDI_DSR_CMD_STARTCAPTURE,					//IKDDIDSR_StartCapture()̃R}h
	KDDI_DSR_CMD_STOPCAPTURE,					//IKDDIDSR_StopCapture()̃R}h
	KDDI_DSR_CMD_CANCELCAPTURE					//IKDDIDSR_CancelCapture()̃R}h
}KDDI_DSR_CMD;

//---------------------------------------------------------------------
//Xe[^XR[h
//	IKDDIDSR_RegisterNotify()œo^ꂽR[obN֐ɑ΂āADSR
//	@\ʒmAԂ\B
//
//---------------------------------------------------------------------
typedef enum  _KDDI_DSR_STATUS
{
	KDDI_DSR_STATUS_RECNOISE_START,				//Gf[^̎WJn060705
	KDDI_DSR_STATUS_RECNOISE_END,				//Gf[^̎WI060705
	KDDI_DSR_STATUS_STARTTOBEGIN,				//捞Jnꂽ
	KDDI_DSR_STATUS_BEGINCAPTURE,				//boꂽ
	KDDI_DSR_STATUS_DBPOWER,					//odBlԂ
	KDDI_DSR_STATUS_ENDCAPTURE,					//Iboꂽ
	KDDI_DSR_STATUS_SENDDATA,					//f[^Mꂽ
	KDDI_DSR_STATUS_REPORT,						//G[AXe[^X112904
	KDDI_DSR_STATUS_STOPCAPTURE,				//Ib
	KDDI_DSR_STATUS_CANCELCAPTURE,				//F̎112904
	KDDI_DSR_STATUS_ABORT,						//ُI
	KDDI_DSR_STATUS_BADSTATE					//IKDDIDR_StartCapture(),_StopCapture(),_CancelCapture()
}KDDI_DSR_STATUS;								//ɂēłȂ112904

//---------------------------------------------------------------------
//͕R[h
//	IKDDIDSR_SetAnalysisKind()ɂāA͕ύXB
//	
//060705
//---------------------------------------------------------------------
typedef enum _KDDI_DSR_ANALYSIS_KIND
{
	KDDI_DSR_ANALYSIS_AUTO,						//͕
	KDDI_DSR_ANALYSIS_KIND_ES201108,			//ETSI ES 201 108
	KDDI_DSR_ANALYSIS_KIND_ES202050				//ETSI ES 202 050
}KDDI_DSR_ANALYSIS_KIND;


//---------------------------------------------------------------------
//KDDIDSRBusiness
//	F̂߂̃RecʏێB
//
//---------------------------------------------------------------------
typedef struct  _KDDIDSRBusiness
{
	uint32  iBusinessID;								//RecvoC_\ʏ
	char  	cBusinessName[KDDI_DSR_NAME_LENGTH];		//RecvoC_\O
	uint32  iBusinessServiceID;							//RecvoC_̃T[rX\ʏ
	char  	cBusinessServiceName[KDDI_DSR_NAME_LENGTH]; //RecvoC_̃T[rX\ʏ
}KDDIDSRBusiness;


//---------------------------------------------------------------------
//KDDIDSRServer
//	FT[õT[oێB
//
//---------------------------------------------------------------------
typedef struct  _KDDIDSRServer
{
	char  	cServerAddress[KDDI_DSR_ADDRESS_LENGTH];	//FT[õAhX
	uint16  iServerPort;								//FT[õ|[g
	char	cServerPath[KDDI_DSR_PATH_LENGTH];			//FT[õpX
} KDDIDSRServer;

//---------------------------------------------------------------------
//KDDIDSRApplication
//	RecvoC_ŗL̏ێB
//
//---------------------------------------------------------------------
typedef struct  _KDDIDSRApplication 
{
	char  cApplication[KDDI_DSR_APPLICATION_LENGTH];	//RecvoC_ŗL̏
} KDDIDSRApplication;

//---------------------------------------------------------------------
//KDDIDSRParm
//	̍\̂́ADSR̊ep[^i[B
//	
//---------------------------------------------------------------------
typedef  struct  _KDDIDSRParm
{
	uint16		kddidsrAnalysisKind;			//͕060705
	uint16		iScore;							//FXRABݒ肵lȏ̒PԂ
	uint16		iNBest;							//NBest(擾łFʂ̌)̒l
	uint32		iResultMask;					//F@\̗p060705
	uint16		iStartTime;						//捞Jn甭b(n[)܂ł̃^CAEgb
	uint16		iCaptureTime;					//b(n[)JnIb܂ł̃^CAEgb
	uint16		iInterval;						//DBPowerl̒ʒmԊu060705
}KDDIDSRParm;


//---------------------------------------------------------------------
//KDDIDSRResult
//	Fʂ̏ێB
//
//---------------------------------------------------------------------
typedef struct  _KDDIDSRResult 
{
	uint16	iScore;							//Fʂ̃XRAi[
	char    cWord[KDDI_DSR_RESULT_LENGTH];	//Fʂi[
	uint32	iDataSize;						//cWord̃TCYi[
} KDDIDSRResult;

//---------------------------------------------------------------------
//KDDIDSRNotifyData
//	̍\̂́ADSRɂĂꂽCxg̃Xe[^Xɉ
//  IvVif[^i[i[B
//060705
//---------------------------------------------------------------------
typedef  struct  _KDDIDSRNotifyData
{
	int32 iData1;						//IvVif[^P
	int32 iData2;						//IvVif[^Q
} KDDIDSRNotifyData;


//---------------------------------------------------------------------
//KDDIDSRNotify
//	̍\̂́ADSRɂĂꂽCxg̏i[B
//	́Ao^ꂽR[obNʒm֐֑B
//
//---------------------------------------------------------------------
typedef  struct  _KDDIDSRNotify
{
	IKDDIDSR *pIKDDIDSR;						//IKDDIDSRւ̃|C^
	uint32  kddidsrCmd;							//R}hR[h
	uint32  kddidsrStatus;						//Xe[^XR[h
	KDDIDSRNotifyData  kddidsrNotifyData;		//Xe[^XɉăIvVif[^i[060705
} KDDIDSRNotify;


//---------------------------------------------------------------------
//KDDIDSRNetInfo
//	PPPڑlbg[N(hC)
//0930  
//---------------------------------------------------------------------
typedef struct  _KDDIDSRNetInfo 
{
	int  nNetwork;						//lbg[NID(INETMGR_SelectNetwork()Őݒ肷lbg[NID)
} KDDIDSRNetInfo;


//---------------------------------------------------------------------
//R[obN֐̌^`
//---------------------------------------------------------------------
typedef  void (*PFNKDDIDSRNOTIFY)(void  * pUser,KDDIDSRNotify  * pNotify);


//---------------------------------------------------------------------
//
//	IKDDIDSR	Interface Definition
//
//---------------------------------------------------------------------

AEEINTERFACE(IKDDIDSR){
   INHERIT_IQueryInterface(IKDDIDSR);
	int		(*SetBusiness)		(IKDDIDSR *po, KDDIDSRBusiness  kddidsrBusiness);
	int		(*SetServer)		(IKDDIDSR *po, KDDIDSRServer	kddidsrServer);
	int		(*SetAnalysisKind)	(IKDDIDSR *po, uint16	kddidsrAnalysisKind);
	int		(*SetRejectedScore) (IKDDIDSR *po, uint16	iScore);
	int		(*SetNBest)			(IKDDIDSR *po, uint16	iNBest);
	int		(*SetRecognitionErrorMask)	(IKDDIDSR *po, uint32	iResultMask);
	int		(*SetUtteranceTime) (IKDDIDSR *po, uint16	iStartTime,	uint16	iCaptureTime);
	int		(*SetDBPowerInterval) (IKDDIDSR *po, uint16	iInterval);
	int		(*SetApplication)	(IKDDIDSR *po, KDDIDSRApplication	kddidsrApplication);
	int     (*SelectNetwork)	(IKDDIDSR *po, KDDIDSRNetInfo   kddidsrNetInfo);//0930
	int		(*RegisterNotify)	(IKDDIDSR *po, PFNKDDIDSRNOTIFY pfnNotify, void *pUser);
	int		(*Initialize)		(IKDDIDSR *po);
	int		(*InitializeCapture)	(IKDDIDSR *po);
	int		(*StartCapture)		(IKDDIDSR *po);
	int		(*StopCapture)		(IKDDIDSR *po);
	int		(*CancelCapture)	(IKDDIDSR *po);
	int		(*GetResult)		(IKDDIDSR *po, char *pData, uint32* pDataSize);
	int		(*GetElemResult)	(IKDDIDSR *po, char *pElem, KDDIDSRResult* (pKDDIDSRResult[]));
	int		(*GetBusiness)		(IKDDIDSR *po, KDDIDSRBusiness*	pKddiDsrBusiness);
	int		(*GetServer)		(IKDDIDSR *po, KDDIDSRServer*	pKddiDsrServer);
	int		(*GetApplication)	(IKDDIDSR *po, KDDIDSRApplication*	pKddiDsrApplication);
	int		(*GetParm)			(IKDDIDSR *po, KDDIDSRParm *pKddiDsrParm);
#ifdef	OEMDSR_DEBUG
	int		(*HttpCb)			(IKDDIDSR *po, int status, char *pData, int iLen);
#endif	//OEMDSR_DEBUG
};

#define		IKDDIDSR_AddRef(po)						AEEGETPVTBL(po,IKDDIDSR)->AddRef(po)
#define		IKDDIDSR_Release(po)					AEEGETPVTBL(po,IKDDIDSR)->Release(po)
#define     IKDDIDSR_QueryInterface(po,c,i)         AEEGETPVTBL(po,IKDDIDSR)->QueryInterface(po,c,i)
#define     IKDDIDSR_SetBusiness(po, dsrB)          AEEGETPVTBL(po,IKDDIDSR)->SetBusiness(po, dsrB)
#define		IKDDIDSR_SetServer(po, dsrS)			AEEGETPVTBL(po,IKDDIDSR)->SetServer(po, dsrS)
#define		IKDDIDSR_SetAnalysisKind(po, dsrAK)		AEEGETPVTBL(po,IKDDIDSR)->SetAnalysisKind(po, dsrAK)
#define		IKDDIDSR_SetRejectedScore(po, iScore)	AEEGETPVTBL(po,IKDDIDSR)->SetRejectedScore(po, iScore)
#define		IKDDIDSR_SetNBest(po, iNBest)			AEEGETPVTBL(po,IKDDIDSR)->SetNBest(po, iNBest)
#define		IKDDIDSR_SetRecognitionErrorMask(po, iResultMask)	AEEGETPVTBL(po,IKDDIDSR)->SetRecognitionErrorMask(po, iResultMask)
#define		IKDDIDSR_SetUtteranceTime(po, iStartTime, iCaptureTime)	AEEGETPVTBL(po,IKDDIDSR)->SetUtteranceTime(po,iStartTime, iCaptureTime)
#define		IKDDIDSR_SetDBPowerInterval(po, iInterval)	AEEGETPVTBL(po,IKDDIDSR)->SetDBPowerInterval(po, iInterval)
#define		IKDDIDSR_SetApplication(po, dsrA)		AEEGETPVTBL(po,IKDDIDSR)->SetApplication(po, dsrA)
#define		IKDDIDSR_SelectNetwork(po, dsrNetInfo)	AEEGETPVTBL(po,IKDDIDSR)->SelectNetwork(po, dsrNetInfo)//0930
#define		IKDDIDSR_RegisterNotify(po, pfNt, pUsr)	AEEGETPVTBL(po,IKDDIDSR)->RegisterNotify(po, pfNt, pUsr)
#define		IKDDIDSR_Initialize(po)					AEEGETPVTBL(po,IKDDIDSR)->Initialize(po)
#define		IKDDIDSR_InitializeCapture(po)			AEEGETPVTBL(po,IKDDIDSR)->InitializeCapture(po)
#define		IKDDIDSR_StartCapture(po)				AEEGETPVTBL(po,IKDDIDSR)->StartCapture(po)
#define		IKDDIDSR_StopCapture(po)				AEEGETPVTBL(po,IKDDIDSR)->StopCapture(po)
#define		IKDDIDSR_CancelCapture(po)				AEEGETPVTBL(po,IKDDIDSR)->CancelCapture(po)
#define		IKDDIDSR_GetResult(po, pDt, pDtSz)		AEEGETPVTBL(po,IKDDIDSR)->GetResult(po, pDt, pDtSz)
#define		IKDDIDSR_GetElemResult(po, pEl, pRs)	AEEGETPVTBL(po,IKDDIDSR)->GetElemResult(po, pEl, pRs)
#define		IKDDIDSR_GetBusiness(po, pKDB)			AEEGETPVTBL(po,IKDDIDSR)->GetBusiness(po,	pKDB)
#define		IKDDIDSR_GetServer(po, pKDS)			AEEGETPVTBL(po,IKDDIDSR)->GetServer(po,	pKDS)
#define		IKDDIDSR_GetApplication(po, pKDA)		AEEGETPVTBL(po,IKDDIDSR)->GetApplication(po,pKDA)
#define		IKDDIDSR_GetParm(po, pKDP)			AEEGETPVTBL(po,IKDDIDSR)->GetParm(po,	pKDP)
#ifdef	OEMDSR_DEBUG
#define		IKDDIDSR_HttpCb(po, iSt, pData, iLen)	AEEGETPVTBL(po,IKDDIDSR)->HttpCb(po,	iSt, pData, iLen)
#endif	//OEMDSR_DEBUG

#endif //_IKDDIDSR_H_

/*
ȉ̓p[^̕\ɓo͂̌^݂Ăꍇ̂݁Ap[^Xg[in]A[in/out]Ay[out]B
p[^Sē̓p[^̏ꍇA[in]͏ȗB

1.1.@IKDDIDSR_SetBusiness()
F
	DSRp[^̈ł鉹F̂߂̃AvP[V/Rec
	ʏݒ肷Bݒ肷́AFVXe̗L鉹Fƃ}b
	sOAAvP[VɓKFIB
	AvP[V̏Nɂ͕Kݒ肷KvB
vg^CvF
	int IKDDIDSR_SetBusiness
		(
		IKDDIDSR * pIKDDIDSR,
		KDDIDSRBusiness  kddidsrBusiness
		)
p[^F
	pIKDDIDSR	IKDDIDSRC^tF[XIuWFNgւ̃|C^B
	kddidsrBusiness	F̂߂̃AvP[V/RecʏB
߂lF
	KDDI_DSR_SUCCESS	IB삪B
	KDDI_DSR_EBADPARM	sȃp[^B
	KDDI_DSR_EFAILED	sB
RgF
AvP[V/Recʏ́AKDDI蓖ĂƊǗsBAvP[V/Recʏ̏ڍׂ́AKDDIS҂֏Ɖ̂ƁB
QƁF
	KDDIDSRBusiness
 
1.2.@IKDDIDSR_SetServer()
F
	DSRp[^̈ł鉹FT[õT[oݒ肷B
	̃XebvȗƁAKDDI̎w肷鉹FT[õT[o
ݒ肳
vg^CvF
	int IKDDIDSR_SetServer
		(
		IKDDIDSR * pIKDDIDSR,
		KDDIDSRServer@kddidsrServer
		)
p[^F
	pIKDDIDSR	IKDDIDSRC^tF[XIuWFNgւ̃|C^B
	kddidsrServer	FT[õT[oB
					ftHgKDDI̕ێT[õAhXA|[gApX
B

߂lF
	KDDI_DSR_SUCCESS	IB삪B
	KDDI_DSR_EBADPARM	sȃp[^B
KDDI_DSR_EFAILED	sB
RgF
FVXeIPAhXA|[gԍApX̏ڍׂ́AKDDI܂
FVXe̒񋟎Ǝ҂֏Ɖ̂ƁB
QƁF
	KDDIDSRServer

 
1.3.@IKDDIDSR_SetAnalysisKind()
F
	DSRNCAgɂ鉹͕ݒ肷B͕ɂ́Aȉ3
	̕B
	 	KDDI_DSR_ANALYSIS_AUTO	@͕󋵂ɉĐ؂ւB
	 	KDDI_DSR_ANALYSIS_KIND_ES201108@xBG΍ȂB
	 	KDDI_DSR_ANALYSIS_KIND_ES202050@xxBG΍􂠂B
	̃Xebvȗ" KDDI_DSR_ANALYSIS_KIND_ES201108"ݒ肳B
vg^CvF
	int IKDDIDSR_SetAnalysisKind
		(
		IKDDIDSR * pIKDDIDSR,
		uint16  kddidsrAnalysisKind
		)
p[^F
	pIKDDIDSR		IKDDIDSRC^tF[XIuWFNgւ̃|C^B
	kddidsrAnalysisKind	DSRNCAg͕̉B
߂lF
	KDDI_DSR_SUCCESS	IB삪B
	KDDI_DSR_EBADPARM	sȃp[^B
	KDDI_DSR_EFAILED	sB
RgF
FsAvP[Vɍ킹ĉ͕ݒ肷邱ƂłB
QƁF
	KDDI_DSR_ANALYSIS_KIND
 
1.4.@IKDDIDSR_SetRejectedScore()
F
	DSRp[^ł鉹Fʂ̃XRA(ޓx)臒lݒ肷B
	iScoreŐݒ肵lȉ̉Fʂ́AAvP[Vɖ߂錋ʂɊ܂܂ȂB
	̃XebvȗƁAftHglƂiScore	ɂ "30"ݒ肳B
vg^CvF
	int IKDDIDSR_SetRejectedScore
		(
		IKDDIDSR * pIKDDIDSR,
		uint16 	iScore,
		)
p[^F
	pIKDDIDSR	IKDDIDSRC^tF[XIuWFNgւ̃|C^B
	iScore		XRA臒lBݒ肵lȉ̃XRAłPjB
				ftHgl30Bݒ͈͂0`100B
߂lF
	KDDI_DSR_SUCCESS	IB삪B
	KDDI_DSR_EBADPARM	sȃp[^B
	KDDI_DSR_EFAILED	sB
 
1.5.@IKDDIDSR_SetNBest()
F
	DSRp[^łNBest(擾łFʂ̌)ݒ肷B
	FGWŕ̌ʂꍇAFXRA̍̂珇iNBestŐݒ肵lőƂČʂԂB
	̃XebvȗƁAftHglƂiNBestɂ"5" ݒ肳B
vg^CvF
	int IKDDIDSR_SetNBest
		(
		IKDDIDSR * pIKDDIDSR,
		uint16	iNBest
		)
p[^F
	pIKDDIDSR	IKDDIDSRC^tF[XIuWFNgւ̃|C^B
	iNBest		NBest̒lBݒ肵lFʂԂő吔B
			ftHgl5Bݒ͈͂1`10B
߂lF
	KDDI_DSR_SUCCESS	IB삪B
	KDDI_DSR_EBADPARM	sȃp[^B
	KDDI_DSR_EFAILED	sB
 
1.6.@IKDDIDSR_SetRecognitionErrorMask()@
F
	F@\ɂG[mꂽꍇɁA̋@\𗘗pĉFI邩A
	FpăT[oփANZXĔFʂ擾邩}XNɂw肷B
	F͈ȉ̒ʂB
	 	ӎG傫iߑwiGj
	 	傫iI[o[t[j
	 	bn߂擪؂Ăibؒfj
	̃G[mƂKDDI_DSR_STATUS_REPORTŒʒmBiʒm̃^C~OɂĉLRgQƁj
	iResultMask "0"w肷ƁAG[mꂽɉFIAT[oփANZX邱Ƃ͖B
	̃XebvȗƁAftHgiߑwiG{I[o[t[jݒ肳B
vg^CvF
	int IKDDIDSR_SetRecognitionErrorMask
		(
		IKDDIDSR * pIKDDIDSR,
		uint32  iResultMask
		)
p[^F
	pIKDDIDSR 	IKDDIDSRC^tF[XIuWFNgւ̃|C^B
	iResultMask	FɂG[}XNB
				KDDI_DSR_ERRORMASK_NOISEFߑwiG
				KDDI_DSR_ERRORMASK_OVERFLOWFI[o[t[
				KDDI_DSR_ERRORMASK_BEGINNINGBREAKFbؒf
				KDDI_DSR_ERRORMASK_DEFAULTFftHg
							iߑwiG{I[o[t[j
߂lF
	KDDI_DSR_SUCCESS	IB삪B
	KDDI_DSR_EBADPARM	sȃp[^B
	KDDI_DSR_EFAILED	sB
RgF
EG[KDDI_DSR_STATUS_REPORTkddidsrNotifyDataiData1
i[B
EFpꍇƁAIꍇɂăG[ʒm̃^C~OقȂB
	yFpz
		Fʎ擾AFʐƂƂKDDI_DSR_STATUS_REPORTŃG[ʒmBiׂẴG[ʁj
	yFIz
		F𒆎~AKDDI_DSR_STATUS_REPORTɂ艺L̃^C~OŃG[ʒmB
		KDDI_DSR_STATUS_RECNOISE_ENDʒmiߑwiĜ݁j
		KDDI_DSR_STATUS_ENDCAPTUREʒmiׂẴG[ʁj
		KDDI_DSR_STATUS_STOPCAPTUREʒmiׂẴG[ʁj

 
1.7.@IKDDIDSR_SetUtteranceTime()
F
	DSRp[^ł鉹捞Jn甭b(n[)܂łƁAb(n[)Jn
	Ib܂ł̂ꂼ̉Ԃ͉̓\ԁibjݒ肷B
	̃XebvȗƁAftHglƂiStartTimeɂ "20"A
	iCaptureTimeɂ"20" ݒ肳B
vg^CvF
	int IKDDIDSR_SetUtteranceTime
		(
		IKDDIDSR * pIKDDIDSR,
		uint16 	iStartTime,
		uint16	iCaptureTime
		)
p[^F
	pIKDDIDSR	IKDDIDSRC^tF[XIuWFNgւ̃|C^B
	iStartTime	捞Jn甭b(n[)܂ł͉̓\ԁB
				ftHgl20Bݒ͈͂1`20BPʂ͕bB
				(0wŃ^CAEgj
	iCaptureTime	b(n[)JnIb܂ł͉̓\ԁB
					ftHgl20Bݒ͈͂1`20BPʂ͕bB
					(0wŃ^CAEgj
߂lF
	KDDI_DSR_SUCCESS	IB삪B
	KDDI_DSR_EBADPARM	sȃp[^B
	KDDI_DSR_EFAILED	sB
RgF
b^CAEgƁA捞ҋ@ԂDSRԂƂȂB
Ib^CAEgƁA捞IAFpB
 
1.8.@IKDDIDSR_SetDBPowerInterval()
F
	DSRNCAgʒmA͂ꂽ̉p[liDBPowerlF
	KDDI_DSR_STATUS_DBPOWERj̒ʒmԊu(~b)ݒ肷B
	iInterval"O"w肷ƁAKDDI_DSR_STATUS_DBPOWER͒ʒmȂB
	̃XebvȗƁAftHgl "O" ݒ肳B
vg^CvF
	int IKDDIDSR_SetDBPowerInterval
		(
		IKDDIDSR * pIKDDIDSR,
		uint16  iInterval
		)
p[^F
	pIKDDIDSR	IKDDIDSRC^tF[XIuWFNgւ̃|C^B
	iInterval	DBPowerl̒ʒmԊuB
				ftHgl0Bݒ͈͂100`20000BPʂ̓~bB
				(0wŃR[obNj

߂lF
	KDDI_DSR_SUCCESS	IB삪B
	KDDI_DSR_EBADPARM	sȃp[^B
	KDDI_DSR_EFAILED	sB
QƁF
KDDIDSRNotify
 
1.9.@IKDDIDSR_SetApplication()
F
	DSRp[^ɁAKvɉăRecvoC_ŗL̏ݒ
	B
	ݒ肷XML`ŕ\LAݒ\ȏ́A2oCg܂܂ȂpƔpLƂB
vg^CvF
	int IKDDIDSR_SetApplication
		(
		IKDDIDSR * pIKDDIDSR,
		KDDIDSRApplication@kddidsrApplication
		)
p[^F
	pIKDDIDSR	@@@@IKDDIDSRC^tF[XIuWFNgւ̃|C^B
	kddidsrApplication@@@ RecvoC_ŗL̏B
߂lF
	KDDI_DSR_SUCCESS	IB삪B
	KDDI_DSR_EBADPARM	sȃp[^B
	KDDI_DSR_EFAILED	sB
RgF
p[^ŎꂽXML`̃RecŗLɑ΂āAV^bNX̃`FbN͍sȂB̏w肷ۂɂ́AXMLLq́AV^bNXALqĂ邱ƂOƂB
	\Leɓꕶi>A<A"A'A&jgpꍇ͉L̂悤ɋLq邱ƁB

ꕶ	XMLł̓ʂȈӖ	GR[fBO
	^ȌI	&gt;
	^O̊Jn	&lt;
"	p	&quot;
'	A|XgtB	&apos;
&	ApTh	&amp;
RecŗL̏(xml)̋Lq
		<user id="dsr_user" password="xxxxxx" />
		<server cgi="http://xxx.yyy/cgi?request=post&amp;date=today" />
QƁF
	KDDIDSRApplication

1.10.@IKDDIDSR_SelectNetwork()
F
	{APÍABREW3.1Ȃтɂȍ~̃o[Wɂ̂ݓKpB
	BREW2.1ł́APPPڑlbg[N̑I͎{łȂB
F
	BREWAvP[VgpPPPڑlbg[N(hC)ݒ肷B
	ݒ肷lbg[ŃAINETMGR_SelectNetwork()Őݒ肷lbg[NIDƂB
	̃XebvPPPڑlbg[N(hC)ݒ肷ꍇA
	IKDDIDSR_Initialize()ĂяoOɐݒ肷KvB
	̃XebvȗꍇAȂ킿AgpPPPڑlbg[N(hC)
	w肵ȂꍇAʗpBREW.NETlbg[N(ftHglbg[N)IB
vg^CvF
	int IKDDIDSR_SelectNetwork
		(
		IKDDIDSR * pIKDDIDSR,
	KDDIDSRNetInfo kddidsrNetInfo
	)
p[^F
	pIKDDIDSR	IKDDIDSRC^tF[XIuWFNgւ̃|C^B
	kddidsrNetInfo	gpPPPڑlbg[N(hC)B
߂lF
	KDDI_DSR_SUCCESS	IB삪B
	KDDI_DSR_EBADPARM	sȃp[^B
	KDDI_DSR_EFAILED	sB
	KDDI_DSR_EBADSTATE	ԕsv
RgF
lCeBuɎĂDSR@\́AFVXeƒʐMsہA
BREWAvP[VŊmꂽPPPڑ𗘗p邱ƂOƂB
ADSR@\FVXeƒʐMsہAPPPڑmĂȂꍇ
(Ⴆ΁AK̖ʐMԂ𒴂PPPڑJꂽꍇȂ)A
DSR@\ɂPPPڑ̍Ċm{B
DSR@\PPPڑ̍ĊmsꍇABREWAvP[Vgp
lbg[N(hC)ɑ΂PPPڑ̊msKv邽߁A
̃XebvɂABREWAvP[VggpĂ
PPPڑlbg[N(hC)̏ݒ肷BABREWAvP[V
ʗpBREW.NETlbg[NgpĂꍇ́ÃXebvɂ
lbg[N(hC)̐ݒsKv͂ȂBʗpBREW.NETlbg[NƂ
قȂlbg[N(Ⴆ΁A@llbg[NȂ)𗘗pꍇɌA
̃XebvɂAPPPڑlbg[N(hC)ݒ肷KvB
BREWAvP[VgpPPPڑlbg[N(hC)
قȂlbg[N(hC)w肳ꂽꍇAʐM()͕ۏ؂Ȃ

1.11.@IKDDIDSR_RegisterNotify()
F
	IKDDIDSRIuWFNgł̃R[obN֐o^B
	IKDDIDSŔÃR[obNgĔ񓯊Cxg񍐂B
	2A3NULLwŃR[obN̓o^B
vg^CvF
	int  IKDDIDSR_RegisterNotify
		(
		IKDDIDSR  * pIKDDIDSR,
		PFNKDDIDSRNOTIFY  pfnNotify,
		void  * pUser,
		)
p[^F
	pIKDDIDSR@	IKDDIDSRC^tF[XIuWFNgւ̃|C^B
	pfnNotify	[UR[obN֐̃|C^B
	pUser		pfnNotify()R[ƂɎgp郆[Uf[^B
߂lF
	KDDI_DSR_SUCCESS	IB삪B
	KDDI_DSR_EFAILED	sB
QƁF
	PFNKDDIDSRNOTIFY
	KDDIDSRNotify
 
1.12.@IKDDIDSR_Initialize()
F
	eDSRp[^ݒADSRNCAg̏sAN҂
	ɂBAvP[VNɂ͕KsKvB
	̌AFsہAeDSRp[^Đݒ肵ꍇ́AsKvB
	s̍ۂɁAPPPڑ̏ԂmFAڑĂȂΐڑmB
vg^CvF
	int  IKDDIDSR_Initialize
		(
		IKDDIDSR  * pIKDDIDSR
		)
p[^F
	pIKDDIDSR@IKDDIDSRC^tF[XIuWFNgւ̃|C^B
߂lF
	KDDI_DSR_SUCCESS	R}h󂯓ꂽB
	KDDI_DSR_EBADSTATE	݂̏Ԃł͏łȂB
				iEx. IKDDIDSR_SetBusiness()ݒ肳ĂȂꍇj
	KDDI_DSR_EFAILED	sB
RgF
	FsꍇɃT[oƂPPPڑKvB
@	PPPڑm鏈́A捞ȂǑ̏ƕsčsB
 
1.13.@IKDDIDSR_InitializeCapture()
F
	DSRNCAg̏IAF@\̔̂߂1bx̎ӎG
	^B́AIKDDIDSR_StartCapture()OɕKsKvB
	s̍ہAPPPڑ̏ԂmFAڑĂȂΐڑmB
vg^CvF
	int  IKDDIDSR_InitializeCapture()
		(
		IKDDIDSR  * pIKDDIDSR
		)
p[^F
	pIKDDIDSR@IKDDIDSRC^tF[XIuWFNgւ̃|C^B
߂lF
	KDDI_DSR_SUCCESS	R}h󂯓ꂽB
	KDDI_DSR_EBADSTATE	݂̏Ԃł͎ӎG^łȂB
				iEx. AvP[VNIKDDIDSR_Initialize()ݒ肳ĂȂꍇj
	KDDI_DSR_EFAILED	sB
RgF
	FsꍇɃT[oƂPPPڑKvB
@	PPPڑm鏈́A捞ȂǑ̏ƕsčsB
 
1.14.@IKDDIDSR_StartCapture()
F
	IKDDIDSR_RegisterNotify()œo^R[obNĂяoAFJnB
	́AIKDDIDSR_InitializeCapture()sꂽ̂݁As\ƂȂB
	s̍ہAPPPڑ̏ԂmFAڑĂȂΐڑmB
vg^CvF
	int  IKDDIDSR_StartCapture
		(
		IKDDIDSR  * pIKDDIDSR
		)
p[^F
	pIKDDIDSR@IKDDIDSRC^tF[XIuWFNgւ̃|C^B
߂lF
	KDDI_DSR_SUCCESS	R}h󂯓ꂽB
	KDDI_DSR_EBADSTATE	݂̏Ԃł͎ӎG^łȂB
				iEx. AvP[VNIKDDIDSR_Initialize()ݒ肳ĂȂA
				IKDDIDSR_InitializeCapture()sĂȂꍇj
	KDDI_DSR_EFAILED	sB
RgF
	FsꍇɃT[oƂPPPڑKvB
@	PPPڑm鏈́A捞ȂǑ̏ƕsčsB
 
1.15.@IKDDIDSR_StopCapture ()
F
	捞𒆒f(Ib)BDSRNCAgɂF͌pAPPPڑ͊mԂۂB
vg^CvF
	int  IKDDIDSR_StopCapture
		(
		IKDDIDSR  * pIKDDIDSR
		)
p[^F
	pIKDDIDSR@IKDDIDSRC^tF[XIuWFNgւ̃|C^B
߂lF
	KDDI_DSR_SUCCESS	R}h󂯓ꂽB
	KDDI_DSR_EFAILED	sB
 
1.16.@IKDDIDSR_CancelCapture ()
F
	F𒆎~āADSRNCAgN҂ԂɂBPPPڑ͊mԂۂB
vg^CvF
	int  IKDDIDSR_CancelCapture
		(
		IKDDIDSR  * pIKDDIDSR
		)
p[^F
	pIKDDIDSR@IKDDIDSRC^tF[XIuWFNgւ̃|C^B
߂lF
	KDDI_DSR_SUCCESS	R}h󂯓ꂽB
	KDDI_DSR_EFAILED	sB
 
1.17.@IKDDIDSR_GetResult()
F
	DSRNCAgFGW瓾Fʂ擾B́A
	R[obNɂFʂ̏Ԃ̒ʒm(KDDI_DSR_STATUS_REPORT)󂯎ォgpłB
	̌AIKDDIDSR_Initialize()IKDDIDSR_InitializeCapture()A܂IKDDIDSR_StartCapture()
	sAĂєFʂ̏Ԃ̒ʒm(KDDI_DSR_STATUS_REPORT)󂯂܂ł̊Ԃ͎gpłȂB
	擾錋ʂ̌`̓AvP[VɈˑBiEx.XMLAHTMLAURLcj
vg^CvF
	int  IKDDIDSR_GetResult
		(
		IKDDIDSR  * pIKDDIDSR,
		char  * pData,
		uint32 * pDataSize
		)
p[^F
	pIKDDIDSR@[in]   IKDDIDSRC^tF[XIuWFNgւ̃|C^B
	pData	@    [out] F̌ʂ擾f[^ւ̃|C^B
					   f[^̌`̓AvP[VɈˑB
	pDataSize    [in/out]  pDatãTCYi[|C^B^[́A
@@@						ʂ̃TCYi[B
߂lF
	KDDI_DSR_SUCCESS	IB삪B
	KDDI_DSR_EBADSTATE	݂̏Ԃł͌ʂ擾łȂB
	KDDI_DSR_EFAILED	sB
 
1.18.@IKDDIDSR_GetElemResult()
F
	DSRNCAgFGW瓾XML`̔Fʂvfw肵āA
	FXRAƒP擾BFXRAƒP擾łFʂ̌`XML`ɌA
	pElemŗvfiElementjw肵āAFʂorderpKDDIDSRResultɊi[B
	́AR[obNɂFʂ̏Ԃ̒ʒm(KDDI_DSR_STATUS_REPORT)󂯎ォgpłA
	̌AIKDDIDSR_Initialize()IKDDIDSR_InitializeCapture()A܂IKDDIDSR_StartCapture()
	sAĂєFʂ̏Ԃ̒ʒm(KDDI_DSR_STATUS_REPORT)󂯂܂ł̊Ԃ͎gpłȂB
vg^CvF
	int IKDDIDSR_GetElemResult
		(
		IKDDIDSR  * pIKDDIDSR,
		char	* pElem,
		KDDIDSRResult	* ipKDDIDSRResult[]j 
		)
p[^F
	pIKDDIDSR@[in]@@ IKDDIDSRC^tF[XIuWFNgւ̃|C^B
	pElem	@@  [in]@  F̌ʂ̎擾vf̖Ow肷B
	pKDDIDSRResult   [out]  F̌ʂ̎擾\̂ւ̃|C^B
@^[́Aʂ͍\̂̔zɊi[B
߂lF
	KDDI_DSR_SUCCESS	IB삪B
	KDDI_DSR_ENORESULT	pElemŎw肵Element擾ʓɂȂB
	KDDI_DSR_EBADSTATE	݂̏Ԃł͌ʂ擾łȂB
	KDDI_DSR_EFAILED	sB
QƁF
	KDDIDSRResult
 
1.19.@IKDDIDSR_GetBusiness()
F
	DSRp[^̈ł鉹F̂߂̃AvP[V/Rec
	ʏ݂̌̒l擾B
vg^CvF
	int IKDDIDSR_GetBusiness
		(
		IKDDIDSR * pIKDDIDSR,
		KDDIDSRBusiness  * pKddiDsrBusiness
		)
p[^F
	pIKDDIDSR  [in]  IKDDIDSRC^tF[XIuWFNgւ̃|C^B
	pKddiDsrBusiness  [out]  DSRp[^̃AvP[V/Rec
							ʏ̃|C^B
߂lF
	KDDI_DSR_SUCCESS	IB삪B
	KDDI_DSR_EBADPARM	sȃp[^B
	KDDI_DSR_EFAILED	sB
QƁF
	KDDIDSRBusiness
 
1.20.@IKDDIDSR_GetServer()
F
	DSRp[^̈ł鉹FT[õT[o擾B
vg^CvF
	int IKDDIDSR_GetServer
		(
		IKDDIDSR * pIKDDIDSR,
		KDDIDSRServer  * pKddiDsrServer
)
p[^F
	pIKDDIDSR  [in]  IKDDIDSRC^tF[XIuWFNgւ̃|C^B
	pKddiDsrServer [out]  DSRp[^̉FT[õT[oւ
|C^B
߂lF
	KDDI_DSR_SUCCESS	IB삪B
	KDDI_DSR_EBADPARM	sȃp[^B
	KDDI_DSR_EFAILED	sB
QƁF
	KDDIDSRServer
 
1.21.@IKDDIDSR_GetApplication()
F
	DSRp[^ɐݒ肳ꂽRecvoC_ŗL̏擾B
vg^CvF
	int IKDDIDSR_GetApplication
		(
		IKDDIDSR * pIKDDIDSR,
		KDDIDSRApplication  * pKddiDsrApplication
	)
p[^F
	pIKDDIDSR  [in]  IKDDIDSRC^tF[XIuWFNgւ̃|C^B
	pKddiDsrApplication [out]  DSRp[^ɐݒ肳ꂽRecvoC
								_ŗL̏ւ̃|C^B
߂lF
	KDDI_DSR_SUCCESS	IB삪B
	KDDI_DSR_EBADPARM	sȃp[^B
	KDDI_DSR_EFAILED	sB
QƁF
	KDDIDSRApplication
 
1.22.@IKDDIDSR_GetParm()
F
	DSRp[^݂̌̒l擾B
vg^CvF
	int IKDDIDSR_GetParm
		(
		IKDDIDSR * pIKDDIDSR,
		KDDIDSRParm  * pKddiDsrParm
		)
p[^F
	pIKDDIDSR  [in]  IKDDIDSRC^tF[XIuWFNgւ̃|C^B
	pKddiDsrParm [out]  DSRp[^ւ̃|C^B
			  			  擾łp[^
						E	͕
						E	FXRA臒l
						E	NBest
						E	F@\̎gpi}XN̒lj
						E	捞Jn甭b܂ł̃^CAEgb(b)
						E	bIb܂ł̃^CAEgb(b)
						E	DBPowerlʒmԊu(~b)
߂lF
	KDDI_DSR_SUCCESS	IB삪B
	KDDI_DSR_EBADPARM	sȃp[^B
	KDDI_DSR_EFAILED	sB
QƁF
	KDDIDSRParm
 
1.23.@IKDDIDSR_AddRef()
F
	IKDDIDSRC^tF[XIuWFNg̎QƃJEgCNgBɂA
	̃R[ŃIuWFNgLłBQƃJEgOɂȂƁAIuWFNg͊JB
vg^CvF
	uint32  IKDDIDSR_AddRef
		(
		IKDDIDSR * pIKDDIDSR
		)
p[^F
	pIKDDIDSR  IKDDIDSRC^tF[XIuWFNgւ̃|C^B
߂lF
	IuWFNg̃CNgꂽQƃJEgB
RgF
	IuWFNgLł΁A̒lԂB
 
1.24.@IKDDIDSR_Release()
F
	IuWFNg̎QƃJEgfNgBQƃJEg0ɂȂƁA
	IuWFNg̓ꖳɂȂB
vg^CvF
	uint32  IKDDIDSR_Release
		(
		IKDDIDSR  * pIKDDIDSR
		)
p[^F
	pIKDDIDSR@IKDDIDSRC^tF[XIuWFNgւ̃|C^B
߂lF
	IuWFNg̃fNgꂽQƃJEgB0Ԃꂽꍇ́AIuWFNg
	ĖɂȂB
 
1.25.@IKDDIDSR_QueryInterface()
F
	̊֐́ȂsB
(1)	ClassIDɊÂAC^tF[X܂̓f[^ւ̃|C^擾B
(2)	IKDDIDSRhNX̊go[W₢킹B
(3)	o[W݊T|[gB
vg^CvF
	int  IKDDIDSR_QueryInterface
		(
		IKDDIDSR  * pIKDDIDSR,
		AEECLSID  clsReq,
		void  ** ppo
		)
p[^F
	pIKDDIDSR@[in]  IKDDIDSRC^tF[XIuWFNgւ̃|C^B
	clsReq	      [in]  ₢킹GeBeB(C^tF[X܂̓f[^)
@ ʂAO[oɈӂIDB
ppo	     [out]  擾C^tF[X܂̓f[^ւ̃|C^B߂
@ lNULL̏ꍇ́A₢킹C^tF[X܂
@ ̓f[^gpsB
߂lF
	KDDI_DSR_SUCCESS	IB삪B
	G[R[h	sꍇB
RgF
	ppoNULL̏ꍇ́A₢킹C^tF[X܂̓f[^gpsB
pF
	C^tF[X擾ꂽꍇÅ֐͂̎QƃJEgCN
gBf[^\̂擾ꂽꍇ́A\̂ւ̃|C^ԂA	[U[͂Ă͂ȂB
 
2.DSRf[^Xg
2.1.@KDDIDSRBusiness
F
	F̂߂̃AvP[V/RecʏێB
`F
	typedef struct@_KDDIDSRBusiness
		{
		uint32  iBusinessID;
		char  cBusinessName[KDDI_DSR_NAME_LENGTH];
		uint32  iBusinessServiceID;
		char  cBusinessServiceName[KDDI_DSR_NAME_LENGTH];
		}KDDIDSRBusiness;
oF
	iBusinessID	       AvP[V/Rec\ʏB
	cBusinessName	       AvP[V/Rec\OB
	iBusinessServiceID 	AvP[V/Rec̃T[rX\ʏB
	cBusinessServiceName   AvP[V/Rec̃T[rX\OB
RgF
AvP[Vʏ\eʏAÓAKDDI蓖ĂƊǗsB
AvP[Vʏ̏ڍׂ́AKDDIS҂֏Ɖ̂ƁB
QƁF
	IKDDIDSR_SetBusiness()
	IKDDIDSR_GetBusiness()
 
2.2.@KDDIDSRServer
F
	FT[õT[oێB
`F
	typedef struct  _KDDIDSRServer
		{
		char  cServerAddress[KDDI_DSR_ADDRESS_LENGTH];
		uint16  iServerPort;
		char@cServerPath[KDDI_DSR_PATH_LENGTH];
		} KDDIDSRServer;
oF
	cServerAddress		FT[õAhXB
	iServerPort		FT[õ|[gB
	cServerPath		FT[õpXB
RgF
AvP[Vʏ\eʏAÓAKDDI蓖ĂƊǗsBAvP[Vʏ̏ڍׂ́AKDDIS҂֏Ɖ̂ƁB
QƁF
	IKDDIDSR_SetServer()
	IKDDIDSR_GetServer()
 
2.3.@KDDIDSRParm
F
	̍\̂́ADSRp[^i[B
`F
	typedef  struct@_KDDIDSRParm
		{
		uint16		kddidsrAnalysisKind;
		uint16		iScore;
		uint16		iNBest;
		uint32		iResultMask;
		uint16		iStartTime;
		uint16		iCaptureTime;
		uint16		iInterval;
		} KDDIDSRParm;
oF
	kddidsrAnalysisKind	͕B
						ftHglKDDI_DSR_ANALYSIS_KIND_ES201108
	iScore				FXRABݒ肵lȏ̒PԂB
						ftHgl30Bݒ͈͂0`100B
	iNBest				NBest(擾łFʂ̌)̒lB
						̌ʂ𓾂ƂAFXRA̍̂珇
						ʂԂBݒ肵lFʂԂő̐B
						ftHgl͂TBݒ͈͂͂P`10B
	iResultMask			F@\̗pԁi}XNɂwjB
						ftHglKDDI_DSR_ERRORMASK_DEFAULT
						iߑwiG{I[o[t[jB
	iStartTime			捞Jn甭b(n[)܂ł̃^CAEgbB
						ftHgl20Bݒ͈͂1`20BPʂ͕bB
						i0wŃ^CAEgj
	iCaptureTime		b(n[)JnIb܂ł̃^CAEgbB
						ftHgl20Bݒ͈͂1`20BPʂ͕bB
						i0wŃ^CAEgj
	iInterval			DBPower̒ʒmԊuB
						ftHgl0Bݒ͈͂100`20000B
						Pʂ̓~bB
						(0wŃR[obNj
QƁF
	IKDDIDSR_SetAnalysisKind()
	IKDDIDSR_SetRejectedScore()
	IKDDIDSR_SetNBest()
	IKDDIDSR_SetRecognitionErrorMask()
	IKDDIDSR_SetUtteranceTime()
	IKDDIDSR_SetDBPowerInterval()
	IKDDIDR_GetParm()
 
2.4.@KDDIDSRApplication
F
	RecvoC_ŗL̏ێB
`F
	typedef struct  _KDDIDSRApplication 
		{
		char  cApplication[KDDI_DSR_APPLICATION_LENGTH];
		} KDDIDSRApplication;
oF
	cApplication	RecvoC_ŗL̏B
QƁF
	IKDDIDSR_SetApplication()
	IKDDIDSR_GetApplication()
 
2.5.@PFNKDDIDSRNOTIFY
F
	PFNKDDIDSRNOTIFÝA[UIKDDIDSRIuWFNgœo^Kv
	̂R[obN֐̌^`łBIKDDIDSRł́Ao^ꂽR[o
	bN֐đSẴCxgƃf[^[UɑB
`F
	typedef  void (*PFNKDDIDSRNOTIFY)
		(
		void  * pUser,
		KDDIDSRNotify  * pNotify
		)
oF
	pUser	[Uw肷f[^|C^B
	pNotify	R[obNCxg̏B
QƁF
	IKDDIDSR_RegisterNotify()
 
2.6.@KDDIDSRNotify
F
	̍\̂́ADSRNCAgɂĒʒmCxg̏i[B
	́Ao^ꂽR[obNʒm֐֑B
`F
	typedef  struct@ _KDDIDSRNotify
		{
		IKDDIDSR  *  pIKDDIDSR;
		int  kddidsrCmd;
		int  kddidsrStatus;
		KDDIDSRNotifyData  kddidsrNotifyData;
		} KDDIDSRNotify;
oF
	pIKDDIDSR	IKDDIDSRւ̃|C^B
	kddidsrCmd	R}hR[hB
	kddidsrStatus	Xe[^XR[hB
	kddidsrNotifyData	Xe[^XɉăIvVif[^i[B

QƁF
	IKDDIDSR_RegisterNotify()
	PFNKDDIDSRNOTIFY
 
2.7.@KDDIDSRNotifyData
F
	R[obNCxg̃Xe[^XɉIvVif[^i[B
`F
	typedef struct  _KDDIDSRNotifyData
		{
		int32	iData1;
		int32	iData2;
		} KDDIDSRNotifyData;
oF
	iData1		R[obNCxgŒʒmB
	iData2  		R[obNCxgŒʒmB
QƁF
	IKDDIDSR_RegisterNotify()
	PFNKDDIDSRNOTIFY
	KDDIDSRNotify
 
2.8.@KDDIDSRResult
F
	Fʂ̏ێB
`F
	typedef struct  _KDDIDSRResult 
		{
		uint16	iScore;
		char    cWord[KDDI_DSR_RESULT_LENGTH];
		uint32	iDataSize;
		} KDDIDSRResult;
oF
	iScore		Fʂ̃XRAi[B
	cWord		Fʂi[B
	iDataSize  	cWord̃TCYi[B
QƁF
	IKDDIDSR_GetElemResult()

2.9.@KDDIDSRNetInfo
F
	PPPڑlbg[N(hC)
`F
	typedef struct  _KDDIDSRNetInfo 
		{
		int  nNetwork;
		} KDDIDSRNetInfo;
oF
	nNetwork	lbg[NID(INETMGR_SelectNetwork()Őݒ肷lbg[NID)
QƁF
	IKDDIDSR_SelectNetwork()
 
3.DSRR[h
3.1.@KDDI_DSR_CMD
F
	R}hR[h́ACxg^Cv߂ƃNCAgɃf[^Ԃ߂ɁA
	o^ς݃R[obN֐ĕԂB
`F
	typedef  enum@_KDDI_DSR_CMD
		{
		KDDI_DSR_CMD_INITIALIZE,
		KDDI_DSR_CMD_INITIALIZECAPTURE,
			KDDI_DSR_CMD_STARTCAPTURE,
			KDDI_DSR_CMD_STOPCAPTURE,
			KDDI_DSR_CMD_CANCELCAPTURE
		}KDDI_DSR_CMD;
oF
	KDDI_DSR_CMD_INITIALIZE		IKDDIDSR_Initialize()̃R}h
	KDDI_DSR_CMD_INITIALIZECAPTURE	IKDDIDSR_InitializeCapture()̃R}h
	KDDI_DSR_CMD_STARTCAPTURE  	IKDDIDSR_StartCapture()̃R}h
	KDDI_DSR_CMD_STOPCAPTURE	IKDDIDSR_StopCapture()̃R}h
	KDDI_DSR_CMD_CANCELCAPTURE	IKDDIDSR_CancelCapture()̃R}h
 
3.2.@KDDI_DSR_STATUS
F
	IKDDIDSR_RegisterNotify()œo^ꂽR[obN֐ɑ΂āADSR
	@\ʒmAԂ\B
`F
	typedef  enum  _KDDI_DSR_STATUS
		{
		KDDI_DSR_STATUS_RECNOISE_START,
		KDDI_DSR_STATUS_RECNOISE_END,
		KDDI_DSR_STATUS_STARTTOBEGIN,
		KDDI_DSR_STATUS_BEGINCAPTURE,
		KDDI_DSR_STATUS_DBPOWER,
		KDDI_DSR_STATUS_ENDCAPTURE,
		KDDI_DSR_STATUS_SENDDATA,
		KDDI_DSR_STATUS_REPORT,
		KDDI_DSR_STATUS_STOPCAPTURE,
		KDDI_DSR_STATUS_CANCELCAPTURE
		KDDI_DSR_STATUS_ABORT,
		KDDI_DSR_STATUS_BADSTATE
		}KDDI_DSR_STATUS;
oF
	KDDI_DSR_STATUS_RECORDNOISE	ӎGf[^̎WJn
	KDDI_DSR_STATUS_STARTTOBEGIN	捞Jn
	KDDI_DSR_STATUS_BEGINCAPTURE	bo
	KDDI_DSR_STATUS_DBPOWER		odBlԂ
	KDDI_DSR_STATUS_ENDCAPTURE	Ibo
	KDDI_DSR_STATUS_SENDDATA		f[^MJn
	KDDI_DSR_STATUS_REPORT		G[AFʂ̏Ԃ̏
	KDDI_DSR_STATUS_STOPCAPTURE	Ib(捞I)
	KDDI_DSR_STATUS_CANCELCAPTURE	F̎
	KDDI_DSR_STATUS_ABORT		ُI
	KDDI_DSR_STATUS_BADSTATE	IKDDIDSR_StartCapture(),IKDDIDSR_StopCapture(),
								IKDDIDSR_CancelCapture()ɂēłȂ
 
3.3.@KDDI_DSR_ANALYSIS_KIND
F
	͂ꂽ͕̕B
`F
	typedef  enum  _KDDI_DSR_ANALYSIS_KIND
		{
		KDDI_DSR_ANALYSIS_AUTO,
		KDDI_DSR_ANALYSIS_KIND_ES201108,
		KDDI_DSR_ANALYSIS_KIND_ES202050
		} KDDI_DSR_ANALYSIS_KIND;
oF
KDDI_DSR_ANALYSIS_AUTO		I
KDDI_DSR_ANALYSIS_KIND_ES201108	ETSI ES 201 108
KDDI_DSR_ANALYSIS_KIND_ES202050 	ETSI ES 202 050

QƁF
	IKDDIDSR_SetAnalysisKind()
 
4.DSRp[^@ftHgl
4.1.@KDDI_DSR_XXX_LENGTH
F
	DSRp[^œ͂镶̒B
`F
#define  KDDI_DSR_NAME_LENGTH		 256
#define  KDDI_DSR_ADDRESS_LENGTH		16
#define  KDDI_DSR_PATH_LENGTH		 256
#define	KDDI_DSR_APPLICATION_LENGTH	1024
#define  KDDI_DSR_RESULT_LENGTH		 128

4.2@KDDI_DSR_ERRORMASK
F
	F@\ɂG[̎
`F
#define	KDDI_DSR_ERRORMASK_NOISE			0x00000001
#define	KDDI_DSR_ERRORMASK_OVERFLOW			0x00000002
#define	KDDI_DSR_ERRORMASK_BEGINNINGBREAK	0x00000004
#define	KDDI_DSR_ERRORMASK_DEFAULT			0x00000003

*/

