#ifndef IPTM_H
#define IPTM_H
/*===========================================================================================

FILE            : IPTM.h

SERVICES        : PTM Access Interface

DESCRIPTION     : 

PUBLIC CLASSES  : 

INITIALIZATION AND SEQUENCING REQUIREMENTS : 

      Copyright  1999-2005 QUALCOMM Incorporated.
               All Rights Reserved.
            QUALCOMM Proprietary/GTDR

===========================================================================================*/

/*===========================================================================================

                        EDIT HISTORY FOR MODULE

When        Who    Keyword             what, where, why
----------  -----  ------------------  ------------------------------------------------------
01/12/05                               Create file
===========================================================================================*/

/*===========================================================================================
 INCLUDES AND VARIABLE DEFINITIONS
===========================================================================================*/
/*-------------------------------------------------------------------------------------------
   Defines
-------------------------------------------------------------------------------------------*/

#define IPTM_FUNCTION_RESET 0x0001  // @\Zbg
#define IPTM_MEMORY_RESET   0x0002  // Zbg
#define IPTM_ALL_RESET      0x0004  // I[Zbg

// debug
#define IPTM_DEBUG
#undef  IPTM_DEBUG

//#define IPTM_DBG_MSG	MSG_SP1
#define IPTM_DBG_MSG	MSG_HIGH

/*-------------------------------------------------------------------------------------------
   Include Files
-------------------------------------------------------------------------------------------*/
#include "AEE.h"
#include "AEEInterface.h"
#include "AEESound.h"

#ifdef IPTM_DEBUG
#ifdef WIN32
#include "siodef_pc.h"
#else
//#include "siodef.h"
#include "msg.h"
#endif
#endif

/*-------------------------------------------------------------------------------------------
   Constant Declarations
-------------------------------------------------------------------------------------------*/

#define IPTM_STR_SIZE 30

/*===========================================================================================
 Macros
===========================================================================================*/

/*-------------------------------------------------------------------------------------------
   Type Declarations
-------------------------------------------------------------------------------------------*/
typedef struct _PTMKEYCODE{
   uint16 wPTMKey;     //bҌ{^ɃAvɑL[R[h
   uint16 wPageUp;     //XN[sL[̃L[R[h
   uint16 wPageDown;   //XN[sL[̃L[R[h
}PTMKEYCODE;


typedef struct IPTM IPTM;

/*-------------------------------------------------------------------------------------------
   Macros Declarations
-------------------------------------------------------------------------------------------*/

/*===========================================================================================
 FUNCTION DECLARATIONS AND INLINE FUNCTION DEFINITIONS
===========================================================================================*/
void ApiIPTMSetFunctionReset( unsigned short usFncReset );		// @\Zbgݒ
void ApiIPTMSetMemoryReset( unsigned short usMemReset );		// Zbgݒ
void ApiIPTMSetAllReset( unsigned short usAllReset );			// I[Zbgݒ

boolean ApiIPTMSetPPPNAI(unsigned char *nai, unsigned int len);	// PPPFIDݒ
boolean ApiIPTMSetPPPPW( unsigned char *pw,  unsigned int len);	// PPPFPasswardݒ
boolean ApiIPTMSetPTMID( unsigned char *id,  unsigned int len);	// PTM[U[IDݒ (MDN)
boolean ApiIPTMSetPTMPW( unsigned char *pw,  unsigned int len);	// PTM[U[Passwardݒ (IMSI)
boolean ApiIPTMGetPPPNAI(unsigned char *nai);					// PPPFID擾
boolean ApiIPTMGetPPPPW( unsigned char *pw );					// PPPFPassward擾
boolean ApiIPTMGetPTMID( unsigned char *id );					// PTM[U[ID擾 (MDN)
boolean ApiIPTMGetPTMPW( unsigned char *pw );					// PTM[U[Passward擾 (IMSI)
boolean ApiIPTMGetInitPPPNAI(unsigned char *nai);				// PPPFIDl擾
boolean ApiIPTMGetInitPPPPW( unsigned char *pw );				// PPPFPasswardl擾
boolean ApiIPTMGetInitPTMID( unsigned char *id );				// PTM[U[IDl擾 (MDN)
boolean ApiIPTMGetInitPTMPW( unsigned char *pw );				// PTM[U[Passwardl擾 (IMSI)
boolean ApiIPTMGetDbgMode(byte *mode);							// PTMfobO[hݒ ( mode = 1:Debug 0:p )
boolean ApiIPTMSetDbgMode(byte *mode);							// PTMfobO[h擾 ( mode = 1:Debug 0:p )

/* ֐ */
void ApiPTMInitBoot();				// [N̏
void ApiPTMInitFactoryShipment();	// Hoאݒ莞̏

/* IPTMOEMVocoder̂ݎgp */
AEECLSID GetAppClassId( void );		// NAvClass ID擾

/*-------------------------------------------------------------------------------------------
   Interface Definitions
-------------------------------------------------------------------------------------------*/
AEEINTERFACE(IPTM)
{
   INHERIT_IBase(IPTM);
   int     (* Shutdown)                 (IPTM * pIPTM);
   int     (* SIPID)                    (IPTM * pIPTM, char   * pszID,     int * pnSize);
   int     (* SIPPasswd)                (IPTM * pIPTM, char   * pszPasswd, int * pnSize);
   int     (* SetDevice)                (IPTM * pIPTM, AEESoundDevice eDevice);
   int     (* GetVolume)                (IPTM * pIPTM, uint16 * pwVolume);
   int     (* SetVolume)                (IPTM * pIPTM, uint16 * pwVolume);
   int     (* GetPTMRestrictionStatus)  (IPTM * pIPTM, boolean * pbIsRestriction);
   int     (* SearchAddr)               (IPTM * pIPTM, char   * pszTelNo,  char * pszName,  int * pnSize);
   int     (* GetPTMKey)                (IPTM * pIPTM, PTMKEYCODE * pPTM_KeyCode);
   int     (* SetLED)                   (IPTM * pIPTM, uint16   wColor,    uint16 wType);
   int     (* GetResetFlagStatus)       (IPTM * pIPTM, uint16 * pwReset);
   int     (* SetResetFlagStatus)       (IPTM * pIPTM, uint16   wReset);
};


/*-------------------------------------------------------------------------------------------
   Access Macros
-------------------------------------------------------------------------------------------*/
#define IPTM_AddRef(p)                                        AEEGETPVTBL((p),IPTM)->AddRef((p))
#define IPTM_Release(p)                                       AEEGETPVTBL((p),IPTM)->Release((p))
#define IPTM_Shutdown(p)                                      AEEGETPVTBL((p),IPTM)->Shutdown(p)
#define IPTM_SIPID(p, psI, pnS)                               AEEGETPVTBL((p),IPTM)->SIPID(p, psI, pnS)
#define IPTM_SIPPasswd(p, psP, pnS)                           AEEGETPVTBL((p),IPTM)->SIPPasswd(p, psP, pnS)
#define IPTM_SetDevice(p, eD)                                 AEEGETPVTBL((p),IPTM)->SetDevice(p, eD)
#define IPTM_GetVolume(p, pwV)                                AEEGETPVTBL((p),IPTM)->GetVolume(p, pwV)
#define IPTM_SetVolume(p, pwV)                                AEEGETPVTBL((p),IPTM)->SetVolume(p, pwV)
#define IPTM_GetPTMRestrictionStatus(p, pbI)                  AEEGETPVTBL((p),IPTM)->GetPTMRestrictionStatus(p, pbI)
#define IPTM_SearchAddr(p, pszT, pszN, pnS)                   AEEGETPVTBL((p),IPTM)->SearchAddr(p, pszT, pszN, pnS)
#define IPTM_GetPTMKey(p, pP)                                 AEEGETPVTBL((p),IPTM)->GetPTMKey(p, pP)
#define IPTM_SetLED(p, wC, wT)                                AEEGETPVTBL((p),IPTM)->SetLED(p, wC, wT)
#define IPTM_GetResetFlagStatus(p, pwR)                       AEEGETPVTBL((p),IPTM)->GetResetFlagStatus(p, pwR)
#define IPTM_SetResetFlagStatus(p, wR)                        AEEGETPVTBL((p),IPTM)->SetResetFlagStatus(p, wR)


/*===========================================================================================
   DATA STRUCTURE DOCUMENTATION
=============================================================================================
=============================================================================================
PTMKEYCODE

Description:
   eړ@ɂPTMAvpeL[̃L[R[h擾

Definition:

typedef struct _PTMKEYCODE{
   uint16 wPTMKey;     //bҌ{^ɃAvɑL[R[h
   uint16 wPageUp;     //XN[sL[̃L[R[h
   uint16 wPageDown;   //XN[sL[̃L[R[h
}PTMKEYCODE


Members:
   o              
   wPTMKey           : bҌ{^ɃAvɑL[R[h
   wPageUp           : XN[sL[̃L[R[h
   wPageDown         : XN[sL[̃L[R[h


Comments:
   Ȃ
   
See Also:
   Ȃ

=============================================================================================
=============================================================================================
   INTERFACE DOCUMENTATION
=============================================================================================
TODO
*/
#endif // __IPTM_H__

