#ifndef _MPMULTI_H_
#define _MPMULTI_H_
/*======================================================
FILE:  MPMulti.c

SERVICES:
   OEM functions for supporting BREW MPMULTI
   Interface

GENERAL DESCRIPTION:
   This file provides the prorotypes of the functions
   that OEMs must provide in order to support the BREW
   MPUTIL interfaces

=====================================================*/


#include "AEE.h"
#include "AEEMpMulti.h"

extern uint32	CMPMULTI_AddRef			( IMPMulti * po );
extern uint32	CMPMULTI_Release		( IMPMulti * po );
extern int	CMPMULTI_RegisterNotify		( IMPMulti * po, PFNMPMULTINOTIFY pfnNotify, void * pUser );
extern int	CMPMULTI_SetAutoOff		( IMPMulti * po, boolean bAutoOff );
extern int	CMPMULTI_GetUrlInfo		( IMPMulti * po, AEEMPMultiUrlInfo *pUrlInfo );
extern int	CMPMULTI_GetResetFlagStatus	( IMPMulti * po, uint16 *pwReset );
extern int	CMPMULTI_SetResetFlagStatus	( IMPMulti * po, uint16 wReset );
extern int	CMPMULTI_GetFileInfo		( IMPMulti * po, char *pszFileName, AEEMPMultiFileInfo *pFileInfo );
extern uint32	CMPMULTI_GetResInfo		( IMPMulti * po, AEEMPMultiResInfo *  pResInfo);

#endif // _MPMULTI_H_
