#ifndef _OEMFMTUNER_H_
#define _OEMFMTUNER_H_
/*======================================================
FILE:  OEMFMTUNER.c

SERVICES:
   OEM functions for supporting BREW FMTUNER
   Interface

GENERAL DESCRIPTION:
   This file provides the prorotypes of the functions
   that OEMs must provide in order to support the BREW
   FMTUNER interfaces

=====================================================*/


#include "AEE.h"
#include "AEE_OEM.h"

// [PTX635] IFMTUNER̎ [S]
//#include "snd.h"
// [PTX635] IFMTUNER̎ [E]
#include "FMTUNER.h"
#include "FMTUNER.bid"

// [PTX635] IFMTUNER̎ [S]
//typedef void (*PFNFMTUNERHDSET)(snd_af_data_cmd_enum event, uint32 num);
//typedef void (*PFNFMTUNERCLOSEAPP)(int event, uint32 num);
//typedef void (*PFNFMTUNERMANNER)(int event, uint32 num);
// [PTX635] IFMTUNER̎ [E]

// [PTX635] IFMTUNER̎ [S]
#ifdef  WIN32
#include "stdarg.h"
#include "crtdbg.h"
#include "windows.h"
#else  //WIN32
#include "msg.h"
#endif //WIN32

//#define  OEMFMTUNER_DEBUG
//#define  OEMFMTUNER_ERROR

#ifdef   OEMFMTUNER_DEBUG
#ifdef   WIN32
static void OEMFMT_MSG( char * fmt, ...) {
    char    buff[128];
    int     len;
    va_list argp;
    va_start( argp, fmt );
    vsprintf( buff, fmt, argp );
    va_end( argp );
    len = strlen( buff );
    buff[len]   = '\n';
    buff[len+1] = '\0';    
    OutputDebugString( buff );
    //_CrtDbgReport( _CRT_ERROR, NULL, 0, "OEMFMTuner.c", fmt, argp );
}
#else  //WIN32
#define  OEMFMT_MSG(fmt, a, b, c)     MSG_HIGH(fmt, a, b, c)
#endif //WIN32
#else  //OEMFMTUNER_DEBUG
#ifdef  WIN32
static void OEMFMT_MSG( char * fmt, ...) {}
#else  //WIN32
#define  OEMFMT_MSG(fmt, ...)
#endif //WIN32
#endif //OEMFMTUNER_DEBUG

#ifdef   OEMFMTUNER_ERROR
#ifdef   WIN32
static void OEMFMT_MSG_ERROR( char * fmt, ... ) {
    char    buff[128];
    int     len;
    va_list argp;
    va_start( argp, fmt );
    vsprintf( buff, fmt, argp );
    va_end( argp );
    len = strlen( buff );
    buff[len]   = '\n';
    buff[len+1] = '\0';    
    OutputDebugString( buff );
    //_CrtDbgReport( _CRT_ERROR, NULL, 0, "OEMFMTuner.c", fmt, argp );
    //exit( 1 );
}
#else  //WIN32
#define  OEMFMT_MSG_ERROR(fmt, a, b, c)     MSG_ERROR(fmt, a, b, c)
#endif //WIN32
#else  //OEMFMTUNER_ERROR
#ifdef  WIN32
static void OEMFMT_MSG_ERROR( char * fmt, ... ) {}
#else  //WIN32
#define  OEMFMT_MSG_ERROR(fmt, ...)
#endif //WIN32
#endif //OEMFMTUNER_ERROR
// [PTX635] IFMTUNER̎ [E]


// [PTX635] IFMTUNER̎ [S]
void OEMFMTUNER_Init( void );
// [PTX635] IFMTUNER̎ [E]

/*=====================================================================

֐: OEMFMTUNER_Free()

@\:
   擾ReLXg܂D

vg^Cv:
   void OEMFMTUNER_Free
   (
      OEMCONTEXT        cxt
   )

p[^:
   cxt                  ReLXg̃|C^

߂l:
   Ȃ

:
   Ȃ

p:
   Ȃ

֘A:
   OEMFMTUNER_New()

=====================================================================*/
void OEMFMTUNER_Free(OEMCONTEXT cxt);

/*=====================================================================

֐: OEMFMTUNER_Seek()

@\:
   el`[i[̃V[NȂB

vg^Cv:
   int OEMFMTUNER_Seek
   (
      OEMCONTEXT        cxt,
      int               direction,
      uint32           *pFrequency
   )

p[^:
   cxt          [in]     ReLXg̃|C^
   direction    [in]     V[N
   pFrequency   [in/out] Mg

߂l:
   SUCCESS             Iiɖ߂󂯕tj
   EBADPARAM           sȏꍇ
   EBADSTATE           ReLXgݒ肳ĂȂ

:
   CALLBACK[`ZbgĂȂꍇ́AWAITsV[N҂B

p:
   Ȃ

֘A:
   OEMFMTUNER_RegisterNotify()

=====================================================================*/
int    OEMFMTUNER_Seek(OEMCONTEXT cxt, int direction, uint32 *pFrequency);

/*=====================================================================

֐: OEMFMTUNER_SeekStop()

@\:
   FM`[i[SEEK𒆎~

vg^Cv:

   int OEMFMTUNER_SeekStop
   (
      OEMCONTEXT        cxt
   )

p[^:
   cxt          [in]     ReLXg̃|C^

߂l:
   SUCCESS              I
   EBADSTATE            ReLXgݒ肳ĂȂ

:
   Ȃ

p:
   Ȃ

֘A:
   Ȃ

=====================================================================*/
int    OEMFMTUNER_SeekStop(OEMCONTEXT cxt);

/*=====================================================================

֐: OEMFMTUNER_SetVolume()

@\:
   WIo͂鉹ʂZbg

vg^Cv:
   int OEMFMTUNER_SetVolume
   (
      OEMCONTEXT        cxt,
      int               Volume
   )

p[^:
   cxt       [in]       ReLXg̃|C^
   Volume    [in]       ʁiO`POOj

߂l:
   SUCCESS              
   EBADPARM             ̓p[^s
   EBADSTATE            ReLXgݒ肳ĂȂ

:
   ʒĺAO`POOLƂAOMUTEƂ

p:
   Ȃ

֘A:
   Ȃ


=====================================================================*/
int    OEMFMTUNER_SetVolume(OEMCONTEXT cxt, int Volume);

/*=====================================================================

֐: OEMFMTUNER_GetVolume()

@\:
   ݐݒ肳Ă郉WȈo͉ʂ擾B

vg^Cv:
   int OEMFMTUNER_GetVolume
   (
      OEMCONTEXT        cxt,
      int               *pVolume
   )

p[^:
   cxt       [in]       ReLXg̃|C^
   pVolume   [out]      擾ʒl

߂l:
   SUCCESS              
   EBADSTATE            ReLXgݒ肳ĂȂ

:
   CALLBACK[`ZbgĂȂꍇ́AWAITso͉ʎ擾҂B

p:
   Ȃ

֘A:
   OEMFMTUNER_RegisterNotify()

=====================================================================*/
int    OEMFMTUNER_GetVolume(OEMCONTEXT cxt, int *pVolume);

/*=====================================================================

֐: OEMFMTUNER_SetTune()

@\:
   wgɃ`[jOsB

vg^Cv:
   int OEMFMTUNER_SetTune
   (
      OEMCONTEXT        cxt,
      uint32            Frequency,
      int              *pSensitivity
   )

p[^:
   cxt       [in]       ReLXg̃|C^
   Frequency [in]       ݒg
   pSensitivity [out]   Mx

߂l:
   SUCCESS              
   EBADPARM             ̓p[^s
   EBADSTATE            ReLXgݒ肳ĂȂ

:
   CALLBACK[`ZbgĂȂꍇ́AWAITs`[jO̊҂B

p:
   Ȃ

֘A:
   OEMFMTUNER_RegisterNotify()


=====================================================================*/
int    OEMFMTUNER_SetTune(OEMCONTEXT cxt, uint32 Frequency, int *pSensitivity);

/*=====================================================================

֐: OEMFMTUNER_GetTune()

@\:
   ݐݒ肳Ă`[i[̎g擾B

vg^Cv:
   int OEMFMTUNER_GetTune
   (
      OEMCONTEXT        cxt,
      uint32           *pFrequency
   )

p[^:
   cxt        [in]      ReLXg̃|C^
   pFrequency [out]     ݒg

߂l:
   SUCCESS              
   EBADSTATE            ReLXgݒ肳ĂȂ

:
   CALLBACK[`ZbgĂȂꍇ́AWAITs`[jOg擾̊҂B

p:
   Ȃ

֘A:
   OEMFMTUNER_RegisterNotify()

=====================================================================*/
int    OEMFMTUNER_GetTune(OEMCONTEXT cxt, uint32 *pFrequency);

/*=====================================================================

֐: OEMFMTUNER_GetState()

@\:
   el`[i[̎Mx擾܂

vg^Cv:
   int OEMFMTUNER_GetState
   (
      OEMCONTEXT        cxt,
      int              *pSensitivity
   )

p[^:
   cxt          [in]    ReLXg̃|C^
   pSensitivity [out]   Mx

߂l:
   SUCCESS              
   EBADSTATE            ReLXgݒ肳ĂȂ

:
   CALLBACK[`ZbgĂȂꍇ́AWAITsMx擾̊҂B

p:
   Ȃ

֘A:
   OEMFMTUNER_RegisterNotify()

=====================================================================*/
int    OEMFMTUNER_GetState(OEMCONTEXT cxt, int *pSensitivity);

/*=====================================================================

֐: OEMFMTUNER_CtrlPower()

@\:
   el`[i[̓dsB

vg^Cv:
   int OEMFMTUNER_CtrlPower
   (
      OEMCONTEXT        cxt,
      boolean           Power
   )

p[^:
   cxt          [in]    ReLXg̃|C^
   Power        [in]    diOFnee^PFnmj

߂l:
   SUCCESS              
   EBADPARM             ̓p[^s
   EBADSTATE            ReLXgݒ肳ĂȂ

:
   Ȃ

p:
   Ȃ

֘A:
   Ȃ


=====================================================================*/
int    OEMFMTUNER_CtrlPower(OEMCONTEXT cxt, int Power);

/*=====================================================================

֐: OEMFMTUNER_ChangeDevice()

@\:
   ړ@̏̒ʘb͒M̌擾܂

vg^Cv:
   int OEMFMTUNER_ChangeDevice
   (
      OEMCONTEXT        cxt,
      int               Device
   )

p[^:
   cxt          [in]    ReLXg̃|C^
   Device       [out]   o̓foCX

߂l:
   SUCCESS              
   EBADPARM             ̓p[^s
   EBADSTATE            ReLXgݒ肳ĂȂ

:
  T|[gfoCX́ACtĤ݂ƂB

p:
   Ȃ

֘A:
   AEESoundDevice


=====================================================================*/
int    OEMFMTUNER_ChangeDevice(OEMCONTEXT cxt, int Device);

/*=====================================================================

֐: OEMFMTUNER_RegisterNotify()

@\:
   el`[i[֘ÃR[obN֐o^܂B

vg^Cv:
   int OEMFMTUNER_RegisterNotify
   (
      OEMCONTEXT        cxt,
      PFNFMTUNERNOTIFY  pfnNotify,
      void             *pUser
   )

p[^:
   cxt          [in]   ReLXg̃|C^
   pfnNotify    [in]   R[obN֐ւ̃|C^
   pUser        [in]   R[obN鎞Ɏgp郆[U|f[^

߂l:
   SUCCESS              
   EBADSTATE            IFMTUNERC^tF[XIuWFNgfBԂłȂ

:
   񓯊ʒmCxgΉR[obN[`o^B

p:
   Ȃ

֘A:
   Ȃ

=====================================================================*/
int    OEMFMTUNER_RegisterNotify(OEMCONTEXT cxt, PFNFMTUNERNOTIFY  pfnNotify, void *pUser);

/*=====================================================================

֐: OEMFMTUNER_New()

@\:
   ReLXg쐬܂D

vg^Cv:
   OEMCONTEXT OEMFMTUNER_New
   (
      int               *pError
   )

p[^:
   pError               ߂lNULLԋpꂽꍇɁAG[ԋp̈̃|C^

߂l:
   NULLȊO             쐬ꂽReLXg̃|C^
   NULL                 s

:
   Ȃ

p:
   Ȃ

֘A:
   OEMFMTUNER_Free()

=====================================================================*/
// [PTX635] IFMTUNER̎ [S]
//OEMCONTEXT OEMFMTUNER_New(int *pError);
OEMCONTEXT OEMFMTUNER_New( IFMTUNER * pFMTuner, int * pError );
// [PTX635] IFMTUNER̎ [E]

/*=====================================================================

֐: OEMFMTUNER_Backup()

@\:
   ReLXg쐬܂D

vg^Cv:
   OEMCONTEXT OEMFMTUNER_Backup
   (
      IFMTUNER         *pFMTuner
   )

p[^:
   pFMTuner             R[obNpɑޔFM`[iIuWFNg|C^

߂l:
   Ȃ

:
   Ȃ

p:
   Ȃ

֘A:
   Ȃ

=====================================================================*/
// [PTX635] IFMTUNER̎ [S]
//void OEMFMTUNER_Backup(IFMTUNER *pFMTuner);
// [PTX635] IFMTUNER̎ [E]
/*=====================================================================

֐: OEMFMTUNER_GetInfo()

@\:
   ̊֐ BREWŃT|[gĂȂ[̏Ԃ擾B

vg^Cv:
   uint OEMFMTUNER_GetInfo
   (
      OEMCONTEXT cxt,
      int        para,
      int       *pInfo
   )

p[^:
   cxt          ReLXg̃|C^
   int          vp[^
   info         ʒm

߂l:

   SUCCESS              
   EBADSTATE            IFMTUNERC^tF[XIuWFNgfBԂłȂ

:
   Ȃ

p:
   Ȃ

֘A:
   Ȃ

======================================================================*/
int    OEMFMTUNER_GetInfo(OEMCONTEXT cxt, int para, int *pInfo);





/*=====================================================================

֐: OEMFMTUNER_GetCallBack()

@\:
   ̊֐ BREWŃT|[gĂȂ[̏Ԃ擾B

vg^Cv:
   PFNFMTUNERHDSET OEMFMTUNER_GetCallBack()

p[^:
   Ȃ

߂l:

   NULL                 CALLBACKo^
   NULLȊO             o^ςCALLBACK[`

:
   Ȃ

p:
   Ȃ

֘A:
   Ȃ

======================================================================*/
// [PTX635] IFMTUNER̎ [S]
//PFNFMTUNERHDSET OEMFMTUNER_GetCallBack(void);
// [PTX635] IFMTUNER̎ [E]
/*=====================================================================

֐: OEMFMTUNER_GetCallBack_CloseApp()

@\:
   ̊֐ APPLETIׂ̒ʒmCALLBACKŒʒmB

vg^Cv:
   PFNFMTUNERCLOSEAPP OEMFMTUNER_GetCallBack_CloseApp()

p[^:
   Ȃ

߂l:

   NULL                 CALLBACKo^
   NULLȊO             o^ςCALLBACK[`

:
   Ȃ

p:
   Ȃ

֘A:
   Ȃ

======================================================================*/
// [PTX635] IFMTUNER̎ [S]
//PFNFMTUNERCLOSEAPP OEMFMTUNER_GetCallBack_CloseApp(void);
// [PTX635] IFMTUNER̎ [E]
/*=====================================================================

֐: OEMFMTUNER_GetCallBack_Manner()

@\:
   ̊֐ BREWŃT|[gĂȂ[̏Ԃ擾B

vg^Cv:
   PFNFMTUNERMANNER OEMFMTUNER_GetCallBack_Manner()

p[^:
   Ȃ

߂l:

   NULL                 CALLBACKo^
   NULLȊO             o^ςCALLBACK[`

:
   Ȃ

p:
   Ȃ

֘A:
   Ȃ

======================================================================*/
// [PTX635] IFMTUNER̎ [S]
//PFNFMTUNERMANNER OEMFMTUNER_GetCallBack_Manner(void);
// [PTX635] IFMTUNER̎ [E]
/*=====================================================================

֐: OEMFMTUNER_GetFrequency()

@\:
   ̊֐ ݒ蒆̎g擾

vg^Cv:
   uint32 OEMFMTUNER_GetFrequency()

p[^:
   Ȃ

߂l:
   ݒgiKhz)

:
   Ȃ

p:
   Ȃ

֘A:
   Ȃ

======================================================================*/
// [PTX635] IFMTUNER̎ [S]
uint32 OEMFMTUNER_GetFrequency(void);
// [PTX635] IFMTUNER̎ [E]

/*=====================================================================

֐: OEMFMTUNER_SetMode()

@\:
   FM`[ĩXeI^m̃[hݒsD

vg^Cv:
   int OEMFMTUNER_SetMode
   (
      IFMTUNER        *pMe,
      int             mode
   )

p[^:
   pMe      [in]       FM`[iIuWFNg̃|C^
   mode     [in]       [hiXeI^mj

߂l:
   SUCCESS              
   EBADPARM             ̓p[^s
   EBADSTATE            ReLXgݒ肳ĂȂ

:
   Ȃ

p:
   Ȃ

֘A:
   Ȃ

=====================================================================*/
// [PTX635] IFMTUNER̎ [S]
int OEMFMTUNER_SetMode(OEMCONTEXT cxt,int mode);
//int OEMFMTUNER_SetMode(IFMTUNER *pMe,int mode);
// [PTX635] IFMTUNER̎ [E]

/*=====================================================================

֐: OEMFMTUNER_GetNowVol()

@\:
   ̊֐ ݒ蒆̉ʂ擾

vg^Cv:
   int OEMFMTUNER_GetNowVol()

p[^:
   Ȃ

߂l:
   ݒ艹ʁiO`PO)

:
   Ȃ

p:
   Ȃ

֘A:
   Ȃ

======================================================================*/
// [PTX635] IFMTUNER̎ [S]
int OEMFMTUNER_GetNowVol(void);
// [PTX635] IFMTUNER̎ [E]

/*=======================================================================

֐: CFMTUNER_Record()

@\:   ̊֐ FM WI̘^sB

vg^Cv:
   int IFMTUNER_Record
   (
       IFMTUNER *pIFMTUNER
   )
   
p[^:
    pIFMTUNER IFMTUNER C^tF[XIuWFNgւ̃|C^
    
߂l:
    SUCCESS 
    EBADSTATE G[(ԕs)
    EUNSUPPORTED Ή
    FMT_PENDING o^ꂽR[obN̒ɒlԂꂽ
:
    ̊֐OɁAIFMTuner_RegisterNotify()֐ɂR[obN֐o^A
    R[obN֐ɂ菈ʂ擾邱ƁB
    IFMTUNER_Record()ĂяoɁAԂ̃`FbNif[^tH_̎ceʂȂǁjsA
    OK ł΁AFMT_STATUS_REC_STANBY AvɒʒmB
    ۂɘ^Jn_ŁAFMT_CMD_RECORD Av֒ʒmB
    ܂AIFMTUNER_Record()sƁAQނ̃R[obNʒmB

p:
    Ȃ
*----------------------history ------------------------------------------
*  No	Date			Revised By		Item				   Description 
*  1.	2005/09/16		Cui Xinyu		CFMTUNER_Record		Created
=======================================================================*/
int OEMFMTUNER_Record( OEMCONTEXT cxt );
/*=======================================================================

֐: CFMTUNER_RecStop()

@\:   ̊֐FM WI̘^~B

vg^Cv:
    int IFMTUNER_RecStop
    (
        IFMTUNER *pIFMTUNER
    )
    
p[^:
    pIFMTUNER IFMTUNER C^tF[XIuWFNgւ̃|C^

߂l:
    SUCCESS 
    EBADSTATE G[(ԕs)
    EUNSUPPORTED Ή
    FMT_PENDING o^ꂽR[obN̒ɒlԂꂽ

:
    ̊֐OɁAIFMTuner_RegisterNotify()֐ɂR[obN֐o^A
    R[obN֐ɂ菈ʂ擾邱ƁB

p:
    Ȃ
*----------------------history ------------------------------------------
*  No	Date			Revised By		Item				   Description 
*  1.	2005/09/16		Cui Xinyu		CFMTUNER_RecStop		Created
=======================================================================*/
int OEMFMTUNER_RecStop( OEMCONTEXT cxt );
/*=======================================================================

֐: CFMTUNER_GetFileName()

@\:   ̊֐ FM WI̘^pt@C擾B

vg^Cv:
    int IFMTUNER_GetFileName
    (
        IFMTUNER *pIFMTUNER,
        unsigned char *name,
        int *wSize;
    )
    
p[^:
    pIFMTUNER IFMTUNER C^tF[XIuWFNgւ̃|C^
    name o̓t@C
    wSize o̓t@C̕

߂l:
    SUCCESS 
    EBADSTATE G[(ԕs)
    EBADPARAM sȏꍇ
    EUNSUPPORTED Ή

:
    Ȃ

p:
    Ȃ
*----------------------history ------------------------------------------
*  No	Date			Revised By		Item				       Description 
*  1.	2005/09/16		Cui Xinyu		CFMTUNER_GetFileName		Created
=======================================================================*/
int OEMFMTUNER_GetFileName( OEMCONTEXT cxt, unsigned char *name, int *wSize);
// [PTX803] obNOEhĐRΉ [S]
/*=======================================================================

֐: OEMFMTUNER_BG_SetVolume()

@\:
   obNOhAvpʐݒ菈

vg^Cv:
   void OEMFMTUNER_BG_SetVolume
   (
		int Volume
   )

p[^:
	Volume	Zbg鉹

߂l:
	Ȃ

p:
   Ȃ

֘A:
   Ȃ

=======================================================================*/
void  OEMFMTUNER_BG_SetVolume( int Volume );

/*=======================================================================

֐: OEMFMTUNER_BG_Seek()

@\:
   obNOhĐFMWI`[jOs

vg^Cv:
   void OEMFMTUNER_BG_Seek
   (
		int direction,
		uint32 * pFrequency
   )

p[^:
	direction	`[jO
	pFrequency	`[jOJng

߂l:
	Ȃ

p:
   Ȃ

֘A:
   Ȃ

=======================================================================*/
void OEMFMTUNER_BG_Seek( int direction, uint32 * pFrequency );


/*=======================================================================

֐: OEMFMTUNER_BG_SetTune()

@\:
   obNOhĐFMWI̎gZbg

vg^Cv:
   void OEMFMTUNER_BG_SetTune
   (
		uint32 * pFrequency
   )

p[^:
	pFrequency	Zbgg

߂l:
	Ȃ

p:
   Ȃ

֘A:
   Ȃ

=======================================================================*/
void  OEMFMTUNER_BG_SetTune( uint32 Frequency);

// [PTX803] obNOEhĐRΉ [E]

#endif // _OEMFMTUNER_H_
