#ifndef _OEMMPMULTI_H_
#define _OEMMPMULTI_H_
/*======================================================
FILE:  OEMMPMulti.h

SERVICES:
   OEM functions for supporting BREW MPMULTI
   Interface

GENERAL DESCRIPTION:
   This file provides the prorotypes of the functions
   that OEMs must provide in order to support the BREW
   MPUTIL interfaces

=====================================================*/

#include "AEE.h"
#include "AEE_OEM.h"
#include "OEMObjectMgr.h"
#include "MPMulti.h"

extern void	OEMMPMULTI_Init			( void );
extern void*	OEMMPMULTI_New			( IMPMulti *pIMPMulti, uint32 *pnErr );
extern void	OEMMPMULTI_Free			( void * po );

extern int	OEMMPMULTI_RegisterNotify	( void * po, PFNMPMULTINOTIFY pfnNotify, void * pUser );
extern int	OEMMPMULTI_SetAutoOff		( void * po, boolean bAutoOff );
extern int	OEMMPMULTI_GetUrlInfo		( void * po, AEEMPMultiUrlInfo *pUrlInfo );
extern int	OEMMPMULTI_GetResetFlagStatus	( void * po, uint16 *pwReset );
extern int	OEMMPMULTI_SetResetFlagStatus	( void * po, uint16 wReset );
extern int	OEMMPMULTI_GetFileInfo		( void * po, char *pszFileName, AEEMPMultiFileInfo *pFileInfo );

// MPMULTI OEMReLXg^
typedef struct _OEMMPMulti {
    struct _OEMMPMulti *next;

    IMPMulti        * m_pIMPMulti;
    void            * m_pac;   // app context
    AEEObjectHandle   m_hObject;
    
    PFNMPMULTINOTIFY  m_pfn;
    void           * m_pUser;
} OEMMPMulti;

#endif // _OEMMPMULTI_H_
