#if !defined(OEMPROVISIONITEMS_H)
#define OEMPROVISIONITEMS_H  1
/*======================================================
FILE:  OEMProvisionItems.h

SERVICES:  OEM Provisioning Item ID List

GENERAL DESCRIPTION:

This file contains chip software specific IDs passed to 
OEM_GetConfig and OEM_SetConfig.  These values are translated
to underlying NV_XXX_I values in OEM_Get/SetConfig.

NOTE: These values are critical because NV item offsets may
change between builds.  Virtualization here allows us to 
support dynamically downloaded (or .LIB) files without 
re-compiling.

        Copyright  1999-2002 QUALCOMM Incorporated.
               All Rights Reserved.
            QUALCOMM Proprietary/GTDR
=====================================================*/
#include "OEMConfig.h"

//
// Structure passed to OEMGetConfig.  
//
typedef struct _ProvisionItem
{
   int      nNAM;
   byte *   pDest;
   int      nSize;
} ProvisionItem;

#define CFGI_ROAMING_LIST     (CFGI_PROVISION_FIRST + 1)
#define CFGI_MIN2             (CFGI_PROVISION_FIRST + 2)
#define CFGI_BANNER           (CFGI_PROVISION_FIRST + 3)
#define CFGI_NAME_NAM         (CFGI_PROVISION_FIRST + 4)
#define CFGI_ANALOG_FIRSTCHP  (CFGI_PROVISION_FIRST + 5)
#define CFGI_ANALOG_REG       (CFGI_PROVISION_FIRST + 6)
#define CFGI_ANALOG_HOME_SID  (CFGI_PROVISION_FIRST + 7)
#define CFGI_PCDMACH          (CFGI_PROVISION_FIRST + 8)
#define CFGI_SCDMACH          (CFGI_PROVISION_FIRST + 9)
#define CFGI_SYSTEM_PREF      (CFGI_PROVISION_FIRST + 10)
#define CFGI_PREF_MODE        (CFGI_PROVISION_FIRST + 11)
#define CFGI_HOME_SID_NID     (CFGI_PROVISION_FIRST + 12)
#define CFGI_EVRC             (CFGI_PROVISION_FIRST + 13)
#define CFGI_MIN_CHKSUM       (CFGI_PROVISION_FIRST + 14)

#endif